unit NDamen99;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Grids, ExtCtrls, DBCtrls;

  const Max=20;Leer=0;Dame=1;Gesperrt=2;
  type
   TBrett=Array[1..Max,1..Max]of Integer;
   TNDamen = class(TForm)
    Anzahl: TSpinEdit;
    LabelDamen: TStaticText;
    Start: TButton;
    StellungsAusgabe: TListBox;
    Zeigen: TCheckBox;
    StaticTextN: TStaticText;
    LabelN: TLabel;
    StaticTextTime: TStaticText;
    LabelZeit: TLabel;
    Feldausgabe: TDrawGrid;
    procedure StartClick(Sender: TObject);
    procedure StellungsAusgabeClick(Sender: TObject);
    function TimeSekunden:Extended;
    procedure Ausgabe(Nr:Integer;Brett:TBrett);
    function Erlaubt(Z,S:Integer):Boolean;
    procedure Setz(S:Integer);
    procedure Fuellen(Nr:Integer);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-Deklarationen }
     Brett:TBrett;
     TSek:Extended;
     BrettGroesse,DamenAnzahl,alteNr:Integer;
     DameBild,LeerBild:TBitmap;
  public
    { Public-Deklarationen }
  end;

var NDamen: TNDamen;

implementation

{$R *.DFM}
{$R+,Q+}

 function TNDamen.TimeSekunden:Extended;
  var H, M, S, MS : Word;
  begin
   DecodeTime(Now,H,M,S,MS);
   TimeSekunden:=3600.0*H+60.0*M+S+MS/1000
  end;

 procedure TNDamen.Ausgabe(Nr:Integer;Brett:TBrett);
  var Z,S:Integer;
      Zeile:String;
  begin
   if Zeigen.Checked then
    begin
     Zeile:='';
     StellungsAusgabe.Items.Add(IntToStr(Nr)+'-te Stellung');
     for S:=1 to BrettGroesse do
      for Z:=1 to BrettGroesse do
       if Brett[Z,S]=Dame then
        Zeile:=Zeile+Char(S+64)+IntToStr(BrettGroesse+1-Z)+' ';
     StellungsAusgabe.Items.Add(Zeile);
     StellungsAusgabe.Items.Add('');
    end
  end;

 function TNDamen.Erlaubt(Z,S:Integer):Boolean;
  begin
   Erlaubt:=(Z>0) and (Z<=BrettGroesse) and (S>0) and (S<=BrettGroesse)
  end;

 procedure TNDamen.Setz(S:Integer);
  var Z,K,DiagonalSteigend,DiagonalFallend:Integer;
      F:TBrett;
  begin
   for Z:=BrettGroesse downto 1 do
    if Brett[Z,S]=Leer then
     begin
      F:=Brett; // Brett zwischenspeichern
      // Zeile bis zum Ende sperren
      for K:=S+1 to BrettGroesse do Brett[Z,K]:=Gesperrt;
      // oberhalb der Hauptdiagonalen
      DiagonalSteigend:=Z-1;
      if Z>S then DiagonalFallend:=BrettGroesse-Z
      else DiagonalFallend:=BrettGroesse-S;
      if Z+S=BrettGroesse+1 then // auf der Hauptdiagonalen
       begin
        DiagonalSteigend:=BrettGroesse-S;
        if Z>S then DiagonalFallend:=S-1
        else DiagonalFallend:=Z-1;
       end
      else
       if Z+S>BrettGroesse+1 then // unterhalb der Hauptdiagonalen
        begin
         DiagonalSteigend:=BrettGroesse-S;
         if Z>S then DiagonalFallend:=BrettGroesse-Z
         else DiagonalFallend:=BrettGroesse-S;
        end;
      for K:=1 to DiagonalSteigend do Brett[Z-K,S+K]:=Gesperrt;
      for K:=1 to DiagonalFallend do Brett[Z+K,S+K]:=Gesperrt;
      Brett[Z,S]:=Dame;
      if S<BrettGroesse then Setz(S+1)
      else begin inc(DamenAnzahl);Ausgabe(DamenAnzahl,Brett) end;
      Brett:=F // Zug rckgngig machen
    end
  end;

 procedure TNDamen.Fuellen(Nr:Integer);
  var Z,S:Integer;
      Teil,Zeile:String;
  begin
   FeldAusgabe.Canvas.Brush.Color:=clSilver;
   FeldAusgabe.Canvas.Brush.Style:=bsSolid;
   for S:=1 to BrettGroesse do FeldAusgabe.Canvas.Textout(41*S+12,12,Char(64+S));
   for Z:=1 to BrettGroesse do FeldAusgabe.Canvas.Textout(12,41*(BrettGroesse+1-Z)+12,IntToStr(Z));
   for Z:=1 to BrettGroesse do
    for S:=1 to BrettGroesse do
     FeldAusgabe.Canvas.Draw(41*Z+4,41*S+4,LeerBild);
   Zeile:=StellungsAusgabe.Items[Nr];S:=0;
   While Zeile<>'' do
    begin
     Teil:=Copy(Zeile,1,Pos(' ',Zeile)-1);Inc(S);
     Z:=StrToInt(Copy(Teil,2,Length(Teil)-1));
     FeldAusgabe.Canvas.Draw(41*S+4,41*(BrettGroesse+1-Z)+4,DameBild);
     Delete(Zeile,1,Pos(' ',Zeile));
    end;
  end;

 procedure TNDamen.StartClick(Sender: TObject);
  begin
   alteNr:=0;
   BrettGroesse:=StrToInt(Anzahl.Text);StellungsAusgabe.Clear;
   if BrettGroesse>11 then Zeigen.Checked:=False; // keine Einschrnkung,
   if Not Zeigen.Checked then           // nur krzere Rechenzeit
    begin
     NDamen.Height:=330;
     NDamen.Width:=600;
     StellungsAusgabe.Visible:=False;
     FeldAusgabe.Visible:=False;
     NDamen.Position:=poScreenCenter;
    end
   else
    begin
      NDamen.Height:=330;
      NDamen.Width:=600;
      NDamen.Position:=poScreenCenter;
      StellungsAusgabe.Height:=230;
      StellungsAusgabe.Width:=160;
      FeldAusgabe.Width:=208;
      FeldAusgabe.Height:=208;
      FeldAusgabe.ColCount:=BrettGroesse+1;
      FeldAusgabe.RowCount:=BrettGroesse+1;
     if BrettGroesse>4 then
      begin
       NDamen.Height:=330+40*(BrettGroesse-4);
       NDamen.Width:=600+40*(BrettGroesse-4);
       NDamen.Position:=poScreenCenter;
       StellungsAusgabe.Height:=230;
       StellungsAusgabe.Width:=160;
       FeldAusgabe.Width:=41*(BrettGroesse+1)+3;
       FeldAusgabe.Height:=41*(BrettGroesse+1)+3;
       StellungsAusgabe.Width:=120+(BrettGroesse-4)*30;// breitere Anzeige
       StellungsAusgabe.Height:=NDamen.Height-40-StellungsAusgabe.Top;
      end;
     StellungsAusgabe.Visible:=True;
     FeldAusgabe.Visible:=True;
    end;
   DamenAnzahl:=0;FillChar(Brett,SizeOf(Brett),Leer);
   Screen.Cursor:=crHourGlass;
   TSek:=TimeSekunden;Setz(1);TSek:=TimeSekunden-TSek;
   Screen.Cursor:=crDefault;
   LabelZeit.Caption:=Format('%0.2f',[TSek])+' sek.';
   LabelN.Caption:=IntToStr(DamenAnzahl);
  end;

 procedure TNDamen.StellungsAusgabeClick(Sender: TObject);
  var Nr:Integer;
  begin
   Nr:=StellungsAusgabe.ItemIndex;
   if (Nr+2)mod 3=0 then
    begin
     alteNr:=Nr;
     Fuellen(Nr);
    end;
  end;

 procedure TNDamen.FormResize(Sender: TObject);
  begin
   if alteNr>0 then Fuellen(alteNr)
  end;

 procedure TNDamen.FormCreate(Sender: TObject);
  begin
   DameBild:=TBitmap.Create;
   DameBild.LoadFromFile('Dame Schwarz.Bmp');
   LeerBild:=TBitmap.Create;
   LeerBild.LoadFromFile('Leer.Bmp');
  end;

 procedure TNDamen.FormDestroy(Sender: TObject);
  begin DameBild.Free;LeerBild.Free end;

end.

