unit FunktionsInterpreter;

Interface
type ArtTyp   =(Vorzeichen,Operator,Funktion,Zahl,VarX);
     PTR      =^KnotenTyp;
     KnotenTyp=Record
                case Art:ArtTyp of
                 Vorzeichen:(von:PTR);
                 Operator  :(OP:char;Links,Rechts:PTR);
                 Funktion  :(FN:STRING[6];Next:PTR);
                 Zahl      :(ZA:Extended);
                 VarX      :()
               end;

function FunktionsAnalyse(Term:String):PTR;
function FunktionsBerechnung(FKT:PTR;X:Extended):Extended;

Implementation
uses Plotter;

type OPTyp=Set of Char;

function SucheOperator(OPS:OPTyp;var K:Integer;Term:String):Boolean;
 var Klammer:Integer;Gefunden:Boolean;
 begin
  Gefunden:=False;Klammer:=0;K:=Length(Term)+1;
  repeat
   dec(K);
   case Term[K] of
    '(':dec(Klammer);
    ')':inc(Klammer);
   else
    if (Klammer=0) and (Term[K] in OPS) and (K>1) and
       (not(Term[K-1] in['E','^'])) then Gefunden:=True
   end
  until Gefunden or (K=1);
  SucheOperator:=Gefunden
 end;
function SuchePlusMinus(var K:Integer;Term:String):Boolean;
 begin SuchePlusMinus:=SucheOperator(['+','-'],K,Term) end;
function SucheMalDurch(var K:Integer;Term:String):Boolean;
 begin SucheMalDurch:=SucheOperator(['*','/'],K,Term) end;
function SucheVorzeichen(Term:String):Boolean;
 begin SucheVorzeichen:=(Term[1] in ['+','-']) end;
function SuchePotenz(var K:Integer;Term:String):Boolean;
 begin SuchePotenz:=SucheOperator(['^'],K,Term) end;
function SucheFunktion(var K:Integer;Term:String):Boolean;
 var F:String;
 begin
  SucheFunktion:=False;K:=pos('(',Term);
  if K>0 then
   begin
    F:=copy(Term,1,K-1);
    if ( (F='ABS') or (F='ARCTAN') or (F='ARCSIN')or (F='COS') or (F='EXP') or
         (F='FRAC') or (F='INT') or (F='LN') or (F='SIN') or
         (F='SQR') or (F='SQRT') or (F='TAN') or (F='') )
         and (Term[Length(Term)]=')') then SucheFunktion:=True
   end
 end;
function SucheZahl(var Wert:Extended;Term:String):Boolean;
 var Code:Integer;
 begin val(Term,Wert,Code);SucheZahl:=(Code=0) end;
function SucheX(Term:String):Boolean;
 begin SucheX:=(Term='X') end;

function FunktionsAnalyse;
 var TermOk:Boolean;FKT:PTR;

 function UpDate(Term:String):String;
  var i:Integer;
  begin
   for i:=1 to Length(Term) do
    Term[i]:=UpCase(Term[i]);
   while pos(' ',Term)>0 do
    delete(Term,pos(' ',Term),1);
   UpDate:=Term;
  end;

  procedure BaueBaum(var Knoten:PTR;Term:String);
   var Wert:Extended;K:Integer;VZ:CHAR;
   begin
    if TermOk and (Length(Term)>0) then
     if SuchePlusMinus(K,Term) then
      begin
       new(Knoten);
       Knoten^.Art:=Operator;Knoten^.OP:=Term[K];
       BaueBaum(Knoten^.Links,copy(Term,1,K-1));
       BaueBaum(Knoten^.Rechts,copy(Term,K+1,Length(Term)-K))
      end
     else if SucheMalDurch(K,Term) then
           begin
            new(Knoten);
            Knoten^.Art:=Operator;Knoten^.OP:=Term[K];
            BaueBaum(Knoten^.Links,copy(Term,1,K-1));
            BaueBaum(Knoten^.Rechts,copy(Term,K+1,Length(Term)-K))
           end
          else if SucheVorzeichen(Term) then
           begin
            VZ:=Term[1];delete(Term,1,1);
            case VZ of
             '+':BaueBaum(Knoten,Term);
             '-':begin
                  new(Knoten);Knoten^.Art:=Vorzeichen;
                  BaueBaum(Knoten^.VON,Term)
                 end
            end
           end
               else if SuchePotenz(K,Term) then
                     begin
                      new(Knoten);
                      Knoten^.Art:=Operator;Knoten^.OP:=Term[K];
                      BaueBaum(Knoten^.Links,copy(Term,1,K-1));
                      BaueBaum(Knoten^.Rechts,copy(Term,K+1,Length(Term)-K))
                     end
                    else if SucheFunktion(K,Term) then
                          begin
                           new(Knoten);
                           Knoten^.Art:=Funktion;Knoten^.FN:=copy(Term,1,K-1);
                           BaueBaum(Knoten^.Next,copy(Term,K+1,Length(Term)-1-K))
                          end
                         else if SucheZahl(Wert,Term) then
                               begin
                                new(Knoten);
                                Knoten^.Art:=Zahl;Knoten^.ZA:=Wert
                               end
                              else if SucheX(Term) then
                                    begin
                                     new(Knoten);
                                     Knoten^.Art:=VarX
                                    end
                                   else TermOk:=False
    else TermOk:=False
   end;

 begin // of FunktionsAnalyse
  TermOk:=True;Term:=UpDate(Term);BaueBaum(FKT,Term);
  if not TermOk then FunktionsAnalyse:=nil else FunktionsAnalyse:=FKT
 end;

 function FunktionsBerechnung;
  var WertOk:Boolean;

  function Wert(Zeiger:PTR):Extended;
   var Exponent,I,P,Test:Extended;
   begin
    Wert:=Funktionsgraph.MaxReal;
    if WertOk then
     with Zeiger^ do
      case Art of
       Vorzeichen: Wert:=-Wert(VON);
       Operator:case OP of
                 '+':Wert:=Wert(Links)+Wert(Rechts);
                 '-':Wert:=Wert(Links)-Wert(Rechts);
                 '*':Wert:=Wert(Links)*Wert(Rechts);
                 '/':begin
                      Test:=Wert(Rechts);
                      if WertOk and (Test<>0.0) and (ABS(Test)>Funktionsgraph.MinReal) then
                       Wert:=Wert(Links)/Test
                      else WertOk:=False
                     end;
                 '^':begin
                      Test:=Wert(Links);
                      if Test=0 then Wert:=0 else
                      if Wert(Rechts)*LN(ABS(Test))<3000.0*LN(10) then
                       begin
                        if Test>Funktionsgraph.MinReal then Wert:=EXP(Wert(Rechts)*LN(Test))
                        else begin
                              I:=1;P:=1;Exponent:=Wert(Rechts);
                              WHILE I<=ABS(Exponent) do
                               begin P:=P*Test;I:=I+1 end;
                              if Exponent<0 then Wert:=1/P else Wert:=P
                             end
                       end
                      else WertOk:=False
                     end
                end;
       Funktion:begin
                 if FN=''       then Wert:=Wert(Next);
                 if FN='ABS'    then Wert:=Abs(Wert(Next));
                 if FN='ARCSIN' then begin
                                      if Abs(Wert(Next))>=1 then WertOk:=False
                                      else Wert:=ArcTan(Wert(Next)/Sqrt(1-Sqr(Wert(Next))));
                                     end;
                 if FN='ARCTAN' then Wert:=ArcTan(Wert(Next));
                 if FN='COS'    then Wert:=Cos(Wert(Next));
                 if FN='EXP'    then Wert:=Exp(Wert(Next));
                 if FN='FRAC'   then Wert:=Frac(Wert(Next));
                 if FN='INT'    then Wert:=Int(Wert(Next));
                 if FN='LN'     then begin
                                      Test:=Wert(Next);
                                      if Test>0 then Wert:=LN(Test)
                                      else WertOk:=False
                                     end;
                 if FN='SIN'    then Wert:=Sin(Wert(Next));
                 if FN='SQR'    then Wert:=Sqr(Wert(Next));
                 if FN='SQRT'   then begin
                                      Test:=Wert(Next);
                                      if Test>=0.0 then Wert:=Sqrt(Test)
                                      else WertOk:=False
                                     end;
                 if FN='TAN'    then Wert:=Sin(Wert(Next))/Cos(Wert(Next))
                end;
        Zahl:Wert:=ZA;
        VarX:Wert:=X
      end
  end;

 begin // of FunktionsBerechnung
  if FKT<>nil then
   begin
    WertOk:=True;FunktionsBerechnung:=Wert(FKT);
    if not WertOk then FunktionsBerechnung:=Funktionsgraph.MaxReal
   end
  else FunktionsBerechnung:=Funktionsgraph.MaxReal
 end;

end.

