unit Plotter;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, Spin, ExtCtrls,
  FunktionsInterpreter, Eingabe;

type
  TFunktionsgraph = class(TForm)
    Zeichnekopf: TButton;
    yMaxWert: TSpinEdit;
    yMinWert: TSpinEdit;
    xMaxWert: TSpinEdit;
    xMinWert: TSpinEdit;
    xMinText: TStaticText;
    xMaxText: TStaticText;
    yMinText: TStaticText;
    yMaxText: TStaticText;
    SchrittText: TStaticText;
    SchrittWeite: TEdit;
    Blatt: TImage;
    Fx1: TCheckBox;
    Fx2: TCheckBox;
    Fx0: TCheckBox;
    xHL: TCheckBox;
    yHL: TCheckBox;
    FunktionsGleichung: TEdit;
    StaticTextFkt: TStaticText;
    FktText: TStaticText;
    FunktionsEingabe: TButton;
    procedure ZeichnekopfClick(Sender: TObject);
    procedure SchrittWeiteKeyPress(Sender: TObject; var Key: Char);
    procedure FunktionsEingabeClick(Sender: TObject);
    function f(x:Extended):Extended;
    function f1(x:Extended):Extended;
    function f2(x:Extended):Extended;
    function fx(x:Extended):Integer;
    function fy(y:Extended):Integer;
    procedure init;
    procedure Achsenzeichnen;
    procedure KurveZeichnen;
    procedure Fx0Zeichnen;
    procedure Fx1Zeichnen;
    procedure Fx2Zeichnen;
    procedure FormCreate(Sender: TObject);
    procedure Fx0Click(Sender: TObject);
    procedure FunktionsGleichungKeyPress(Sender: TObject; var Key: Char);
  private
    { Private-Deklarationen }
    xMin, xMax, yMin, yMax:Integer; // Definitions- und Wertebereich
    sw:Extended;                    // Mastabsfaktoren
    xsMax, ysMax:Integer;           // Mae des Formulars
    Funktion:Ptr;
  public
    { Public-Deklarationen }
   MaxReal,MinReal:Extended;
  end;

var
  Funktionsgraph: TFunktionsgraph;

implementation
{$R *.DFM}
{R+,Q+}

 const h:extended=0.00001;

 function TFunktionsgraph.f(x:Extended):Extended;
  begin f:=Funktionsberechnung(Funktion,x) end;

 function TFunktionsgraph.f1(x:Extended):Extended;
  begin f1:=(f(x+h)-f(x))/h end;

 function TFunktionsgraph.f2(x:Extended):Extended;
  begin f2:=(f1(x+h)-f1(x))/h end;

 function TFunktionsgraph.fx(x:Extended):Integer; // x-Achse
  begin fx:=round((x-xMin)/(xMax-xMin)*xsMax) end;

 function TFunktionsgraph.fy(y:Extended):Integer; // y-Achse
  begin fy:=round((yMax-y)/(yMax-yMin)*ysMax) end;

 procedure TFunktionsgraph.init;
  begin
   xMin:=StrToInt(xMinWert.Text);
   xMax:=StrToInt(xMaxWert.Text);
   yMin:=StrToInt(yMinWert.Text);
   yMax:=StrToInt(yMaxWert.Text);
   xsMax:=Blatt.Width;
   ysMax:=Blatt.Height;
   if Schrittweite.Text='' then Schrittweite.Text:='0,1';
   sw:=StrToFloat(Schrittweite.Text);
  end;

 procedure TFunktionsgraph.Achsenzeichnen;
  var Rect:TRect;
      x,y,Strich,sl:Integer;
  begin
   Strich:=10;sl:=Strich div 2;
   with Blatt.Canvas do
    begin
     Brush.Color:=clSilver;
     Rect.Left:=0;Rect.Top:=0;Rect.Right:=Width;Rect.Bottom:=Height;
     FillRect(Rect);// Formular lschen
     Pen.Color:=clBlack;
     Pen.Style:=psSolid;
     moveto(fx(xMin),fy(0));lineto(fx(xMax),fy(0)); // waagerechte Achse
     moveto(fx(0),fy(yMin));lineto(fx(0),fy(yMax)); // senkrechte Achse
     for x:=xMin to xMax do
      begin
       moveto(fx(x),fy(0)-sl);
       lineto(fx(x),fy(0)+sl);
       TextOut(fx(x)-2,fy(0)+sl+2,IntToStr(x));
      end;
     for y:=yMin to yMax do
      if y<>0 then
       begin
        moveto(fx(0)-sl,fy(y));
        lineto(fx(0)+sl,fy(y));
        TextOut(fx(0)+sl+2,fy(y)-5,IntToStr(y));
       end;
     TextOut(fx(-0.5),fy(yMax),'Y');
     TextOut(fx(xMax-0.5),fy(1),'X');
    if xHL.Checked then
     begin
      Pen.Color:=clBlack;
      Pen.Style:=psDot;
      for y:=yMin to yMax do
       if y<>0 then
        begin
         moveto(fx(xMin),fy(y));
         lineto(fx(xMax),fy(y));
        end;
     end;
    if yHL.Checked then
     begin
      Pen.Color:=clBlack;
      Pen.Style:=psDot;
      for x:=xMin to xMax do
       if x<>0 then
        begin
         moveto(fx(x),fy(yMin));
         lineto(fx(x),fy(yMax));
        end;
     end;
    end;
  end;

 procedure TFunktionsgraph.Fx0Zeichnen;
  var x,y: Extended;
  begin
   with Blatt.Canvas do
    begin
     Pen.Color:=clGreen;
     x:=xMin;y:=f(x);
     if (y<yMin) or (y>yMax) then
      repeat x:=x+sw;y:=f(x) until ((y>=yMin) and (y<=yMax)) or (x>=xMax);
     if y<MaxReal then moveto(fx(x),fy(y));
     repeat
      x:=x+sw;y:=f(x);
      if (y<yMin) or (y>yMax) then
       begin
        repeat x:=x+sw;y:=f(x) until ((y>=yMin) and (y<=yMax)) or (x>=xMax);
        if y<MaxReal then moveto(fx(x),fy(y));
       end;
      if y<MaxReal then lineto(fx(x),fy(y));
     until x>=xMax;
    end;
  end;

 procedure TFunktionsgraph.Fx1Zeichnen;
  var x,y: Extended;
  begin
   with Blatt.Canvas do
    begin
     Pen.Color:=clBlue;
     x:=xMin;y:=f1(x);
     if (y<yMin) or (y>yMax) then
      repeat x:=x+sw;y:=f1(x) until ((y>=yMin) and (y<=yMax)) or (x>=xMax);
     if y<MaxReal then moveto(fx(x),fy(y));
     repeat
      x:=x+sw;y:=f1(x);
      if (y<yMin) or (y>yMax) then
       begin
        repeat x:=x+sw;y:=f1(x) until ((y>=yMin) and (y<=yMax)) or (x>=xMax);
        if y<MaxReal then moveto(fx(x),fy(y));
       end;
      if y<MaxReal then lineto(fx(x),fy(y));
     until x>=xMax;
    end;
  end;

 procedure TFunktionsgraph.Fx2Zeichnen;
  var x,y: Extended;
  begin
   with Blatt.Canvas do
    begin
     Pen.Color:=clRed;
     x:=xMin;y:=f2(x);
     if (y<yMin) or (y>yMax) then
      repeat x:=x+sw;y:=f2(x) until ((y>=yMin) and (y<=yMax)) or (x>=xMax);
     if y<MaxReal then moveto(fx(x),fy(y));
     repeat
      x:=x+sw;y:=f2(x);
      if (y<yMin) or (y>yMax) then
       begin
        repeat x:=x+sw;y:=f1(x) until ((y>=yMin) and (y<=yMax)) or (x>=xMax);
        if y<MaxReal then moveto(fx(x),fy(y));
       end;
      if y<MaxReal then lineto(fx(x),fy(y));
     until x>=xMax;
    end;
  end;

 procedure TFunktionsgraph.KurveZeichnen;
  begin
   with Blatt.Canvas do
    begin
     Pen.Style:=psSolid;
     if Fx0.Checked then Fx0Zeichnen;
     if Fx1.Checked then Fx1Zeichnen;
     if Fx2.Checked then Fx2Zeichnen;
    end;
  end;

 procedure TFunktionsgraph.ZeichnekopfClick(Sender: TObject);
  begin
   Init;
   Funktion:=Funktionsanalyse(FunktionsGleichung.Text);
   if Funktion=Nil then
    begin
     Application.MessageBox('Deine Funktionsgleichung enthlt einen Fehler!','Eingabefehler',48);
     exit
    end;
   Caption:='Funktionsgraph (c) by Meister Fiete';
   Achsenzeichnen;
   KurveZeichnen;
  end;

 procedure TFunktionsgraph.SchrittWeiteKeyPress(Sender: TObject;var Key: Char);
  begin
   if Key='.' then Key:=',';
  end;

 procedure TFunktionsgraph.FunktionsEingabeClick(Sender: TObject);
  begin
   FormelEditor.ShowModal;
  end;

 procedure TFunktionsgraph.FormCreate(Sender: TObject);
  begin
   MaxReal:=1E+3000;
   MinReal:=1E-3000;
  end;

 procedure TFunktionsgraph.Fx0Click(Sender: TObject);
  begin
   ZeichnekopfClick(Sender);
  end;

 procedure TFunktionsgraph.FunktionsGleichungKeyPress(Sender:TObject;var Key:Char);
  begin
   if Key=#13 then ZeichnekopfClick(Sender);
  end;

end.

