unit WortGenerator;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus;

type
  TWortschatzgenerator = class(TForm)
    Wortschatz: TMemo;
    LabelD: TLabel;
    DateiLesen: TOpenDialog;
    DateiSpeichern: TSaveDialog;
    Liste: TListBox;
    MainMenu: TMainMenu;
    Datei: TMenuItem;
    Neu: TMenuItem;
    Laden: TMenuItem;
    Speichern: TMenuItem;
    N1: TMenuItem;
    Beenden: TMenuItem;
    procedure LadenClick(Sender: TObject);
    procedure SpeichernClick(Sender: TObject);
    procedure LoeschenClick(Sender: TObject);
    procedure BeendenClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
   Anzahl:Integer; 
  public
    { Public-Deklarationen }
  end;

var Wortschatzgenerator: TWortschatzgenerator;

implementation

{$R *.DFM}

 procedure TWortschatzgenerator.LadenClick(Sender: TObject);
  begin
   with DateiLesen do
    begin
     Filter:='Wortdateien (*.hgm) |*.hgm';
     DefaultExt:='hgm';
     if Execute then
      begin
       Wortschatz.Lines.LoadFromFile(Filename);
       LabelD.Caption:=ExtractFilename(FileName)+' '+
                       IntToStr(Wortschatz.Lines.Count)+' Begriffe';
       Anzahl:=Wortschatz.Lines.Count;
      end
    end
  end;

 procedure TWortschatzgenerator.SpeichernClick(Sender: TObject);
  var K:Word;
      DateiName:String;
  begin
   if Wortschatz.Lines.Count=0 then
    begin
     MessageDlg('Es gibt NICHTS zu speichern!!',mtError,[mbOk],0);
     exit;
    end;
   for K:=0 to Wortschatz.Lines.Count-1 do
    Wortschatz.Lines[K]:=AnsiUpperCase(Wortschatz.Lines[K]);
   Liste.Items:=Wortschatz.Lines; // in der ListBox wird sortiert
   Wortschatz.Lines:=Liste.Items;
   with DateiSpeichern do
    begin
     Filter:='Wortdateien (*.hgm) |*.hgm';
     DefaultExt:='hgm';
     Options:=[ofOverwritePrompt];
     if Execute then
      begin
       Wortschatz.Lines.SaveToFile(Filename);
       DateiName:=ExtractFileName(Filename);
       Anzahl:=Wortschatz.Lines.Count;
       LabelD.Caption:=DateiName+' '+IntToStr(Wortschatz.Lines.Count)+' Begriffe';
      end
    end;
  end;

 procedure TWortschatzgenerator.LoeschenClick(Sender: TObject);
  begin
   if Anzahl<>Wortschatz.Lines.Count then
    MessageDlg('Deine Daten sind nicht gespeichert!',mtWarning,[mbYes],0);
   if MessageDlg('Willst du wirklich alles lschen?!',mtConfirmation,
                 [mbYes,mbNo],0)=mrNo then exit;
   Wortschatz.Clear;Anzahl:=0;
   LabelD.Caption:='Noname.hgm';
  end;

 procedure TWortschatzgenerator.BeendenClick(Sender: TObject);
  begin close end;

 procedure TWortschatzgenerator.FormCloseQuery(Sender: TObject;
                                var CanClose: Boolean);
  begin
   if Anzahl<>Wortschatz.Lines.Count then
    MessageDlg('Deine Daten sind nicht gespeichert!',mtWarning,[mbYes],0);
   CanClose:=MessageDlg('Willst du wirklich beeenden?!',mtConfirmation,
                 [mbYes,mbNo],0)=mrYes
  end;

 procedure TWortschatzgenerator.FormCreate(Sender: TObject);
  begin Anzahl:=0 end;

end.


 
