unit LangWurzel;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, LangZahlRechnen;

type
  TLW = class(TForm)
    EditR: TLabeledEdit;
    EditNK: TLabeledEdit;
    Ausgabe: TMemo;
    Start: TButton;
    LabelZeit: TLabel;
    LabelSek: TLabel;
    procedure EditKeyPress(Sender: TObject; var Key: Char);
    procedure StartClick(Sender: TObject);
    function TimeSekunden:Extended;
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  LW: TLW;

implementation

{$R *.dfm}
{$R+,Q+}

 function TLW.TimeSekunden:Extended;
  var H, M, S, MS : Word;
  begin
   DecodeTime(Now,H,M,S,MS);
   TimeSekunden:=3600.0*H+60.0*M+1.0*S+MS/1000
  end;

 procedure TLW.EditKeyPress(Sender: TObject; var Key: Char);
  begin
   if not(Key in['0'..'9',#8]) then Key:=#0;
  end;

 procedure TLW.StartClick(Sender: TObject);
  var Radikand,Hundert,Zehn,Eins,Wurzel,WurzelQuadrat,Quadrat:TFeld;
      K,Anzahl,Ziffer,Komma:LongWord;
      Ergebnis:String;
      Zeit:Extended;
  begin
   Ausgabe.Clear;
   LangRead(EditR.Text,Radikand);
   Anzahl:=StrToInt(EditNK.Text);
   LangInt(Hundert,100);LangInt(Zehn,10);LangInt(Eins,1);
   LangSqrt(Wurzel,Radikand);LangIntToStr(Wurzel,Ergebnis);
   Ergebnis:=Ergebnis+',';
   Komma:=Length(EditR.Text)+1;
   Screen.Cursor:=crHourGlass;
   Zeit:=TimeSekunden;
   for K:=1 to Anzahl do
    begin
     LangMul(Wurzel,Wurzel,Zehn);
     LangMul(WurzelQuadrat,Wurzel,Wurzel);
     LangMul(Radikand,Radikand,Hundert);
     Ziffer:=0;
     while LangKleiner(WurzelQuadrat,Radikand) do
      begin
       inc(Ziffer);
       LangAdd(Wurzel,Wurzel,Eins);
       LangMul(WurzelQuadrat,Wurzel,Wurzel);
      end;
     if Ziffer>0 then
      begin
       dec(Ziffer);
       LangSub(Wurzel,Wurzel,Eins);
      end;
     Ergebnis:=Ergebnis+IntToStr(Ziffer);
    end;
   Zeit:=TimeSekunden-Zeit;
   LabelSek.Caption:=Format('%0.2f',[Zeit])+' sek.'; 
   Screen.Cursor:=crDefault;
   Ausgabe.Lines.Add('Wurzel=');
   Ausgabe.Lines.Add(Ergebnis);
   LangMul(Quadrat,Wurzel,Wurzel);
   Ausgabe.Lines.Add('Kontrolle=');
   LangIntToStr(Quadrat,Ergebnis);
   Insert(',',Ergebnis,Komma);
   Ausgabe.Lines.Add(Ergebnis);
  end;

end.
