unit LangZahlRechnen;
interface
 uses StdCtrls, SysUtils;

 const T=1000000000;BL=9;
 type TFeld=Array of Extended;

 // IntegerVariable B umwandeln in ein Array vom Typ TFeld
 procedure LangInt(var A:TFeld;B:Integer);
 function LangKleiner(A,B:TFeld):Boolean; // A<B ?
 function LangGleich(A,B:TFeld):Boolean;  // A=B ?
 procedure LangRead(Zahl:String;var Z:TFeld); // Zahl eingeben
 procedure LangIntToStr(Zahl:TFeld;var Erg:String); // Liste --> String wandeln
 procedure LangAdd(var S:TFeld;A,B:TFeld);  // A+B
 procedure LangSub(var D:TFeld;A,B:TFeld);  // A-B
 procedure LangMul(var E:TFeld;A,B:TFeld);  // A*B
 procedure LangDivision(var E,R:TFeld;A,B:TFeld);
 procedure LangAusgabe(LBox:TMemo;S:TFeld); // Ergebnis ausgeben
 procedure LangSqrt(var XA:TFeld;A:TFeld); // W=sqrt(A)

 implementation

 procedure LangInt(var A:TFeld;B:Integer);
 // IntegerVariable B umwandeln in ein Array vom Typ TFeld
  begin
   SetLength(A,1);
   repeat
    SetLength(A,Length(A)+1);
    A[Length(A)-1]:=B mod T;
    B:=B div T
   until B=0
  end;

 function LangKleiner(A,B:TFeld):Boolean; // A<B ?
  var LA,LB,K:LongWord;
  begin
   LangKleiner:=True;
   LA:=Length(A);
   LB:=Length(B);
   if LA<LB then LangKleiner:=True;
   if LA>LB then LangKleiner:=False;
   if LA=LB then
    begin
     K:=LA-1;LangKleiner:=False;
     while (A[K]=B[K]) and (K>1) do dec(K);
     if A[K]<B[K] then LangKleiner:=True
    end
  end;

 function LangGleich(A,B:TFeld):Boolean;  // A=B ?
  var LA,LB,K:LongWord;
  begin
   LA:=Length(A);
   LB:=Length(B);
   if LA<>LB then LangGleich:=False
   else
    begin
     K:=LA-1;LangGleich:=True;
     while (A[K]=B[K]) and (K>1) do dec(K);
     if A[K]<>B[K] then LangGleich:=False
    end
  end;

 procedure LangRead(Zahl:String;var Z:TFeld); // Zahl eingeben
  var LZ,K,ZP,L,Wert:Integer;
  begin
   SetLength(Z,1);Z[0]:=0;
   LZ:=Length(Zahl);
   for K:=1 to LZ div BL do
    begin
     SetLength(Z,Length(Z)+1);
     Z[Length(Z)-1]:=0;ZP:=1;
     for L:=1 to BL do
      begin
       Wert:=StrToInt(Zahl[LZ+BL+1-L-BL*K]);
       Z[Length(Z)-1]:=Z[Length(Z)-1]+ZP*Wert;
       ZP:=10*ZP;
      end
    end;
   if LZ mod BL>0 then
    begin
     SetLength(Z,Length(Z)+1);
     Z[Length(Z)-1]:=0;ZP:=1;
     for L:=1 to LZ mod BL do
      begin
       Wert:=StrToInt(Zahl[LZ+BL+1-L-BL*(1+LZ div BL)]);
       Z[Length(Z)-1]:=Z[Length(Z)-1]+ZP*Wert;
       ZP:=10*ZP;
      end
    end;
  end;

 procedure LangIntToStr(Zahl:TFeld;var Erg:String);
  const Nullen='00000000000000000000';
  var ZahlStr:String;
      K:Integer;
  begin
   Erg:=Format('%0.0f',[Zahl[Length(Zahl)-1]]);
   for K:=Length(Zahl)-2 downto 1 do
    begin
     Str(Zahl[K]:0:0,ZahlStr);
     ZahlStr:=copy(Nullen+ZahlStr,Length(Nullen+ZahlStr)-BL+1,BL);
     Erg:=Erg+Format('%9s',[ZahlStr]);
    end;
  end;

 procedure LangAusgabe(LBox:TMemo;S:TFeld); // Ergebnis ausgeben
  const Null='00000000000000000000';
  var K:LongWord;
      ZahlStr:String;
  begin
   LBox.Lines.Add(Format('%10.0f',[S[Length(S)-1]]));
   for K:=Length(S)-2 downto 1 do
    begin
     Str(S[K]:0:0,ZahlStr);
     ZahlStr:=copy(Null+ZahlStr,Length(Null+ZahlStr)-BL+1,BL);
     ZahlStr:=Format('%10s',[ZahlStr]);
     LBox.Lines.Add(ZahlStr);
    end
  end;

 procedure LangAdd(var S:TFeld;A,B:TFeld);  // A+B
  var LA,LB,K,Grenze:LongWord; H,UE:Extended;
  begin
   LA:=Length(A);
   LB:=Length(B);
   if LA>LB then
    begin
     Grenze:=LA-1;
     SetLength(B,LA);
     for K:=LB+1 to Grenze  do B[K]:=0;
    end
   else
    begin
     Grenze:=LB-1;
     SetLength(A,LB);
     for K:=LA+1 to Grenze  do A[K]:=0;
    end;
   UE:=0;
   SetLength(S,Grenze+1);
   for K:=1 to Grenze do
    begin
     H:=A[K]+B[K]+UE;
     if H>=T then begin H:=H-T;UE:=1 end else UE:=0;
     S[K]:=H
    end;
   if UE>0 then
    begin
     SetLength(S,Length(S)+1);
     S[Length(S)-1]:=UE
    end
  end;

 procedure LangSub(var D:TFeld;A,B:TFeld);  // A-B
  var LA,LB,K:LongWord; H,UE:Extended;
  begin
   LA:=Length(A);
   LB:=Length(B);
   if LangKleiner(A,B) then exit;
   SetLength(B,LA);
   SetLength(D,LA);
   dec(LA);
   UE:=0;for K:=LB to LA  do B[K]:=0;
   for K:=1 to LA do
    begin
     H:=A[K];H:=H-B[K]-UE;
     if H<0 then begin H:=H+T;UE:=1 end else UE:=0;
     D[K]:=H
    end;
   while (D[LA]=0) and (LA>1) do dec(LA);
   SetLength(D,LA+1);
  end;

 procedure LangMul(var E:TFeld;A,B:TFeld);  // A*B
  var AltLE,LA,LB,LE,K,I,J:LongWord; H,UE:Extended;
  begin
   LA:=Length(A);
   LB:=Length(B);
   LE:=LA+LB-1;
   AltLE:=LE;
   SetLength(E,LE);
   for K:=1 to LE-1 do E[K]:=0;
   for I:=1 to LB-1 do
    begin
     UE:=0;
     for J:=1 to LA-1 do
      begin
       H:=A[J]*B[I]+E[I+J-1]+UE;
       UE:=INT(H/T);E[I+J-1]:=H-UE*T;
      end;
     E[LA-1+I]:=UE
    end;
   while (E[AltLE-1]=0) and (AltLE>1) do dec(AltLE);
   SetLength(E,AltLE);
  end;

 procedure LangDivision(var E,R:TFeld;A,B:TFeld);
  var U,V,Q,S:TFeld;
      UE,P,QU,DIFF:Extended;
      LE,LR,LA,LB,K,M,N,J,I:LongWord;
  begin
   SetLength(A,Length(A)+1);
   A[Length(A)-1]:=0;
   SetLength(B,Length(B)+1);
   B[Length(B)-1]:=0;
   LA:=Length(A);
   LB:=Length(B);
   M:=LA-2;N:=LB-2;
   if LangKleiner(A,B) then
    begin R:=A;LangInt(E,0);exit end;
   SetLength(U,LA);for K:=0 to La-1 do U[K]:=0;
   SetLength(V,LB);
   SetLength(S,LB);
   SetLength(Q,M-N+1);
   for I:=1 to M do U[I]:=A[M-I+1];
   for I:=1 to N do V[I]:=B[N-I+1];
   if N=1 then V[2]:=0;
   for J:=0 to M-N do
    begin
     if U[J]=V[1] then QU:=T-1 else QU:=INT((U[J]*T+U[J+1])/V[1]);
     DIFF:=(U[J]*T+U[J+1]-QU*V[1])*T+U[J+2];
     if V[2]*QU>DIFF then QU:=INT((U[J]*T*T+U[J+1]*T+U[J+2])/(V[2]+V[1]*T));
     UE:=0;
     for I:=N downto 1 do
      begin P:=V[I]*QU+UE;UE:=INT(P/T);S[I]:=P-UE*T end;
     S[0]:=UE;UE:=0;
     for I:=J+N downto J do
      begin
       P:=U[I]-S[I-J]-UE;
       if P<0 then begin U[I]:=P+T;UE:=1 end else begin U[I]:=P;UE:=0 end
      end;
     Q[J]:=QU;
     if UE=1 then
      begin
       Q[J]:=Q[J]-1;UE:=0;
       for I:=J+N downto J do
        begin P:=U[I]+V[I-J]+UE;UE:=INT(P/T);U[I]:=P-UE*T end;
       if J>0 then U[J-1]:=U[J-1]+UE
      end
    end;
   I:=0;while (Q[I]=0) and (I<M-N) do inc(I);
   LE:=M-N-I+1;SetLength(E,LE+1);
   for K:=1 to LE do E[K]:=Q[M-N-K+1];
   I:=M-N+1;while (U[I]=0) and (I<M) do inc(I);
   LR:=M-I+1;SetLength(R,LR+1);
   for K:=1 to LR do R[K]:=U[M-K+1]
  end;

 procedure LangSqrt(var XA:TFeld;A:TFeld); // W=sqrt(A)
  var XN,Zwei,R,Diff:TFeld;
      Fertig:Boolean;
  begin
   LangInt(Zwei,2);LangDivision(XA,R,A,Zwei);
   Fertig:=False;
   repeat
    LangDivision(XN,R,A,XA);       // XN:=A div XA
    LangAdd(XN,XN,XA);             // XN:=XN+XA
    LangDivision(XN,R,XN,Zwei);    // XN:=XN div 2
    if LangKleiner(XN,XA) then LangSub(Diff,XA,XN)
    else LangSub(Diff,XN,XA);
    if LangKleiner(Diff,Zwei) then Fertig:=True;
    XA:=XN;
   until Fertig;
  end;

 end.

