UNIT LangZahlRechnen;
INTERFACE
 uses StdCtrls, SysUtils;

 CONST MAX=4000;T=1000000000;EXPONENT=9;
 TYPE TFeld=ARRAY[0..MAX] OF EXTENDED;

 PROCEDURE LANGINT(VAR A:TFeld;VAR LA:WORD;B:Integer);
 { * LONGINTEGERVARIABLE B UMWANDELN IN EIN ARRAY VOM TYP TFeld *}
 FUNCTION LANGKLEINER(A,B:TFeld;LA,LB:WORD):BOOLEAN;{ * A<B ? * }
 FUNCTION LANGGLEICH(A,B:TFeld;LA,LB:WORD):BOOLEAN;{ * A=B ? * }
 PROCEDURE LANGREAD(Zahl:String;VAR Z:TFeld;VAR LZ:WORD);{ * ZAHL EINGEBEN *}
 PROCEDURE LANGADD(VAR S:TFeld;VAR LS:WORD;A,B:TFeld;LA,LB:WORD;
                   Var Fehler:Boolean;Var FehlerText:String);{ * A+B *}
 PROCEDURE LANGSUB(VAR D:TFeld;VAR LD:WORD;A,B:TFeld;LA,LB:WORD;
                   Var Fehler:Boolean;Var FehlerText:String);{ * A-B *}
 PROCEDURE LANGMUL(VAR E:TFeld;VAR LE:WORD;B,P:TFeld;LB,LP:WORD);
 PROCEDURE LANGDIVISION(VAR E,R:TFeld;VAR LE,LR:WORD;A,B:TFeld;LA,LB:WORD);
 PROCEDURE LANGAUSGABE(LBox:TListBox;S:TFeld;LS:WORD);{* ERGEBNIS AUSGEBEN *}
 PROCEDURE LANGWURZEL(VAR W:TFeld;VAR LW:WORD;A:TFeld;LA:WORD); { * W=A * }

 IMPLEMENTATION

 PROCEDURE LANGINT(VAR A:TFeld;VAR LA:WORD;B:Integer);
 { * LONGINTEGERVARIABLE B UMWANDELN IN EIN ARRAY VOM TYP TFeld *}
  BEGIN
   FILLCHAR(A,SIZEOF(A),0);LA:=0;
   REPEAT INC(LA);A[LA]:=B MOD T;B:=B DIV T UNTIL B=0
  END;

 FUNCTION LANGKLEINER(A,B:TFeld;LA,LB:WORD):BOOLEAN;{ * A<B ? * }
  VAR K:WORD;
  BEGIN
   LANGKLEINER:=TRUE;
   IF LA<LB THEN LANGKLEINER:=TRUE;
   IF LA>LB THEN LANGKLEINER:=FALSE;
   IF LA=LB THEN
    BEGIN
     K:=LA;LANGKLEINER:=FALSE;
     WHILE (A[K]=B[K]) AND (K>1) DO DEC(K);
     IF A[K]<B[K] THEN LANGKLEINER:=TRUE
    END
  END;

 FUNCTION LANGGLEICH(A,B:TFeld;LA,LB:WORD):BOOLEAN;{ * A=B ? * }
  VAR K:WORD;
  BEGIN
   IF LA<>LB THEN LANGGLEICH:=FALSE
   ELSE
    BEGIN
     K:=LA;LANGGLEICH:=TRUE;
     WHILE (A[K]=B[K]) AND (K>1) DO DEC(K);
     IF A[K]<>B[K] THEN LANGGLEICH:=FALSE
    END
  END;

 PROCEDURE LANGREAD(Zahl:String;VAR Z:TFeld;VAR LZ:WORD);
  VAR A,K,ZP,L,Wert,Code:Integer;
  BEGIN
   FILLCHAR(Z,SIZEOF(Z),0);A:=0;LZ:=Length(Zahl);
   FOR K:=1 TO LZ DIV EXPONENT DO
    BEGIN
     INC(A);Z[A]:=0;ZP:=1;
     FOR L:=1 TO EXPONENT DO
      BEGIN
       Val(ZAHL[LZ+EXPONENT+1-L-EXPONENT*K],Wert,Code);
       Z[A]:=Z[A]+ZP*Wert;
       ZP:=10*ZP;
      END
    END;
   IF LZ MOD EXPONENT>0 THEN
    BEGIN
     INC(A);Z[A]:=0;ZP:=1;
     FOR L:=1 TO LZ MOD EXPONENT DO
      BEGIN
       Val(ZAHL[LZ+EXPONENT+1-L-EXPONENT*(1+LZ DIV EXPONENT)],Wert,Code);
       Z[A]:=Z[A]+ZP*Wert;
       ZP:=10*ZP;
      END
    END;
   K:=LZ DIV EXPONENT;IF LZ MOD EXPONENT>0 THEN INC(K);
   LZ:=K
  END;

 PROCEDURE LANGADD(VAR S:TFeld;VAR LS:WORD;A,B:TFeld;LA,LB:WORD;
                   Var Fehler:Boolean;Var FehlerText:String);{ * A+B *}
  VAR K,GRENZE:WORD; H,UE:EXTENDED;
  BEGIN
   Fehler:=False;FehlerText:='';
   IF LA>LB THEN
    BEGIN
     GRENZE:=LA;
     FOR K:=LB+1 TO LA  DO B[K]:=0;
    END
   ELSE
    BEGIN
     GRENZE:=LB;
     FOR K:=LA+1 TO LB  DO A[K]:=0;
    END;
   UE:=0;
   FOR K:=1 TO GRENZE DO
    BEGIN
     H:=A[K]+B[K]+UE;
     IF H>=T THEN BEGIN H:=H-T;UE:=1 END ELSE UE:=0;
     S[K]:=H
    END;
   LS:=GRENZE;
   IF UE>0 THEN
    BEGIN
     INC(LS);IF LS>MAX THEN
      BEGIN
       FehlerText:='Overflow-Error in LangAdd!';
       Fehler:=True;Exit;
      END;
     S[LS]:=UE
    END
  END;

 PROCEDURE LANGSUB(VAR D:TFeld;VAR LD:WORD;A,B:TFeld;LA,LB:WORD;
                   Var Fehler:Boolean;Var FehlerText:String);{ * A-B *}
  VAR K:WORD; H,UE:EXTENDED;
  BEGIN
   Fehler:=False;FehlerText:='';
   IF LANGKLEINER(A,B,LA,LB) THEN
    BEGIN
     FehlerText:='Der Subtrahend ist grer als der Minuend!';
     Fehler:=True;Exit;
    END;
   UE:=0;FOR K:=LB+1 TO LA  DO B[K]:=0;
   FOR K:=1 TO LA DO
    BEGIN
     H:=A[K];H:=H-B[K]-UE;
     IF H<0 THEN BEGIN H:=H+T;UE:=1 END ELSE UE:=0;
     D[K]:=H
    END;
   WHILE (D[LA]=0) AND (LA>1) DO DEC(LA);
   LD:=LA
  END;

 PROCEDURE LANGMUL(VAR E:TFeld;VAR LE:WORD;B,P:TFeld;LB,LP:WORD);
  VAR I,J:WORD; H,UE:EXTENDED;
  BEGIN
   LE:=LB+LP;
   IF LE>MAX THEN
    BEGIN
     WRITELN(^G,'MAXIMUM=',MAX,' STELLENANZAHL=',LE,'===> OVERFLOW-ERROR!');
     HALT
    END;
   FILLCHAR(E,SIZEOF(E),0);
   FOR I:=1 TO LP DO
    BEGIN
     UE:=0;
     FOR J:=1 TO LB DO
      BEGIN
       H:=B[J]*P[I]+E[I+J-1]+UE;
       UE:=INT(H/T);E[I+J-1]:=H-UE*T;
      END;
     E[LB+I]:=UE
    END;
   WHILE (E[LE]=0) AND (LE>1) DO DEC(LE)
  END;

 PROCEDURE LANGDIVISION(VAR E,R:TFeld;VAR LE,LR:WORD;A,B:TFeld;LA,LB:WORD);
  VAR U,V,Q,S:TFeld;
      UE,P,QU,DIFF:EXTENDED;
      K,M,N,J,I:WORD;
  BEGIN
   M:=LA;N:=LB;
   IF M<N THEN
    BEGIN R:=A;LR:=LA;LANGINT(E,LE,0);EXIT END;
   FILLCHAR(U,SIZEOF(U),0);FILLCHAR(V,SIZEOF(V),0);
   FOR I:=1 TO M DO U[I]:=A[M-I+1];
   FOR I:=1 TO N DO V[I]:=B[N-I+1];
   IF N=1 THEN V[2]:=0;
   FOR J:=0 TO M-N DO
    BEGIN
     IF U[J]=V[1] THEN QU:=T-1 ELSE QU:=INT((U[J]*T+U[J+1])/V[1]);
     DIFF:=(U[J]*T+U[J+1]-QU*V[1])*T+U[J+2];
     IF V[2]*QU>DIFF THEN QU:=INT((U[J]*T*T+U[J+1]*T+U[J+2])/(V[2]+V[1]*T));
     UE:=0;
     FOR I:=N DOWNTO 1 DO
      BEGIN P:=V[I]*QU+UE;UE:=INT(P/T);S[I]:=P-UE*T END;
     S[0]:=UE;UE:=0;
     FOR I:=J+N DOWNTO J DO
      BEGIN
       P:=U[I]-S[I-J]-UE;
       IF P<0 THEN BEGIN U[I]:=P+T;UE:=1 END ELSE BEGIN U[I]:=P;UE:=0 END
      END;
     Q[J]:=QU;
     IF UE=1 THEN
      BEGIN
       Q[J]:=Q[J]-1;UE:=0;
       FOR I:=J+N DOWNTO J DO
        BEGIN P:=U[I]+V[I-J]+UE;UE:=INT(P/T);U[I]:=P-UE*T END;
       IF J>0 THEN U[J-1]:=U[J-1]+UE
      END
    END;
   I:=0;WHILE (Q[I]=0) AND (I<M-N) DO INC(I);
   LE:=M-N-I+1;FOR K:=1 TO LE DO E[K]:=Q[M-N-K+1];
   I:=M-N+1;WHILE (U[I]=0) AND (I<M) DO INC(I);
   LR:=M-I+1;FOR K:=1 TO LR DO R[K]:=U[M-K+1]
  END;

 PROCEDURE LANGAUSGABE(LBox:TListBox;S:TFeld;LS:WORD);{* ERGEBNIS AUSGEBEN *}
  VAR K:WORD;
  BEGIN
   FOR K:=LS DOWNTO 1 DO
   LBox.Items.Add(Format('%12.0f',[S[K]]));
  END;

 PROCEDURE LANGWURZEL(VAR W:TFeld;VAR LW:WORD;A:TFeld;LA:WORD);
  VAR XN,XA,ZWEI,EINS,R,DIFF:TFeld;
      FERTIG,F:BOOLEAN;
      FT:String;
      LZWEI,LEINS,LR,LXA,LXN,LDIFF:WORD;
  BEGIN
   LANGINT(ZWEI,LZWEI,2);LANGDIVISION(XA,R,LXA,LR,A,ZWEI,LA,LZWEI);
   FERTIG:=FALSE;
   REPEAT
    LANGDIVISION(XN,R,LXN,LR,A,XA,LA,LXA);       { XN:=A DIV XA }
    LANGADD(XN,LXN,XN,XA,LXN,LXA,F,FT);               { XN:=XN+XA    }
    LANGDIVISION(XN,R,LXN,LR,XN,ZWEI,LXN,LZWEI); { XN:=XN DIV 2 }
    IF LANGKLEINER(XN,XA,LXN,LXA) THEN LANGSUB(DIFF,LDIFF,XA,XN,LXA,LXN,F,FT)
    ELSE LANGSUB(DIFF,LDIFF,XN,XA,LXN,LXA,F,FT);
    IF LANGKLEINER(DIFF,ZWEI,LDIFF,LZWEI) THEN FERTIG:=TRUE;
    XA:=XN;LXA:=LXN;
   UNTIL FERTIG;
   LANGINT(EINS,LEINS,1);LANGADD(XA,LXA,XA,EINS,LXA,LEINS,F,FT);
   IF INT(XA[1]/2)=XA[1]/2 THEN LANGADD(XA,LXA,XA,EINS,LXA,LEINS,F,FT);
   W:=XA;LW:=LXA
  END;

 END.

