unit Life1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, Spin, Menus, ExtCtrls;

  Const MaxX=39;MaxY=39;Inhalt:String[2]=' *'; // 2 Ausgabesymbole

type
  TMatrix=Array[-1..MaxX+1,-1..MaxY+1]of Byte;
  TCode=Array[1..50]of Integer; // 40*40=1600, 1600 div 32=50
  TLife = class(TForm)
    Ausgabe: TStringGrid;
    LabelA: TLabel;
    SaveDialog: TSaveDialog;
    OpenDialog: TOpenDialog;
    MainMenu: TMainMenu;
    Datei: TMenuItem;
    Laden: TMenuItem;
    Speichern: TMenuItem;
    Neu: TMenuItem;
    N1: TMenuItem;
    Quit: TMenuItem;
    Beenden: TMenuItem;
    Optionen: TMenuItem;
    Start: TMenuItem;
    Zufall: TMenuItem;
    GitterAnAus: TMenuItem;
    Parameter: TMenuItem;
    LifeBewegung: TTimer;
    Hilfe: TMenuItem;
    Regeln: TMenuItem;
    N2: TMenuItem;
    Info: TMenuItem;
    Back: TMenuItem;
    Vorwaerts: TMenuItem;
    Einzelschritt: TMenuItem;
    procedure StartClick(Sender: TObject);
    procedure AusgabeSelectCell(Sender: TObject; Col, Row: Integer;
                                Var CanSelect: Boolean);
    procedure Loeschen(Var F:TMatrix);
    procedure Ausgeben(F:TMatrix);
    procedure NeuClick(Sender: TObject);
    procedure ZufallClick(Sender: TObject);
    procedure Berechnen(Var Leben:Integer;Var F:TMatrix);
    procedure Zaehlen(F:TMatrix;X,Y:Integer;Var A:Integer);
    procedure QuitClick(Sender: TObject);
    procedure SpeichernClick(Sender: TObject);
    procedure LadenClick(Sender: TObject);
    Function TestBit(Zahl: Integer; BitNr: Byte): Boolean;
    Function SetBit(Zahl: Integer; BitNr: Byte): Integer;
    procedure Rand(Var F:TMatrix);
    procedure Codieren(F:TMatrix;Var Code:TCode);
    procedure Decodieren(Var F:TMatrix;Code:TCode);
    function Identisch(K,L:Integer):Boolean;
    procedure BeendenClick(Sender: TObject);
    procedure GitterAnAusClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ParameterClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure LifeBewegungTimer(Sender: TObject);
    procedure RegelnClick(Sender: TObject);
    procedure InfoClick(Sender: TObject);
    procedure BackClick(Sender: TObject);
    procedure VorwaertsClick(Sender: TObject);
    procedure EinzelschrittClick(Sender: TObject);
  private
    { Private-Deklarationen }
   // globale Variablen
   Feld:TMatrix; // konstantes Array
   Abbruch,GitterAn:Boolean;
   GZ,Index:Integer;
  public
    { Public-Deklarationen }
   Ozzi:Array of TCode; // dynamisches Array
   LowTod,HighTod,LowGeb,HighGeb,MaxOzzi:Integer;
  End;

 Var Life: TLife;

implementation

uses Einstellungen, Regeln, Info;

{$R *.DFM}
{$R+,Q+} // Bereichsberprfung ist aktiviert
         // berlaufprfung ist aktiviert

 Function TLife.TestBit(Zahl: Integer; BitNr: Byte): Boolean;// 32 Bit
  Begin TestBit:=((Zahl shr BitNr) and 1)=1 End;

 Function TLife.SetBit(Zahl: Integer; BitNr: Byte): Integer;// 4 Bytes
  Begin SetBit:=Zahl or (1 shl BitNr) End;

 procedure TLife.Loeschen(Var F:TMatrix);
  Begin FillChar(F,SizeOf(F),0) End;

 procedure TLife.Ausgeben(F:TMatrix);
  Var X,Y:Word;
  Begin
   For X:=0 To MaxX do
    For Y:=0 To MaxY do
    Ausgabe.Cells[X,Y]:=Inhalt[F[X,Y]+1];
   End;

 procedure TLife.Rand(Var F:TMatrix);
  Var X,Y:Integer;
  Begin
   For X:=-1 To MaxX+1 do // oben und unten
    Begin F[X,MaxY+1]:=F[X,0];F[X,-1]:=F[X,MaxY] End;
   For Y:=-1 To MaxY+1 do // links und rechts
    Begin F[MaxX+1,Y]:=F[0,Y];F[-1,Y]:=F[MaxX,Y] End;
  End;

 procedure TLife.Zaehlen(F:TMatrix;X,Y:Integer;Var A:Integer);
  Var Z,S:Integer;
  Begin
   A:=0;
   For S:=X-1 To X+1 do
    For Z:=Y-1 To Y+1 do inc(A,F[S,Z]);
   dec(A,F[X,Y]);
  End;

 procedure TLife.Berechnen(Var Leben:Integer;Var F:TMatrix);
  Var x,y,L:Integer;
      NeuesFeld:TMatrix;
  Begin
   Leben:=0;FillChar(NeuesFeld,SizeOf(NeuesFeld),0);
   For x:=0 To MaxX do
    For y:=0 To MaxY do
     Begin
      Zaehlen(F,x,y,L);
      // geboren werden
      if (F[x,y]=0) and (L>=LowGeb) and (L<=HighGeb) then NeuesFeld[x,y]:=1;
      // berleben
      if (F[x,y]=1) and (L>=LowTod) and (L<=HighTod) then NeuesFeld[x,y]:=1;
      inc(Leben,NeuesFeld[x,y]);
     End;
   F:=NeuesFeld;
  End;

 procedure TLife.Codieren(F:TMatrix;Var Code:TCode);
  Var X,Y,Nr,Position:Integer;
  Begin
   FillChar(Code,SizeOf(Code),0);
   Position:=31;// BitPosition
   Nr:=1;// Position in FeldInhalt
   For X:=0 To MaxX do
    For Y:=0 To MaxY do
     Begin
      if Feld[x,y]=1 then Code[Nr]:=SetBit(Code[Nr],Position);
      Dec(Position);
      if Position<0 then Begin Position:=31;inc(Nr) End
     End;
  End;

 procedure TLife.Decodieren(Var F:TMatrix;Code:TCode);
  Var X,Y,Nr,Position:Integer;
   begin
    FillChar(F,SizeOf(F),0);
    Position:=31;// BitPosition
    Nr:=1;// Position in FeldInhalt
    For X:=0 To MaxX do
     For Y:=0 To MaxY do
      Begin
       if TestBit(Code[Nr],Position) then F[x,y]:=1;
       Dec(Position);
       if Position<0 then Begin Position:=31;inc(Nr) End
      End;
   end;

 function TLife.Identisch(K,L:Integer):Boolean; // vergleicht zwei Generationen
  var G1,G2:TCode;
      Nr:Integer;
  begin
   if K>0 then Identisch:=True
   else begin Identisch:=False;exit end;
   G1:=Ozzi[K];G2:=Ozzi[L];
   for Nr:=1 to 50 do
    if G1[Nr]<>G2[Nr] then begin Identisch:=False;exit end
  end;

 procedure TLife.LifeBewegungTimer(Sender: TObject);
  var K,Lebendig:Integer;
      Code:TCode;
      Ozzilierend,Gleich:Boolean;
  begin
   inc(GZ);Index:=GZ;
   Codieren(Feld,Code);Ozzi[GZ]:=Code;
   Berechnen(Lebendig,Feld);Ausgeben(Feld);
   Rand(Feld);
   Gleich:=Identisch(GZ,GZ-1);
   Ozzilierend:=False;
   For K:=0 To GZ-1 do
    if Identisch(GZ,K) then Begin Ozzilierend:=True;Break End;
   LabelA.Caption:=IntToStr(GZ)+' -te Generation '+IntToStr(Lebendig)+
                   ' Lebewesen !';
   if Abbruch then
    LabelA.Caption:='Abbruch nach der '+IntToStr(GZ)+'-ten Generation!'+#13
                     +IntToStr(Lebendig)+' Lebewesen !';
   if Lebendig=0 then
    LabelA.Caption:='Nach der '+IntToStr(GZ)+'-ten Generation ausgestorben!';
   if Gleich then
   LabelA.Caption:='Nach der '+IntToStr(GZ)+'-ten Generation unverndert geblieben!'
                   +#13+IntToStr(Lebendig)+' Lebewesen !';
   if Ozzilierend and not Gleich then
    LabelA.Caption:='Nach der '+IntToStr(GZ)+'-ten Generation ozzilierend mit der '
                     +IntToStr(K)+'-ten Generation! '+#13
                     +IntToStr(Lebendig)+' Lebewesen !';
   if GZ=MaxOzzi then
    LabelA.Caption:=IntToStr(MaxOzzi)+' Generationen wurden berechnet! '+#13
                    +IntToStr(Lebendig)+' Lebewesen !';
   if Abbruch or (Lebendig=0) or Gleich or Ozzilierend or (GZ=MaxOzzi) then
    begin
     LifeBewegung.Enabled:=False;
     Back.Enabled:=True;Vorwaerts.Enabled:=True;
    end;
  end;

 procedure TLife.StartClick(Sender: TObject);
  var Version:Integer;
  Begin
   Ausgabe.Enabled:=False;
   LowTod:=ParameterDialog.LowSterben.Value;
   HighTod:=ParameterDialog.HighSterben.Value;
   LowGeb:=ParameterDialog.LowLeben.Value;
   HighGeb:=ParameterDialog.HighLeben.Value;
   MaxOzzi:=ParameterDialog.MaxGeneration.Value;
   LifeBewegung.Interval:=ParameterDialog.Verz.Value;
   if LowGeb>HighGeb then
    Begin
     MessageDlg('Falsche Geburtswerte!',mtError,[mbOk],0);
     Exit
    End;
   if LowTod>HighTod then
    Begin
     MessageDlg('Falsche Todwerte!',mtError,[mbOk],0);
     Exit
    End;
   Version:=1000*LowTod+100*HighTod+10*LowGeb+HighGeb;
   Life.Caption:='Conway'+''''+'s Life     Version '+IntToStr(Version);
   Abbruch:=False;GZ:=-1;Index:=GZ;
   Back.Enabled:=False;Vorwaerts.Enabled:=False;
   Rand(Feld);
   SetLength(Ozzi,MaxOzzi+1);
   LifeBewegung.Enabled:=True;
  End;

 procedure TLife.AusgabeSelectCell(Sender: TObject; Col, Row: Integer;
                                   Var CanSelect: Boolean);
  Begin
   Feld[Col,Row]:=1-Feld[Col,Row];
   Ausgabe.Cells[Col,Row]:=Inhalt[Feld[Col,Row]+1];
  End;

 procedure TLife.FormCreate(Sender: TObject);
  Begin
   Randomize;
   LifeBewegung.Enabled:=False;
   Back.Enabled:=False;Vorwaerts.Enabled:=False;
   Einzelschritt.Enabled:=False;
   GitterAn:=True;
   Loeschen(Feld);Ausgeben(Feld);
  End;

 procedure TLife.NeuClick(Sender: TObject);
  Begin
   Ausgabe.Enabled:=True;
   Back.Enabled:=False;Vorwaerts.Enabled:=False;
   if ParameterDialog.Einzeln.Checked then
    begin
     Einzelschritt.Enabled:=True;
     Back.Enabled:=True;Vorwaerts.Enabled:=True;
     GZ:=-1;Index:=GZ;
    end;
   Loeschen(Feld);
   Ausgeben(Feld);
  End;

 procedure TLife.ZufallClick(Sender: TObject);
  Var K,N,X,Y:Integer;
  Begin
   Loeschen(Feld);N:=Random(700)+100;
   For K:=1 To N do
    Begin
     Repeat
      X:=Random(MaxX)+1;Y:=Random(MaxY)+1;
     Until Feld[X,Y]=0;
     Feld[X,Y]:=1
    End;
   Ausgeben(Feld);
   GZ:=-1;
  End;

 procedure TLife.QuitClick(Sender: TObject);
  Begin
   if MessageDlg('Willst du das Programm abbrechen?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    begin
     MessageDlg('Life wird abgebrochen!',mtWarning,[mbOk],0);
     Abbruch:=True;
    end
  End;

 procedure TLife.SpeichernClick(Sender: TObject);
  Var FeldInhalt:TCode;
      Wo:Integer;
      LifeDat:File;
      DateiName:String;
  Begin
   Codieren(Feld,FeldInhalt);
   with SaveDialog do
    if execute then
    Begin
     DateiName:=FileName;
     Wo:=Pos('.',DateiName);
     if Wo>0 then
      Delete(DateiName,Wo,Length(DateiName)-Wo+1);
     DateiName:=DateiName+'.'+DefaultExt;
     AssignFile(LifeDat,Dateiname);
    {$I-} Rewrite(LifeDat,4) {$I+};  // 4 Bytes, wegen Datentyp "Integer"
     BlockWrite(LifeDat,FeldInhalt,50);
     CloseFile(LifeDat);
    End
   else MessageDlg('Es wurde keine Datei gespeichert!',mtError,[mbOK],0);
  End;

 procedure TLife.LadenClick(Sender: TObject);
  Var FeldInhalt:TCode;
      LifeDat:File;
  Begin
   with OpenDialog do
    if execute then
    Begin
     AssignFile(LifeDat,Filename);
    {$I-} Reset(LifeDat,4) {$I+};  // 4 Bytes, wegen Datentyp "Integer"
     BlockRead(LifeDat,FeldInhalt,50);
     CloseFile(LifeDat);
    End
   else
    Begin
     MessageDlg('Es wurde keine Datei geladen!',mtError,[mbOK],0);
     exit
    End;
   Decodieren(Feld,FeldInhalt);
   Ausgeben(Feld);
   Ausgabe.Enabled:=True;
  End;

 procedure TLife.GitterAnAusClick(Sender: TObject);
  begin
   if Not GitterAn then
    begin
     GitterAn:=True;
     GitterAnAus.Caption:='&Gitter aus';
     Ausgabe.Options:=Ausgabe.Options+[goVertLine];
     Ausgabe.Options:=Ausgabe.Options+[goHorzLine];
    end
   else
    begin
     GitterAn:=False;
     GitterAnAus.Caption:='&Gitter an';
     Ausgabe.Options:=Ausgabe.Options-[goVertLine];
     Ausgabe.Options:=Ausgabe.Options-[goHorzLine];
    end
  end;

 procedure TLife.ParameterClick(Sender: TObject);
  begin
   ParameterDialog.ShowModal;
  end;

 procedure TLife.BeendenClick(Sender: TObject);
  begin close end;

 procedure TLife.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  begin
   if MessageDlg('Willst du das Programm beenden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    begin
     MessageDlg('Life wird beendet!',mtWarning,[mbOk],0);
     CanClose:=True
    end
   else CanClose:=False
  end;

 procedure TLife.RegelnClick(Sender: TObject);
  begin RegelnBox.ShowModal end;

 procedure TLife.InfoClick(Sender: TObject);
  begin InfoBox.ShowModal end;

 procedure TLife.BackClick(Sender: TObject);
  begin
   if Index>0 then
    begin
     dec(Index);
     Decodieren(Feld,Ozzi[Index]);
     Ausgeben(Feld);
    end
  end;

 procedure TLife.VorwaertsClick(Sender: TObject);
  begin
    if Index<GZ then
    begin
     inc(Index);
     Decodieren(Feld,Ozzi[Index]);
     Ausgeben(Feld);
    end
  end;

 procedure TLife.EinzelschrittClick(Sender: TObject);
  var K,Lebendig:Integer;
      Code:TCode;
      Ozzilierend,Gleich:Boolean;
  begin
   inc(GZ);Index:=GZ;
   Codieren(Feld,Code);Ozzi[GZ]:=Code;
   Berechnen(Lebendig,Feld);Ausgeben(Feld);
   Rand(Feld);
   Gleich:=Identisch(GZ,GZ-1);
   Ozzilierend:=False;
   For K:=0 To GZ-1 do
    if Identisch(GZ,K) then Begin Ozzilierend:=True;Break End;
   LabelA.Caption:=IntToStr(GZ)+' -te Generation '+IntToStr(Lebendig)+
                   ' Lebewesen !';
   if Lebendig=0 then
    LabelA.Caption:='Nach der '+IntToStr(GZ)+'-ten Generation ausgestorben!';
   if Gleich then
    LabelA.Caption:='Nach der '+IntToStr(GZ)+'-ten Generation unverndert geblieben!'
                    +#13+IntToStr(Lebendig)+' Lebewesen !';
   if Ozzilierend and not Gleich then
    LabelA.Caption:='Nach der '+IntToStr(GZ)+'-ten Generation ozzilierend mit der '
                     +IntToStr(K)+'-ten Generation! '+#13
                     +IntToStr(Lebendig)+' Lebewesen !';
   if GZ=MaxOzzi then
    LabelA.Caption:=IntToStr(MaxOzzi)+' Generationen wurden berechnet! '+#13
                    +IntToStr(Lebendig)+' Lebewesen !';
  end;

end.

