Unit Lotto99;

Interface

Uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

Type
  TOft=Array[1..49]of Integer;
  TZieh=Array[1..7]of Integer;
  TLotto = class(TForm)
    Anzahl: TEdit;
    LabelZiehung: TLabel;
    Ausgabe: TListBox;
    Start: TButton;
    Ende: TButton;
    LabelAusgabe: TLabel;
    LabelOft: TLabel;
    ListBoxOft: TListBox;
    ZiehungsAnzeige: TCheckBox;
    Procedure EndeClick(Sender: TObject);
    Procedure StartClick(Sender: TObject);
    Procedure Sortieren(Zieh:TZieh);
    Procedure Ziehen(Var Oft:TOft;An:Integer);
    Procedure OftAusgabe(Oft:TOft);
    Procedure AnzahlKeyPress(Sender: TObject; Var Key: Char);
    Procedure FormCreate(Sender: TObject);
  Private
    { Private-Deklarationen }
  Public
    { Public-Deklarationen }
  End;

Var Lotto: TLotto;

implementation

{$R *.DFM}
{$R+,Q+} // die Bereichsberprfung und die berlaufprfung ist aktiviert
         //         Arrays                   Wertebereich

 Procedure TLotto.EndeClick(Sender: TObject);
  Begin Close End;

 Procedure TLotto.Sortieren(Zieh:TZieh);
 // eine Ziehung wird sortiert und ausgegeben
  Var J,H:Integer;
      Sortiert:Boolean;
      Zeile:String;
  Begin
   Repeat
    Sortiert:=True;
    For J:=1 To 5 Do
     If Zieh[J]>Zieh[J+1] Then
      Begin
       H:=Zieh[J];Zieh[J]:=Zieh[J+1];Zieh[J+1]:=H;
       Sortiert:=False
      End
   Until Sortiert;
   If ZiehungsAnzeige.Checked Then
    Begin
     Zeile:='';
     For J:=1 To 6 Do Zeile:=Zeile+Format('%3d',[Zieh[J]]);
     Zeile:=Zeile+'   '+Format('%2d',[Zieh[7]]);
     Ausgabe.Items.Add(Zeile);
    End
  End;

 Procedure TLotto.Ziehen(Var Oft:TOft;An:Integer);
   Var A,J,D:Integer;
       Zieh:TZieh;
       Kugel:TOft;
   Begin
    For D:=1 To AN Do
     Begin
      For J:=1 To 49 Do Kugel[J]:=1;
      For J:=1 To 7 Do
       Begin
        Repeat A:=Random(49)+1 Until Kugel[A]=1;
        Inc(Oft[A]);Kugel[A]:=0;Zieh[J]:=A
       End;
      Sortieren(Zieh)
     End
   End;

 Procedure TLotto.OftAusgabe(Oft:TOft);
  Var Zeile:String;
      J:Integer;
  Begin
   Zeile:='';
   For J:=1 To 49 Do
    Begin
     Zeile:=Zeile+(Format('%3d',[J]));
     Zeile:=Zeile+'='+(Format('%7d',[Oft[J]]))+' ';
     If J mod 4=0 Then
      Begin
       Lotto.ListBoxOft.Items.Add(Zeile);
       Zeile:='';
      End
    End;
   Lotto.ListBoxOft.Items.Add(Zeile);
  End;

 Procedure TLotto.StartClick(Sender: TObject);
  var An:Integer;
      Oft:TOft;
  Begin
   If Anzahl.Text='' Then
    Begin
     MessageDLG('Keine Ziehung mglich!',mtError,[mbOk],0);
     exit
    End;
   Screen.Cursor:=crHourGlass;
   AN:=StrToInt(Anzahl.Text);
   if An>32736 then ZiehungsAnzeige.Checked:=False;
   Lotto.Ausgabe.Items.Clear;
   Lotto.ListBoxOft.Items.Clear;
   FillChar(Oft,SizeOf(Oft),0);
   Ziehen(Oft,An);OftAusgabe(Oft);
   Screen.Cursor:=crDefault;
  End;

 Procedure TLotto.AnzahlKeyPress(Sender: TObject; Var Key: Char);
  Begin
   If not (Key in[#8,'0'..'9']) Then Key:=#0;
   // wenn keine Ziffer oder Backspace, dann Nichts
  End;

 Procedure TLotto.FormCreate(Sender: TObject);
  Begin Randomize End;

End.

