unit Matrixver;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, ExtCtrls;

type
  TMatrixcode = class(TForm)
    Auswahl: TRadioGroup;
    AusgabeMatrix: TStringGrid;
    MatrixKopfzeile: TStaticText;
    Start: TButton;
    Codewahl: TRadioGroup;
    Eingabe: TMemo;
    Ausgabe: TMemo;
    EingabeKopfzeile: TStaticText;
    AusgabeKopfzeile: TStaticText;
    DateiOeffnen: TOpenDialog;
    Laden: TButton;
    procedure StartClick(Sender: TObject);
    procedure LadenClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Matrixcode: TMatrixcode;

implementation

{$R *.DFM}

procedure TMatrixcode.StartClick(Sender: TObject);
  CONST N=6;NMAX=11;
        NORMAL:ARRAY[0..N,0..N]OF CHAR=('*LUHNV*',
                                        'IDBMWID',
                                        'ECOXGEC',
                                        'SQYRFSQ',
                                        'PZAKTPZ',
                                        'VLUHNVL',
                                        '*DBMWI*');
  VAR MATRIX:ARRAY[0..NMAX,0..NMAX]OF CHAR;
      ALFA:STRING;
      SCHLUESSEL,Result,M:LONGINT;
      InputString: string;

  PROCEDURE INIT;
   VAR I,J,VON,BIS,Z,S:INTEGER;
   BEGIN
    FOR I:=0 TO NMAX DO
     FOR J:=0 TO NMAX DO AusgabeMatrix.Cells[J,I]:='';
    VON:=65;BIS:=90;ALFA:='';M:=5;
    FOR I:=VON TO BIS DO ALFA:=ALFA+CHAR(I);
    FOR I:=0 TO M+1 DO
     FOR J:=0 TO M+1 DO MATRIX[I,J]:='*';
    DELETE(ALFA,10,1); { I wird entfernt }
    IF Auswahl.ItemIndex=0 THEN
     FOR I:=0 TO N DO
      FOR J:=0 TO N DO MATRIX[I,J]:=NORMAL[I,J]
    ELSE
     BEGIN
      InputString:= InputBox('Eingabe', 'Dein Schlssel', '4711');
      Val(InputString,SCHLUESSEL,Result);
      IF Result<>0 THEN SCHLUESSEL:=4711; // bei fehlerhafter Eingabe
      RANDSEED:=SCHLUESSEL;
      IF Auswahl.ItemIndex=2 THEN
       BEGIN
        VON:=32;BIS:=125;ALFA:='';M:=10;
        FOR I:=VON TO BIS DO ALFA:=ALFA+CHAR(I);
        ALFA:=ALFA+'';
        FOR I:=0 TO M+1 DO
         FOR J:=0 TO M+1 DO MATRIX[I,J]:='*';
       END;
      { Matrix zufllig fllen }
      FOR I:=1 TO M*M DO
       BEGIN
        REPEAT Z:=RANDOM(M)+1;S:=RANDOM(M)+1 UNTIL MATRIX[Z,S]='*';
        MATRIX[Z,S]:=ALFA[I]
       END;
      FOR I:=1 TO M DO
       BEGIN MATRIX[I,0]:=MATRIX[I,M];MATRIX[I,M+1]:=MATRIX[I,1] END;
      FOR J:=1 TO M DO
       BEGIN MATRIX[0,J]:=MATRIX[M,J];MATRIX[M+1,J]:=MATRIX[1,J] END
     END;
    // Ausgabe der Matrix
    AusgabeMatrix.ColCount:=M+2;
    AusgabeMatrix.RowCount:=M+2;
    FOR I:=0 TO M+1 DO
     FOR J:=0 TO M+1 DO AusgabeMatrix.Cells[J,I]:=MATRIX[I,J];
   END;

  PROCEDURE VERSCHLUESSELN;
   VAR AN,K,L,I,J,X,XI,XJ,YI,YJ:INTEGER;
       G,T:STRING;
       A1,A2:CHAR;
   BEGIN
    Matrixcode.Ausgabe.Clear;
    IF Codewahl.Itemindex=0 THEN X:=1
    ELSE X:=-1;
    FOR AN:=0 TO Eingabe.Lines.Count DO
     BEGIN
      T:=Eingabe.Lines[AN];
      L:=LENGTH(T);
      IF L MOD 2=1 THEN BEGIN L:=L+1;T:=T+'X' END;
      K:=1;G:='';
      WHILE K<L DO
       BEGIN
        A1:=T[K];A2:=T[K+1];
        IF A1='J' THEN A1:='I';
        IF A2='J' THEN A2:='I';
        IF A1=A2 THEN A2:='X';
        XI:=0;XJ:=0;YI:=0;YJ:=0;
        FOR I:=1 TO M DO
         FOR J:=1 TO M DO
          BEGIN
           IF A1=MATRIX[I,J] THEN BEGIN XI:=I;XJ:=J END;
           IF A2=MATRIX[I,J] THEN BEGIN YI:=I;YJ:=J END
          END;
        IF (XI>0) AND (YI>0) AND (XI=YI) THEN
         BEGIN XJ:=XJ+X;YJ:=YJ+X;G:=G+MATRIX[XI,XJ]+MATRIX[YI,YJ] END
        ELSE
         IF (XJ>0) AND (YJ>0) AND (XJ=YJ) THEN
          BEGIN XI:=XI+X;YI:=YI+X;G:=G+MATRIX[XI,XJ]+MATRIX[YI,YJ] END
         ELSE
          IF (XI>0) AND (XJ>0) AND (YI>0) AND (YJ>0) THEN G:=G+MATRIX[XI,YJ]+MATRIX[YI,XJ]
          ELSE G:=G+A1+A2;
        INC(K,2)
       END;
      Ausgabe.Lines.Add(G)
     END
   END;

 BEGIN
  INIT;VERSCHLUESSELN
 END;

procedure TMatrixcode.LadenClick(Sender: TObject);
begin
 with DateiOeffnen do
  begin
   if Execute then Matrixcode.Eingabe.Lines.LoadFromFile(Filename)
  end
end;

end.
