unit Perioden;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Printers, Menus;

type
  TPeriode = class(TForm)
    LabelZaehler: TLabel;
    EditZaehler: TEdit;
    LabelNenner: TLabel;
    EditNenner: TEdit;
    Ausgabe: TRichEdit;
    LabelErg: TLabel;
    DateiLesen: TOpenDialog;
    DateiSpeichern: TSaveDialog;
    PrintDialog: TPrintDialog;
    LabelOben: TLabel;
    MainMenu1: TMainMenu;
    Datei: TMenuItem;
    Laden: TMenuItem;
    Speichern: TMenuItem;
    N1: TMenuItem;
    Beenden: TMenuItem;
    Rechne: TMenuItem;
    Drucken: TMenuItem;
    procedure RechneClick(Sender: TObject);
    procedure LadenClick(Sender: TObject);
    procedure SpeichernClick(Sender: TObject);
    procedure DruckenClick(Sender: TObject);
    procedure BeendenClick(Sender: TObject);
    procedure EditZaehlerKeyPress(Sender: TObject; var Key: Char);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Periode: TPeriode;

implementation

  CONST MAX=999999;MaxZiffern=999999; // wegen Stackgre
  VAR R:ARRAY OF Integer;
{$R *.DFM}
{$R+,Q+}
 procedure TPeriode.RechneClick(Sender: TObject);
  var S,I,REST,Z,N,X,LZ:Integer;
      ENDE,Abbruch:BOOLEAN;
      Zeile:String;
  begin
   if EditZaehler.Text='' then
    begin
     MessageDlg('Der Zhler ist undefiniert!',mtError,[mbOk],0);
     Exit
    end;
   if EditNenner.Text='' then
    begin
     MessageDlg('Der Nenner ist undefiniert!',mtError,[mbOk],0);
     Exit
    end;
   Z:=StrToInt(EditZaehler.Text);
   N:=StrToInt(EditNenner.Text);
   SetLength(R,N);
   For I:=0 to N-1 do R[I]:=0;
   ENDE:=FALSE;Abbruch:=False;
   S:=1;I:=0;Ausgabe.Clear;Ausgabe.SelAttributes.Color:=clBlack;
   Zeile:=IntToStr(Z)+':'+IntToStr(N)+'='+IntToStr(Z DIV N)+',';
   LZ:=Length(Zeile);
   Z:=Z MOD N;
   REPEAT
    INC(I);REST:=Z MOD N;
    if Rest>Max then Abbruch:=True;
    if not Abbruch then
     begin
      IF REST=0 THEN
       BEGIN
        LabelErg.Caption:='abbrechender Dezimalbruch der Lnge '+IntToStr(I-1);
        if I=1 then Zeile:=Zeile+'0';
        Ausgabe.Lines.Add(Zeile);
        Ausgabe.Lines.Add(LabelErg.Caption);
        ENDE:=TRUE
       END
      ELSE IF R[REST]>0 THEN
            BEGIN
             ENDE:=TRUE;Ausgabe.Lines.Add(Zeile);
             LabelErg.Caption:='Periodenlnge = '+IntToStr(S-R[REST])+#13
             +'Periode von der '+IntToStr(R[REST])+'-ten bis zur '
             +IntToStr(S-1)+'-ten Stelle';
             Ausgabe.Lines.Add('Periodenlnge = '+IntToStr(S-R[REST]));
             Ausgabe.Lines.Add('Periode von der '+IntToStr(R[REST])+
                               '-ten bis zur '+IntToStr(S-1)+'-ten Stelle');
             Ausgabe.SelStart:=LZ+R[REST]-1;
             Ausgabe.SelLength:=S-R[REST];
             Ausgabe.SelAttributes.Color:=clBlue;
             Ausgabe.SelStart:=0;
            END
           ELSE BEGIN
                 R[REST]:=S;INC(S);Z:=10*REST;X:=Z DIV N;
                 Zeile:=Zeile+IntToStr(X);
                END
     end
   UNTIL ENDE or Abbruch or (S=MaxZiffern);
   IF Abbruch or (S=MaxZiffern) THEN
    begin
     LabelErg.Caption:='Noch keine Periode entdeckt! Das Ergebnis hat mehr als '
                       +IntToStr(MaxZiffern)+' Ziffern!!!';
     Ausgabe.Lines.Add(Zeile);
    end;
  end;

 procedure TPeriode.LadenClick(Sender: TObject);
  var Teil:String;
  begin
   with DateiLesen do
    begin
     Filter:='Perioden-Dateien (*.Per)|*.Per';
     if Execute then
      begin
       Ausgabe.Lines.LoadFromFile(filename);
       LabelErg.Caption:=Ausgabe.Lines[Ausgabe.Lines.Count-2]+#13+
                         Ausgabe.Lines[Ausgabe.Lines.Count-1];
       Ausgabe.Lines.Delete(Ausgabe.Lines.Count-1);
       Ausgabe.Lines.Delete(Ausgabe.Lines.Count-1);
       Teil:=copy(Ausgabe.Lines[0],1,pos('=',Ausgabe.Lines[0])-1);
       EditZaehler.Text:=copy(Teil,1,pos(':',Teil)-1);
       Delete(Teil,1,pos(':',Teil));
       EditNenner.Text:=Teil
      end
     else
      begin
       MessageDlg('Es wurde keine Datei gewhlt!',mtError,[mbOk],0);
       exit
      end;
    end;
  end;

 procedure TPeriode.SpeichernClick(Sender: TObject);
  begin
   if Ausgabe.Lines.Count=0 then
    begin
     MessageDlg('Keine Daten!',mtConfirmation,[mbOk],0);
     exit
    end;
   with DateiSpeichern do
    begin
     Filter:='Perioden-Dateien (*.Per)|*.Per';
     Options:=[ofOverwritePrompt];
     DefaultExt:='Per';
     Ausgabe.Lines.Add(LabelErg.Caption);
     if Execute then
      begin
       Ausgabe.Lines.SaveToFile(Filename);
       Ausgabe.Lines.Delete(Ausgabe.Lines.Count-1);
      end 
     else MessageDlg('Die Datei wurde nicht gespeichert!',mtWarning,[mbOk],0);
    end;
  end;

 procedure TPeriode.DruckenClick(Sender: TObject);
  var K,LineSpace,Y,wo:Word;
      Zeile:String;
  begin
   if Ausgabe.Lines.Count=0 then
    begin
     MessageDlg('Es gibt NICHTS zu drucken!',mtError,[mbOk],0);
     exit;
    end;
   Printer.BeginDoc;
   Printer.Canvas.Font.Size:=Ausgabe.Font.Size;
   Printer.Canvas.Font.Name:=Ausgabe.Font.Name;
   Printer.Canvas.Font.Style:=Ausgabe.Font.Style;
   Printer.Canvas.TextOut(150,90,'Dezimalbruch');
   LineSpace:=10*Ausgabe.Font.Size;y:=200;{ oberer Rand }
   For K:=0 to Ausgabe.Lines.Count-1 do
    Begin
     Printer.Canvas.TextOut(100,y,Ausgabe.Lines[K]);
     y:=y+LineSpace;
    End;
   y:=y+LineSpace;Zeile:=LabelErg.Caption;
   wo:=Pos(#13,Zeile);Zeile[wo]:=' ';
   Printer.Canvas.TextOut(100,y,Zeile);
   Printer.EndDoc;
  end;

 procedure TPeriode.BeendenClick(Sender: TObject);
  begin
   if MessageDlg('Willst du das Programm beenden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    begin
     MessageDlg('Das Programm wird beendet!',mtWarning,[mbOk],0);
     close
    end
  end;

 procedure TPeriode.EditZaehlerKeyPress(Sender: TObject; var Key: Char);
  begin
   if Not(Key in[#8,'0'..'9']) then Key:=#0;
  end;

end.

