unit Primsieb;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,Printers;

type
  TPrimZahl = class(TForm)
    LabelBis: TLabel;
    EditBis: TEdit;
    ButtonPrim: TButton;
    ListBoxPrim: TListBox;
    LabelUeberschrift: TLabel;
    LabelAnzahl: TLabel;
    ErgebnisAnzahl: TLabel;
    LabelZeit: TLabel;
    LabelSek: TLabel;
    LabelGrenze: TLabel;
    Drucken: TButton;
    FontDialog1: TFontDialog;
    PrintDialog1: TPrintDialog;
    Ende: TButton;
    PrimAnzeige: TCheckBox;
    procedure ButtonPrimClick(Sender: TObject);
    procedure DruckenClick(Sender: TObject);
    procedure EndeClick(Sender: TObject);
    procedure EditBisExit(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var PrimZahl: TPrimZahl;

implementation

{$R *.DFM}
{$R+,Q+}
const max=9000000;
var sieb:array[1..max]of byte;
    an:Longint;
    ZeitWert: String;

function TimeSekunden:real;
 var H, M, S, MS : Word;
 begin
  DecodeTime(Time,H,M,S,MS);
  TimeSekunden:=3600.0*H+60.0*M+1.0*S+MS/100
 end;

procedure TPrimZahl.ButtonPrimClick(Sender: TObject);
 var Breite, i, z, k, Anzahl, Bis, Zahl, Wurzel: Longint;
     ZahlStr : String;
     Zeit : Real;
 begin
  Screen.Cursor := crHourglass;
  ListBoxPrim.Items.Clear;
  LabelGrenze.Caption:='3 - '+IntToStr(2*max);
  Bis:=StrToInt(EditBis.Text);
  Bis:=Abs(Bis);
  if Bis>2*max then Bis:=200;
  EditBis.Text:=IntToStr(Bis);
  Zeit:=TimeSekunden;
  an:=(Bis-1) div 2;{ (2w+1)=2an+1 !!! }
  Breite:=Trunc(ln(2*an)/ln(10));
  for i:=1 to an do sieb[i]:=1;
  Wurzel:=trunc(sqrt(an/2+0.25)-0.5);
  for i:=1 to Wurzel do
   begin
    if sieb[i]>0 then
     begin
      z:=2*i+1;k:=i*(z+1);
      while k<=an do begin sieb[k]:=0;inc(k,z) end
     end
   end;
  Anzahl:=0;Zeit:=TimeSekunden-Zeit;
  Str(2:Breite,ZahlStr);inc(Anzahl);
  if PrimAnzeige.Checked then ListBoxPrim.Items.Add(ZahlStr);
  for i:=1 to an do
   if sieb[i]>0 then
    begin
     Str(2*i+1:Breite,ZahlStr);inc(Anzahl);
     if PrimAnzeige.Checked then ListBoxPrim.Items.Add(ZahlStr);
    end;
  ZeitWert:=FloatToStrF(Zeit,ffgeneral,0,2);
  ErgebnisAnzahl.Caption:=IntToStr(Anzahl);
  LabelSek.Caption:=ZeitWert+' sek.';
  Screen.Cursor := crDefault
 end;

procedure TPrimZahl.DruckenClick(Sender: TObject);
 var Ctr,x,y,Seite,Breite,Abstand,Anzahl,PWeite,K,L,PHeight,LineSpace,
     LinesPerPage,Pixel,Mitte,FontSize,CopyNum,NumCopies: Integer;
     Primanzahl:Longint;
     Name,SeiteStr,ZahlStr : String;
 begin
  IF an=0 THEN
   BEGIN
    MessageDlg('Du mut erst Primzahlen berechnen!',mtError,[mbOk],0);
    EXIT
   END;
  Str(2*an+1,ZahlStr);
  Name:='(C)opyright by Fiete      Primzahlen bis '+ZahlStr;
  if PrintDialog1.Execute then
   begin
    FontDialog1.Execute;
    NumCopies:=PrintDialog1.Copies;
    for CopyNum:=1 to NumCopies do
     begin
      Ctr:=0;Seite:=1;Str(Seite,SeiteStr);y:=200;{ oberer Rand }
      Printer.BeginDoc;
      PHeight:=Printer.PageHeight-400;{ oben und unten Rand von je 200 Pixel}
      PWeite:=Printer.PageWidth-300;{ links und rechts Rand von je 150 Pixel}
      Abstand:=Trunc(ln(2*an)/ln(10))+1;{ Druckbereich fr die Zahlen }
      Pixel:=FontDialog1.Font.Size;
      Breite:=Abstand*4*Pixel;
      Anzahl:=PWeite div Breite+1;
      Printer.Canvas.Font.Size:=FontDialog1.Font.Size;
      Printer.Canvas.Font.Name:=FontDialog1.Font.Name;
      Printer.Canvas.Font.Style:=FontDialog1.Font.Style;
      LineSpace:=4*Pixel;
      LinesPerPage:=PHeight Div LineSpace+3;
      Mitte:=(Printer.PageWidth-length(Name)*2*Pixel)div 2;
      Printer.Canvas.TextOut(Mitte,90,Name);
      SeiteStr:='Seite '+SeiteStr;
      Mitte:=(Printer.PageWidth-length(SeiteStr)*Pixel)div 2;
      Printer.Canvas.TextOut(Mitte,Printer.PageHeight-100,SeiteStr);
      k:=0;Primanzahl:=0;
      Repeat
       L:=1;x:=150;{ linker Rand }
       Repeat
        inc(k);
        if k>an then break;
        if sieb[k]>0 then
         begin
          Str(2*k+1:Abstand,ZahlStr);inc(L);
          Printer.Canvas.TextOut(x,y,ZahlStr);
          x:=x+Breite;inc(Primanzahl)
         end;
       Until L>Anzahl;
       y:=y+LineSpace;Ctr:=Ctr+1;
       If Ctr > LinesPerPage then
        begin
         Printer.NewPage;
         Inc(Seite);Str(Seite,SeiteStr);
         Mitte:=(Printer.PageWidth-length(Name)*2*Pixel)div 2;
         Printer.Canvas.TextOut(Mitte,90,Name);
         SeiteStr:='Seite '+SeiteStr;
         Mitte:=(Printer.PageWidth-length(SeiteStr)*Pixel)div 2;
         Printer.Canvas.TextOut(Mitte,Printer.PageHeight-100,SeiteStr);
         y:=200;x:=150;Ctr:=0
        end;
      Until k>an;
      y:=y+LineSpace;
      ZahlStr:=IntToStr(Primanzahl);
      Printer.Canvas.TextOut(150,y,'Anzahl der Primzahlen = '+ZahlStr);
      y:=y+LineSpace;
      Printer.Canvas.TextOut(150,y,'Rechenzeit = '+ZeitWert+' sek.');
      Printer.EndDoc;
     end
   end
 end;

 procedure EingabeTest(Eingabe:TEdit);
 var n:Longint;
 begin
   try
    n:=StrToInt(Eingabe.Text);
   except
    on EConvertError do
     begin
      Messagebox(0,'Fehler in der Eingabe!','Problem',16);
      Eingabe.SetFocus
     end
  end
 end;

procedure TPrimZahl.EditBisExit(Sender: TObject);
begin
 EingabeTest(Sender as TEdit)
end;

procedure TPrimZahl.EndeClick(Sender: TObject);
 begin
  close
 end;

end.
