unit Quicksort2000;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin;

type
  TQuicksort = class(TForm)
    LabelAn: TLabel;
    SpinEditN: TSpinEdit;
    Input: TListBox;
    Output: TListBox;
    Fuellen: TButton;
    Sortieren: TButton;
    LabelG: TLabel;
    SpinEditG: TSpinEdit;
    LabelZeit: TLabel;
    procedure FuellenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    PROCEDURE QSort(VON,BIS:INTEGER);
    PROCEDURE Tauschen(VAR X,Y:Integer);
    procedure SortierenClick(Sender: TObject);
    function TimeSekunden:Extended;
  private
   Liste:Array of Integer;
   N:Integer;
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var Quicksort: TQuicksort;

implementation

{$R *.DFM}
{$R+,Q+}

 function TQuicksort.TimeSekunden:Extended;
  var H, M, S, MS : Word;
  begin
   DecodeTime(Now,H,M,S,MS);
   TimeSekunden:=3600.0*H+60.0*M+S+MS/1000
  end;

 PROCEDURE TQuicksort.Tauschen(VAR X,Y:Integer);
  VAR T:Integer;
  BEGIN T:=X;X:=Y;Y:=T END;

 PROCEDURE TQuicksort.QSort(VON,BIS:INTEGER);
  VAR I,J,M:Integer;
  BEGIN
   I:=VON;J:=BIS;M:=LISTE[(I+J) DIV 2];
   WHILE I<J DO
    BEGIN
     WHILE LISTE[I]>M DO INC(I);
     WHILE M>LISTE[J] DO DEC(J);
     IF I<=J THEN BEGIN Tauschen(LISTE[I],LISTE[J]);INC(I);DEC(J) END;
    END;
   IF I<BIS THEN QSort(I,BIS);
   IF VON<J THEN QSort(VON,J)
  END;

 procedure TQuicksort.FuellenClick(Sender: TObject);
  var Grenze,K:Integer;
  begin
   Grenze:=SpinEditG.Value;
   N:=SpinEditN.Value;SetLength(Liste,N);Input.Items.Clear;
   For K:=0 to N-1 do
    Begin
     Liste[K]:=Random(Grenze);
     Input.Items.Add(Format('%12s',[IntToStr(Liste[K])]));
    End
  end;

 procedure TQuicksort.FormCreate(Sender: TObject);
  begin Randomize end;

  procedure TQuicksort.SortierenClick(Sender: TObject);
   var K:Integer;
       T_Sek:Extended;
       Zahl:String;
   begin
    if Input.Items.Count=0 then
     Begin
      MessageDlg('Es gibt NICHTS zu sortieren!',mtError,[mbOk],0);
      exit;
     End;
    T_Sek:=TimeSekunden;
    QSort(0,N-1);
    T_Sek:=TimeSekunden-T_Sek;Str(T_Sek:0:2,Zahl);
    LabelZeit.Caption:='Rechenzeit= '+Zahl+' sek.';
    Output.Items.Clear;
    For K:=0 to N-1 do
     Output.Items.Add(Format('%12s',[IntToStr(Liste[K])]));
   end;

end.
