unit Schablone;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, ExtCtrls;
CONST MAX=20;Loch=0;Massiv=1;

type

  TFeld=ARRAY[1..MAX,1..MAX]OF Byte;
  TBrief=ARRAY[1..MAX,1..MAX]OF String[2];

  TSchablonenCode = class(TForm)
    Start: TButton;
    LabelT: TLabel;
    EditEingabe: TEdit;
    Auswahl: TRadioGroup;
    Ausgabe: TDrawGrid;
    BriefAusgabe: TDrawGrid;
    procedure StartClick(Sender: TObject);
    procedure AuswahlClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AusgabeDrawCell(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure BriefAusgabeDrawCell(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  SchablonenCode: TSchablonenCode;

implementation

{$R *.DFM}
{$R+,Q+}
 var Schab:TFeld;
     Breite:Integer;
     BRIEF:TBrief;

 PROCEDURE DREHEN(VAR NEU:TFeld;ALT:TFeld;BG:Integer);
  VAR X,Y:Integer;
  BEGIN
   FOR X:=1 TO BG DO
    FOR Y:=1 TO BG DO NEU[BG+1-Y,X]:=ALT[X,Y]
  END;

 PROCEDURE VORGABE(VAR KARTE:TFeld;VAR BG:Integer;LT:Integer);
  VAR ALT,X,Y,N,DREHEN,D,GRENZE,K:Integer;
      FELD:TFeld;
  BEGIN
   FILLCHAR(KARTE,SIZEOF(KARTE),MASSIV);{ Schablone ist massiv }
   FELD:=KARTE;BG:=TRUNC(SQRT(LT));
   IF BG*BG<LT THEN INC(BG);
   IF ODD(BG) THEN INC(BG);
   GRENZE:=BG DIV 2;
   N:=LT DIV 4;IF LT MOD 4>0 THEN INC(N);
   FOR K:=1 TO N DO { Anzahl der Lcher }
    BEGIN
     REPEAT
      X:=RANDOM(GRENZE)+1;Y:=RANDOM(GRENZE)+1;
     UNTIL FELD[X,Y]=Massiv;
     FELD[X,Y]:=LOCH;DREHEN:=RANDOM(4);
     FOR D:=1 TO DREHEN DO
      BEGIN ALT:=Y;Y:=X;X:=BG+1-ALT END;
     KARTE[X,Y]:=LOCH
    END
  END;

 PROCEDURE VERSCHLUESSELN(NACHRICHT:STRING;BG:BYTE;Brett:TFeld;VAR CODEBRIEF:TBrief);
  VAR WO,K,X,Y,L:BYTE;
  BEGIN
   WO:=0;L:=Length(NACHRICHT);
   FOR K:=1 TO 4 DO
    BEGIN
     FOR Y:=1 TO BG DO
      FOR X:=1 TO BG DO
       IF BRETT[X,Y]=Loch THEN
        BEGIN
         INC(WO);
         IF WO>L THEN BREAK;
         CODEBRIEF[X,Y]:=NACHRICHT[WO]+IntToStr(K)
        END;
     DREHEN(BRETT,BRETT,BG);
    END;
  END;

 procedure TSchablonenCode.StartClick(Sender: TObject);
  var Nachricht:String;
  begin
   Nachricht:=EditEingabe.Text;
   VERSCHLUESSELN(NACHRICHT,Breite,Schab,Brief);
   BriefAusgabe.Repaint
  end;

 procedure TSchablonenCode.AuswahlClick(Sender: TObject);
  begin
   if Auswahl.ItemIndex=0 then
    begin
     EditEingabe.MaxLength:=36;
     FILLCHAR(Schab,SIZEOF(Schab),MASSIV);
     Schab[3,1]:=Loch;Schab[4,1]:=Loch;
     Schab[5,2]:=Loch;Schab[2,3]:=Loch;
     Schab[4,3]:=Loch;Schab[1,5]:=Loch;
     Schab[4,5]:=Loch;Schab[6,5]:=Loch;
     Schab[1,6]:=Loch;Breite:=6;
    end
   else
    begin
     EditEingabe.MaxLength:=64;
     Vorgabe(Schab,Breite,Length(EditEingabe.Text));
    end;
   Ausgabe.ColCount:=Breite;
   Ausgabe.RowCount:=Breite;
   Ausgabe.Width:=Breite*26;
   Ausgabe.Height:=Breite*26;
   Ausgabe.Repaint;
   FILLCHAR(BRIEF,SIZEOF(BRIEF),'*');
   BriefAusgabe.ColCount:=Breite;
   BriefAusgabe.RowCount:=Breite;
   BriefAusgabe.Width:=Breite*26;
   BriefAusgabe.Height:=Breite*26;
   BriefAusgabe.Repaint
  end;

 procedure TSchablonenCode.FormCreate(Sender: TObject);
  begin
   randomize;
   EditEingabe.MaxLength:=36;
   FILLCHAR(BRIEF,SIZEOF(BRIEF),'*');
   FILLCHAR(Schab,SIZEOF(Schab),MASSIV);
   Schab[3,1]:=Loch;Schab[4,1]:=Loch;
   Schab[5,2]:=Loch;Schab[2,3]:=Loch;
   Schab[4,3]:=Loch;Schab[1,5]:=Loch;
   Schab[4,5]:=Loch;Schab[6,5]:=Loch;
   Schab[1,6]:=Loch;Breite:=6;
   Ausgabe.ColCount:=Breite;
   Ausgabe.RowCount:=Breite;
   Ausgabe.Width:=Breite*26;
   Ausgabe.Height:=Breite*26;
   Ausgabe.Repaint;BriefAusgabe.Repaint
  end;

 procedure TSchablonenCode.AusgabeDrawCell(Sender: TObject; Col,
                      Row: Integer; Rect: TRect; State: TGridDrawState);
  begin
   with Ausgabe.Canvas do
    begin
     Brush.Style:=bsSolid;
     Brush.Color:=clBlack;
     if Schab[Col+1,Row+1]=Massiv then FillRect(Rect)
    end;
  end;

 procedure TSchablonenCode.BriefAusgabeDrawCell(Sender: TObject; Col,
                      Row: Integer; Rect: TRect; State: TGridDrawState);
  begin
   with BriefAusgabe.Canvas do
    begin
     if Brief[Col+1,Row+1][1]<>'*' then
      begin
       Brush.Style:=bsClear;
       if Brief[Col+1,Row+1][2]='1' then Font.Color:=clRed;
       if Brief[Col+1,Row+1][2]='2' then Font.Color:=clBlue;
       if Brief[Col+1,Row+1][2]='3' then Font.Color:=clGreen;
       if Brief[Col+1,Row+1][2]='4' then Font.Color:=clAqua;
       TextOut(Rect.Left+6,Rect.Top+6,Brief[Col+1,Row+1][1])
      end
     else
      begin
       Brush.Style:=bsSolid;
       Brush.Color:=clBlack;
       FillRect(Rect)
      end
    end;
  end;

end.


