unit Schatz;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ComCtrls, Menus, Info, Regeln;

type
  TFeld=Array[0..9,0..9]of Integer;
  TSF = class(TForm)
    SpielFeld: TStringGrid;
    MainMenu: TMainMenu;
    Spiel: TMenuItem;
    Verstecken: TMenuItem;
    N1: TMenuItem;
    Beenden: TMenuItem;
    Level: TMenuItem;
    Level1: TMenuItem;
    Level2: TMenuItem;
    Level3: TMenuItem;
    Level4: TMenuItem;
    Level5: TMenuItem;
    Level6: TMenuItem;
    StatusBar: TStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure LevelClick(Sender: TObject);
    procedure VersteckenClick(Sender: TObject);
    procedure Entfernung(Col,Row:Integer);
    procedure Spielbewertung;
    procedure SpielFeldMouseDown(Sender: TObject; Button: TMouseButton;
                                 Shift: TShiftState; X, Y: Integer);
    procedure SpielFeldDrawCell(Sender: TObject; ACol, ARow: Integer;
                                Rect: TRect; State: TGridDrawState);
    procedure SpielFeldMouseMove(Sender: TObject; Shift: TShiftState;
                                 X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
    procedure BeendenClick(Sender: TObject);
    procedure InfoClick(Sender: TObject);
    procedure RegelnClick(Sender: TObject);
  private
    { Private-Deklarationen }
   Feld:TFeld;
   Schuss,Gefunden,Versuche:Integer;
   Schluss:Boolean;
   Truhe,Maulwurf,Maulwurf2:TBitMap;
  public
    { Public-Deklarationen }
  end;

var SF:TSF;

implementation

{$R *.dfm}
{$R+,Q+}

 const SchatzVersteck=20;SchatzGefunden=30;KeinSchatz=10;

 procedure TSF.FormCreate(Sender: TObject);
  begin
   Randomize;
   Versuche:=10;
   SpielFeld.Enabled:=False;
   Verstecken.Enabled:=False;
   Truhe:=TBitmap.Create;
   Truhe.LoadFromFile('Truhe.bmp');
   Truhe.Transparent:=True;
   Maulwurf:=TBitmap.Create;
   Maulwurf.LoadFromFile('Maulwurf.bmp');
   Maulwurf.Transparent:=True;
   Maulwurf2:=TBitmap.Create;
   Maulwurf2.LoadFromFile('Maulwurf2.bmp');
   Maulwurf2.Transparent:=True;
  end;

 procedure TSF.LevelClick(Sender: TObject);
  begin
   if Sender=Level1 then begin Versuche:=10;Level1.Checked:=True end;
   if Sender=Level2 then begin Versuche:=9;Level2.Checked:=True end;
   if Sender=Level3 then begin Versuche:=8;Level3.Checked:=True end;
   if Sender=Level4 then begin Versuche:=7;Level4.Checked:=True end;
   if Sender=Level5 then begin Versuche:=6;Level5.Checked:=True end;
   if Sender=Level6 then begin Versuche:=5;Level6.Checked:=True end;
   Caption:='Schatzsuche     '+IntToStr(Versuche)+' Versuche';
   Verstecken.Enabled:=True;
  end;

 procedure TSF.VersteckenClick(Sender: TObject);
  var K,x,y:Integer;
  begin
   for x:=0 to 9 do
    for y:=0 to 9 do Feld[x,y]:=0;
   SpielFeld.Repaint; // Spielfeld lschen
   for K:=1 to 4 do // Schtze verstecken
    begin
     repeat x:=random(10);y:=random(10) until Feld[x,y]=0;
     Feld[x,y]:=SchatzVersteck;
    end;
   Schuss:=0;Gefunden:=0;
   SpielFeld.Enabled:=True;
   Level.Enabled:=False;
   Verstecken.Enabled:=False;
   Schluss:=False;
  end;

 procedure TSF.Entfernung(Col,Row:Integer);
  var x,y:Integer;
      Entfernung:Extended;
      Zeile:String;
  begin
   Zeile:='Entfernungen: ';
   for x:=0 to 9 do
    for y:=0 to 9 do
     if Feld[x,y]=SchatzVersteck then
      begin
       Entfernung:=sqrt(sqr(x-Col)+sqr(y-Row));
       Zeile:=Zeile+'('+Format('%0.2f',[Entfernung])+')  ';
      end;
   StatusBar.Panels[0].Text:=Zeile;
  end;

 procedure TSF.SpielFeldMouseMove(Sender: TObject; Shift: TShiftState;
                                  X,Y: Integer);
  var ACol,ARow,Inhalt:Integer;
  begin
   SpielFeld.MouseToCell(X,Y,ACol,ARow);
   Inhalt:=Feld[ACol,ARow];
   if (Inhalt=SchatzGefunden) or (Inhalt=KeinSchatz) then Entfernung(ACol,ARow)
   else StatusBar.Panels[0].Text:='Entfernungen:';
   StatusBar.Panels[1].Text:='Koordinaten: '+'('+IntToStr(ACol)+','+IntToStr(ARow)+')';
  end;

 procedure TSF.FormMouseMove(Sender:TObject;Shift:TShiftState;X,Y: Integer);
  begin
   StatusBar.Panels[1].Text:='Koordinaten: ';
  end;

 procedure TSF.Spielbewertung;
  var x,y:Integer;
  begin
   if gefunden=4 then
    begin
     MessageDLG('Du bist ein guter Schatzjger!'+#13+'Du brauchtest nur '+
                IntToStr(Schuss)+' Versuche!',mtInformation,[mbOK],0);
     Level.Enabled:=True;
     Verstecken.Enabled:=True;
     Schluss:=True
    end
   else if Versuche=Schuss then // letzter Versuch
    begin
     MessageDLG('Du bist ein VERSAGER!',mtInformation,[mbOK],0);
     for x:=0 to 9 do
      for y:=0 to 9 do
       if Feld[x,y]=SchatzVersteck then Feld[x,y]:=SchatzGefunden;
     SpielFeld.Repaint;
     Level.Enabled:=True;
     Verstecken.Enabled:=True;
     Schluss:=True
    end
  end;

 procedure TSF.SpielFeldMouseDown(Sender: TObject; Button: TMouseButton;
                                  Shift: TShiftState; X, Y: Integer);
  var ACol,ARow:Integer;
  begin
   if Schluss then
    Begin
     MessageDlg('Das Spiel ist schon zu Ende!',mtError,[mbOk],0);
     exit
    End;
   inc(Schuss);
   SpielFeld.MouseToCell(X,Y,ACol,ARow);
   if (Feld[ACol,ARow]=SchatzGefunden) or (Feld[ACol,ARow]=KeinSchatz) then exit;
   if Feld[ACol,ARow]=0 then Feld[ACol,ARow]:=KeinSchatz
   else
    begin
     inc(Gefunden);
     Feld[ACol,ARow]:=SchatzGefunden; // SchatzVersteck gefunden
    end;
   SpielFeld.Repaint;
   Caption:='Schatzsuche     '+IntToStr(Versuche-Schuss)+' Versuch';
   if Versuche-Schuss<>1 then Caption:=Caption+'e';
   Entfernung(ACol,ARow);
   Spielbewertung;
  end;

 procedure TSF.SpielFeldDrawCell(Sender: TObject; ACol, ARow: Integer;
                                 Rect: TRect; State: TGridDrawState);
  var Inhalt:Integer;
  begin
   with SpielFeld.Canvas do
    begin
     Inhalt:=Feld[ACol,ARow];
     if Inhalt=KeinSchatz then
      if random(2)=0 then Draw(Rect.Left,Rect.Top,Maulwurf)
      else Draw(Rect.Left,Rect.Top,Maulwurf2);
     if Inhalt=SchatzGefunden then Draw(Rect.Left,Rect.Top,Truhe);
    end
  end;

 procedure TSF.BeendenClick(Sender: TObject);
  begin close end;

 procedure TSF.InfoClick(Sender: TObject);
  begin InfoBox.ShowModal end;

 procedure TSF.RegelnClick(Sender: TObject);
  begin RegelnBox.ShowModal end;

end.

