unit Schneeflocke;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Printers;

type
  TSchneeflockenkurve = class(TForm)
    Zeichnen: TButton;
    Drucken: TButton;
    XStart: TSpinEdit;
    YStart: TSpinEdit;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    RTiefe: TSpinEdit;
    StaticText4: TStaticText;
    StrichLaenge: TSpinEdit;
    Laenge: TStaticText;
    Loeschen: TButton;
    procedure ZeichnenClick(Sender: TObject);
    procedure DruckenClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure LoeschenClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Schneeflockenkurve: TSchneeflockenkurve;

implementation

{$R *.DFM}

 Type TTurtle=Record
                xPosition,yPosition:real;
                Richtung:integer;
                Pen:(up, down)
               end;

 procedure TSchneeflockenkurve.ZeichnenClick(Sender: TObject);
  Var I,XA,YA,L:Word;
      Tiefe:Byte;
      T:TTurtle;

  procedure draw(x1,y1,x2,y2:real);
   begin
    Canvas.moveto(round(x1),round(y1));
    Canvas.lineto(round(x2),round(y2))
   end;

  function innerhalb(x1,y1,x2,y2:real):boolean;
   var test:boolean;
   begin
    test:=(x1>=0.0) and (x1<=Width) and (x2>=0.0) and (x2<=Width);
    test:=test and (y1>=0.0) and (y1<=Height) and (y2>=0.0) and (y2<=Height);
    innerhalb:=test
   end;

  procedure InitTurtle(Var turtle:TTurtle);
   begin
    with turtle do
     begin xPosition:=0.0;yPosition:=0.0;Richtung:=0;Pen:=up end
   end;

  procedure MoveTo(x,y:real;Var turtle:TTurtle);
   begin
    with turtle do
     begin
      if (Pen=down) and (innerhalb(xPosition,yPosition,x,y)) then
       draw(xPosition,yPosition,x,y);
      xPosition:=x;yPosition:=y
     end
   end;

  procedure Move(l:real;Var turtle:TTurtle);
   var xNeu,yNeu:real;
   begin
    with turtle do
     begin
      xNeu:=xPosition+l*cos(Richtung/180*pi);
      yNeu:=yPosition+l*sin(Richtung/180*pi);
      if (Pen=down) and (innerhalb(xPosition,yPosition,xNEU,yNEU)) then
       draw(xPosition,yPosition,xNeu,yNeu);
      xPosition:=xNeu;yPosition:=yNeu
     end
   end;

  procedure back(l:real;Var turtle:TTurtle);
   begin move(-l,turtle) end;

  procedure TurnLeft(w:integer;Var turtle:TTurtle);
   begin turtle.Richtung:=(turtle.Richtung+w) mod 360 end;

  procedure TurnRight(w:integer;Var turtle:TTurtle);
   begin
    if turtle.Richtung-w<0 then turtle.Richtung:=360+turtle.Richtung-w
    else turtle.Richtung:=turtle.Richtung-w
   end;

  procedure TurnTo(w:integer;Var turtle:TTurtle);
   begin turtle.Richtung:=w mod 360 end;

  procedure PenUp(Var turtle:TTurtle);
   begin turtle.Pen:=up end;

  procedure PenDown(Var turtle:TTurtle);
   begin turtle.Pen:=down end;

 PROCEDURE FLOCKE(LAENGE:REAL;STUFE:Byte);
  VAR NL:REAL;
  BEGIN
   NL:=LAENGE/3;
   IF STUFE=0 THEN MOVE(LAENGE,T)
   ELSE BEGIN
         FLOCKE(NL,STUFE-1);TURNRIGHT(60,T);FLOCKE(NL,STUFE-1);TURNLEFT(120,T);
         FLOCKE(NL,STUFE-1);TURNRIGHT(60,T);FLOCKE(NL,STUFE-1)
        END
  END;{ OF FLOCKE }

  begin { TSchneeflockenkurve.ZeichnenClick }
   L:=StrToInt(StrichLaenge.Text);
   XA:=StrToInt(XStart.Text);
   YA:=StrToInt(YStart.Text);
   Canvas.Pen.Color:=clRed;
   Canvas.RecTangle(3,3,3*(ClientWidth div 4),ClientHeight-3);
   Canvas.Pen.Color:=clBlack;
   TIEFE:=StrToInt(RTiefe.Text);
   INITTURTLE(T);MOVETO(XA,YA,T);PENDOWN(T);
   FOR I:=1 TO 3 DO BEGIN FLOCKE(L,Tiefe);TURNLEFT(120,T) END;
   Drucken.Enabled:=True
  end;

 procedure TSchneeflockenkurve.DruckenClick(Sender: TObject);
  var PrnRect,ImageRect:TRect;
  begin
   Screen.Cursor:=crHourglass;
   Printer.BeginDoc;
   SetMapMode(Printer.Canvas.Handle,MM_LOMETRIC);// Umstellen auf 1/10mm
   // ACHTUNG : positive y-Werte nach OBEN!!!
   PrnRect:=Rect(100,-100,ClientWidth,-ClientHeight-100); // s.o.
   ImageRect:=Rect(0,0,3*(ClientWidth div 4),ClientHeight);
   Printer.Canvas.CopyRect(PrnRect,Canvas,ImageRect);
   Printer.EndDoc;
   Screen.Cursor:=crDefault;
  end;

 procedure TSchneeflockenkurve.FormActivate(Sender: TObject);
  begin
   StrichLaenge.MaxValue:=ClientWidth div 2;
  end;

 procedure TSchneeflockenkurve.LoeschenClick(Sender: TObject);
  begin
   Drucken.Enabled:=False;
   refresh;// canvas lschen
  end;

end.
