unit Solitair;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids, Spin;

type
  TSoli = class(TForm)
    Ausgabe: TDrawGrid;
    Start: TButton;
    Eingabe: TRadioGroup;
    BrettN: TRadioGroup;
    Anzeige: TListBox;
    Demo: TButton;
    VerZoe: TSpinEdit;
    LabelV: TLabel;
    LabelA1: TLabel;
    LabelA2: TLabel;
    CheckZiel: TCheckBox;
    LabelZ: TLabel;
    procedure EingabeClick(Sender: TObject);
    procedure AusgabeDrawCell(Sender: TObject; Col, Row: Integer;
                              Rect: TRect; State: TGridDrawState);
    procedure init;
    procedure BrettNClick(Sender: TObject);
    procedure StartClick(Sender: TObject);
    function TimeSekunden:Extended;
    procedure delay(zeit:Longint);// Pausenzeit in Millisekunden
    procedure AusgabeMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DemoClick(Sender: TObject);
    procedure VerZoeChange(Sender: TObject);
    procedure CheckZielClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var Soli: TSoli;

implementation

{$R *.DFM}
{$R+,Q+}
var  BRETT,F:ARRAY[0..120]OF INTEGER;
     R:ARRAY[1..4]OF Integer;
     PS,PR,RX,P,X1,X2:ARRAY[1..35]OF Integer;
     RT:ARRAY[1..4]OF STRING[6];
     MODUS,MAX,FI,ZIEL,AN,B,EN,MA,V,Z,Pause:Integer;
     ERFOLG,FERTIG,GESETZT:BOOLEAN;

 function TSoli.TimeSekunden:Extended;
  var H, M, S, MS : Word;
  begin
   DecodeTime(Now,H,M,S,MS);
   TimeSekunden:=3600.0*H+60.0*M+S+MS/1000
  end;

 procedure TSoli.delay(zeit:Longint);// Pausenzeit in Millisekunden
  var zeit1:Longint;
  begin
   zeit1:=GetTickCount;
   repeat Application.ProcessMessages until GetTickCount-zeit1>zeit
  end;

 procedure TSoli.init;
  var I,J:Integer;
  begin
   if Eingabe.ItemIndex=1 then FI:=1 ELSE FI:=0;
   FOR I:=0 TO 120 DO F[I]:=-1;AN:=26;B:=AN;EN:=94;
   FOR I:=1 TO 7 DO BEGIN FOR J:=0 TO 2 DO F[B+J]:=FI;B:=B+11 END;B:=46;
   FOR I:=1 TO 3 DO BEGIN FOR J:=0 TO 6 DO F[B+J]:=FI;B:=B+11 END;
   IF BrettN.ItemIndex=1 THEN
    BEGIN MAX:=36;F[36]:=FI;F[40]:=FI;F[80]:=FI;F[84]:=FI END
   ELSE BEGIN MAX:=32;F[36]:=-1;F[40]:=-1;F[80]:=-1;F[84]:=-1 END;
   IF FI=0 THEN BEGIN MODUS:=0;FI:=1 END
   ELSE BEGIN MODUS:=1;FI:=0 END;
   Ausgabe.Repaint;
  end;

 procedure TSoli.EingabeClick(Sender: TObject);
  begin Demo.Enabled:=False;Init end;

 procedure TSoli.BrettNClick(Sender: TObject);
  begin Demo.Enabled:=False;Init end;
  
 procedure TSoli.AusgabeDrawCell(Sender: TObject; Col, Row: Integer;
                                   Rect: TRect; State: TGridDrawState);
  var Nr:Integer;
  begin
   with Ausgabe.Canvas do
    begin
     Nr:=Col+11*Row+24;
     Brush.Style:=bsSolid;
     if F[Nr]=0 then
      begin
       Brush.Color:=clOlive;FillRect(Rect);
       if Nr=Ziel then
        begin
         Brush.Style:=bsClear;
         Brush.Color:=clLime;
         Ellipse(Rect.Left+8,Rect.Top+8,Rect.Right-8,Rect.Bottom-8)
        end
      end
     else
      if F[Nr]<0 then
       begin Brush.Color:=clRed;FillRect(Rect) end
      else
       begin
        Brush.Color:=clOlive;FillRect(Rect);
        Brush.Style:=bsClear;
        Brush.Color:=clBlack;
        Ellipse(Rect.Left+2,Rect.Top+2,Rect.Right-2,Rect.Bottom-2);
        if Nr=Ziel then
         begin
          Brush.Color:=clLime;
          Ellipse(Rect.Left+8,Rect.Top+8,Rect.Right-8,Rect.Bottom-8)
         end
       end;
    end;
  end;

 PROCEDURE SUCHEN(VAR FL:BOOLEAN);
  BEGIN
   FL:=FALSE;GESETZT:=TRUE;Z:=1;V:=0;
   REPEAT
    IF GESETZT THEN P[Z]:=AN-1;
    REPEAT
     IF P[Z]=EN THEN
      BEGIN
       DEC(Z);IF Z>0 THEN BEGIN F[P[Z]]:=1;F[X1[Z]]:=1;F[X2[Z]]:=0 END
      END
     ELSE BEGIN INC(P[Z]);RX[Z]:=0 END
    UNTIL (Z=0) OR (F[P[Z]]=1);
    IF Z>0 THEN
     BEGIN
      GESETZT:=FALSE;FERTIG:=FALSE;
      REPEAT
       IF RX[Z]<4 THEN
        BEGIN
         INC(RX[Z]);X1[Z]:=P[Z]+R[RX[Z]];X2[Z]:=X1[Z]+R[RX[Z]];
         IF F[X1[Z]]=1 THEN IF F[X2[Z]]=0 THEN
          BEGIN
           F[P[Z]]:=0;F[X1[Z]]:=0;F[X2[Z]]:=1;INC(V);PS[Z]:=P[Z];
           PR[Z]:=RX[Z];GESETZT:=TRUE
          END
        END
       ELSE FERTIG:=TRUE;
       IF GESETZT THEN
        IF Z<MA THEN INC(Z)
        ELSE IF (Ziel>0) AND (F[ZIEL]<>1) THEN
              BEGIN GESETZT:=FALSE;F[P[Z]]:=1;F[X1[Z]]:=1;F[X2[Z]]:=0 END
             ELSE FL:=TRUE
      UNTIL GESETZT OR FERTIG;
     END
   UNTIL (Z=0) OR FL;
  END;

 procedure TSoli.StartClick(Sender: TObject);
  var I:Integer;
      T_Sek:Extended;
      Zahl:String;
  begin
   Pause:=VerZoe.Value;LabelZ.Caption:='Ziel = '+IntToStr(Ziel);
   LabelA1.Visible:=False;LabelA2.Visible:=False;
   R[1]:=-1;R[2]:=11;R[3]:=1;R[4]:=-11;
   RT[1]:='LINKS';RT[4]:='HOCH';RT[3]:='RECHTS';RT[2]:='RUNTER';
   FOR I:=1 TO 35 DO
    BEGIN PS[I]:=0;PR[I]:=0;RX[I]:=0;P[I]:=0;X1[I]:=0;X2[I]:=0 END;
   MA:=0;FOR I:=0 TO 120 DO
    IF F[I]=1 THEN INC(MA);
   DEC(MA);BRETT:=F;Anzeige.Clear;
   Screen.Cursor:=crHourGlass;
   T_Sek:=TimeSekunden;SUCHEN(ERFOLG);
   T_Sek:=TimeSekunden-T_Sek;Str(T_Sek:0:2,Zahl);
   Screen.Cursor:=crDefault;
   Anzeige.Items.Add('Rechenzeit='+Zahl+' Sek.');
   Anzeige.Items.Add('Anzahl der Aufrufe :'+IntToStr(V));
   IF NOT ERFOLG THEN Anzeige.Items.Add('Keine Lsung !!')
   ELSE
    BEGIN
     F:=BRETT;Anzeige.Items.Add('');
     Anzeige.Items.Add(Format('%3s',['Zug'])+Format('%6s',['Von'])+
                       Format('%7s',['Wie'])+Format('%8s',['Nach']));
     FOR I:=1 TO MA DO
      BEGIN
      Anzeige.Items.Add(Format('%3d',[I])+Format('%6d',[PS[I]])+
                        Format('%8s',[RT[PR[I]]])+Format('%6d',[X2[I]]));
      END;
     Demo.Enabled:=True;
    END;
  end;

 procedure TSoli.AusgabeMouseDown(Sender: TObject; Button: TMouseButton;
                                  Shift: TShiftState; X, Y: Integer);
  var Col,Row,Nr:Integer;
  begin

   Ausgabe.MouseToCell(X,Y,Col,Row);
   Nr:=Col+Row*11+24;
   if (NR>25) AND (NR<95) AND (F[NR]>-1) Then
    Begin
     if (Shift=[ssRight]) and CheckZiel.Checked then
      begin
       Ziel:=NR;Ausgabe.Repaint;
       LabelZ.Caption:='Ziel = '+IntToStr(Ziel);
      End;
     if Shift=[ssLeft] then
      begin F[NR]:=1-F[NR];Ausgabe.Repaint end;
    End
  end;

 procedure TSoli.DemoClick(Sender: TObject);
  var I:Integer;
  begin
   F:=BRETT;Ausgabe.Repaint;Delay(Pause);
   LabelA1.Visible:=True;LabelA2.Visible:=True;
   LabelA1.Caption:=Format('%3s',['Zug'])+Format('%6s',['Von'])+
                       Format('%7s',['Wie'])+Format('%8s',['Nach']);
   FOR I:=1 TO MA DO
    BEGIN
     LabelA2.Caption:=Format('%3d',[I])+Format('%6d',[PS[I]])+
                      Format('%8s',[RT[PR[I]]])+Format('%6d',[X2[I]]);
     F[PS[I]]:=0;F[X1[I]]:=0;F[X2[I]]:=1;
     Ausgabe.Repaint;Delay(Pause);
    End
  end;

 procedure TSoli.VerZoeChange(Sender: TObject);
  begin Pause:=VerZoe.Value end;

 procedure TSoli.CheckZielClick(Sender: TObject);
  begin
   if Not CheckZiel.Checked then
    begin
     Ziel:=0;LabelZ.Caption:='Ziel = '+IntToStr(Ziel);
     Ausgabe.Repaint;
    end
  end;

 procedure TSoli.FormCreate(Sender: TObject);
  begin Demo.Enabled:=False;Init end;

end.
