unit Solitair;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids, Spin;

type
  ZUSTAND=(FREI,BESETZT,VERBOTEN);
  TSoli = class(TForm)
    Ausgabe: TDrawGrid;
    Start: TButton;
    Eingabe: TRadioGroup;
    BrettN: TRadioGroup;
    Anzeige: TListBox;
    Demo: TButton;
    VerZoe: TSpinEdit;
    LabelV: TLabel;
    LabelA1: TLabel;
    LabelA2: TLabel;
    CheckZiel: TCheckBox;
    LabelZ: TLabel;
    procedure EingabeClick(Sender: TObject);
    procedure AusgabeDrawCell(Sender: TObject; Col, Row: Integer;
                              Rect: TRect; State: TGridDrawState);
    procedure init;
    procedure BrettNClick(Sender: TObject);
    procedure StartClick(Sender: TObject);
    function TimeSekunden:Extended;
    PROCEDURE MACHZUG(ZUGNR:BYTE);
    procedure delay(zeit:Longint);// Pausenzeit in Millisekunden
    procedure AusgabeMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DemoClick(Sender: TObject);
    procedure VerZoeChange(Sender: TObject);
    procedure CheckZielClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var Soli: TSoli;

implementation

{$R *.DFM}
{$R+,Q+}
const ZUWACHS:ARRAY[1..4]OF SHORTINT=(-1,11,1,-11);
      ZUWACHSNAME:ARRAY[1..4]OF STRING[6]=('Links','Hoch','Rechts','Runter');
      ANFANGSPOSITION=26;ENDPOSITION=94;

var BRETT,FELD:ARRAY[0..120]OF ZUSTAND;
    PROTOKOLL:ARRAY[1..35]OF RECORD ZUG,RI:BYTE END;
    Pause,MAX,ZIEL,B,MA:INTEGER;
    AUFRUF:LONGINT;
    FI,MODUS:ZUSTAND;
    ERFOLG,WEITER:BOOLEAN;

 function TSoli.TimeSekunden:Extended;
  var H, M, S, MS : Word;
  begin
   DecodeTime(Now,H,M,S,MS);
   TimeSekunden:=3600.0*H+60.0*M+S+MS/1000
  end;

 procedure TSoli.delay(zeit:Longint);// Pausenzeit in Millisekunden
  var zeit1:Longint;
  begin
   zeit1:=GetTickCount;
   repeat Application.ProcessMessages until GetTickCount-zeit1>zeit
  end;

 procedure TSoli.init;
  var I,J:Integer;
  begin
   if Eingabe.ItemIndex=1 then FI:=Besetzt ELSE FI:=Frei;
   FOR I:=1 TO 35 DO
    BEGIN PROTOKOLL[I].ZUG:=0;PROTOKOLL[I].RI:=0 END;
   FOR I:=0 TO 120 DO FELD[I]:=VERBOTEN;
   B:=ANFANGSPOSITION;
   FOR I:=0 TO 6 DO
    FOR J:=0 TO 2 DO
     BEGIN FELD[11*I+ANFANGSPOSITION+J]:=FI;FELD[11*J+46+I]:=FI END;

   IF BrettN.ItemIndex=1 THEN
    BEGIN MAX:=35;Feld[36]:=FI;Feld[40]:=FI;Feld[80]:=FI;Feld[84]:=FI END
   ELSE
    BEGIN
     MAX:=31;Feld[36]:=verboten;Feld[40]:=verboten;
     Feld[80]:=verboten;Feld[84]:=verboten
    END;
   IF FI=FREI THEN BEGIN MODUS:=FREI;FI:=BESETZT END
   ELSE BEGIN MODUS:=BESETZT;FI:=FREI END;

   Ausgabe.Repaint;
  end;

 procedure TSoli.EingabeClick(Sender: TObject);
  begin Demo.Enabled:=False;Init end;

 procedure TSoli.BrettNClick(Sender: TObject);
  begin Demo.Enabled:=False;Init end;
  
 procedure TSoli.AusgabeDrawCell(Sender: TObject; Col, Row: Integer;
                                   Rect: TRect; State: TGridDrawState);
  var Nr:Integer;
  begin
   with Ausgabe.Canvas do
    begin
     Nr:=Col+11*Row+24;
     Brush.Style:=bsSolid;
     if Feld[Nr]=Frei then
      begin
       Brush.Color:=clOlive;FillRect(Rect);
       if Nr=Ziel then
        begin
         Brush.Style:=bsClear;
         Brush.Color:=clLime;
         Ellipse(Rect.Left+8,Rect.Top+8,Rect.Right-8,Rect.Bottom-8)
        end
      end
     else
      if Feld[Nr]=Verboten then
       begin Brush.Color:=clRed;FillRect(Rect) end
      else
       begin
        Brush.Color:=clOlive;FillRect(Rect);
        Brush.Style:=bsClear;
        Brush.Color:=clBlack;
        Ellipse(Rect.Left+2,Rect.Top+2,Rect.Right-2,Rect.Bottom-2);
        if Nr=Ziel then
         begin
          Brush.Color:=clLime;
          Ellipse(Rect.Left+8,Rect.Top+8,Rect.Right-8,Rect.Bottom-8)
         end
       end;
    end;
  end;

 PROCEDURE TSoli.MACHZUG(ZUGNR:BYTE);
  VAR RICHTUNG,POSITION,X1,X2:BYTE;
  BEGIN
   INC(AUFRUF);POSITION:=ANFANGSPOSITION-1;
   REPEAT
    INC(POSITION);RICHTUNG:=0;
    IF FELD[POSITION]=BESETZT THEN
     REPEAT
      INC(RICHTUNG);X1:=POSITION+ZUWACHS[RICHTUNG];X2:=X1+ZUWACHS[RICHTUNG];
      IF (FELD[X1]=BESETZT) AND (FELD[X2]=FREI) THEN
       BEGIN
        FELD[POSITION]:=FREI;FELD[X1]:=FREI;FELD[X2]:=BESETZT;
        PROTOKOLL[ZUGNR].ZUG:=POSITION;PROTOKOLL[ZUGNR].RI:=RICHTUNG;
        IF ZUGNR<MA THEN
         BEGIN
          MACHZUG(ZUGNR+1);
          IF NOT ERFOLG THEN
           BEGIN
            FELD[POSITION]:=BESETZT;FELD[X1]:=BESETZT;FELD[X2]:=FREI
           END
         END
        ELSE IF WEITER AND (FELD[ZIEL]<>BESETZT) THEN
              BEGIN
               FELD[POSITION]:=BESETZT;FELD[X1]:=BESETZT;FELD[X2]:=FREI
              END
             ELSE ERFOLG:=TRUE
       END
     UNTIL ERFOLG OR (RICHTUNG=4)
   UNTIL ERFOLG OR (POSITION=ENDPOSITION)
  END;

 procedure TSoli.StartClick(Sender: TObject);
  var I:Integer;
      T_Sek:Extended;
      Zahl:String;
  begin
   Pause:=VerZoe.Value;LabelZ.Caption:='Ziel = '+IntToStr(Ziel);
   LabelA1.Visible:=False;LabelA2.Visible:=False;
   MA:=0;FOR I:=0 TO 120 DO IF FELD[I]=BESETZT THEN INC(MA);
   DEC(MA);BRETT:=FELD;ERFOLG:=FALSE;AUFRUF:=0;
   Anzeige.Clear;
   Screen.Cursor:=crHourGlass;
   T_Sek:=TimeSekunden;MACHZUG(1);
   T_Sek:=TimeSekunden-T_Sek;Str(T_Sek:0:2,Zahl);
   Screen.Cursor:=crDefault;
   Anzeige.Items.Add('Rechenzeit='+Zahl+' Sek.');
   Anzeige.Items.Add('Anzahl der Aufrufe :'+IntToStr(AUFRUF));
   IF NOT ERFOLG THEN Anzeige.Items.Add('Keine Lsung !!')
   ELSE
    BEGIN
     Feld:=BRETT;Anzeige.Items.Add('');
     Anzeige.Items.Add(Format('%3s',['Zug'])+Format('%6s',['Von'])+
                       Format('%7s',['Wie'])+Format('%8s',['Nach']));
     FOR I:=1 TO MA DO
      BEGIN
      Anzeige.Items.Add(Format('%3d',[I])+Format('%6d',[PROTOKOLL[I].ZUG])+
                        Format('%8s',[ZUWACHSNAME[PROTOKOLL[I].RI]])+
                        Format('%6d',[PROTOKOLL[I].ZUG+2*ZUWACHS[PROTOKOLL[I].RI]]));
      END;
     Demo.Enabled:=True;
    END;
  end;

 procedure TSoli.AusgabeMouseDown(Sender: TObject; Button: TMouseButton;
                                  Shift: TShiftState; X, Y: Integer);
  var Col,Row,Nr:Integer;
  begin
   Ausgabe.MouseToCell(X,Y,Col,Row);
   Nr:=Col+Row*11+24;
   if (Nr>=ANFANGSPOSITION) AND (Nr<=ENDPOSITION) AND (FELD[Nr]<>VERBOTEN) then
    Begin
     if (Shift=[ssRight]) and CheckZiel.Checked then
      begin
       Ziel:=NR;Ausgabe.Repaint;
       LabelZ.Caption:='Ziel = '+IntToStr(Ziel);
      End;
     if Shift=[ssLeft] then
      begin
       if Feld[NR]=Frei then Feld[NR]:=Besetzt
       else if Feld[NR]=Besetzt then Feld[NR]:=Frei;
       Ausgabe.Repaint
      end;
    End
  end;

 procedure TSoli.DemoClick(Sender: TObject);
  var I:Integer;
  begin
   Feld:=BRETT;Ausgabe.Repaint;Delay(Pause);
   LabelA1.Visible:=True;LabelA2.Visible:=True;
   LabelA1.Caption:=Format('%3s',['Zug'])+Format('%6s',['Von'])+
                       Format('%7s',['Wie'])+Format('%8s',['Nach']);
   FOR I:=1 TO MA DO
    BEGIN
     LabelA2.Caption:=Format('%3d',[I])+Format('%6d',[PROTOKOLL[I].ZUG])+
                      Format('%8s',[ZUWACHSNAME[PROTOKOLL[I].RI]])+
                      Format('%6d',[PROTOKOLL[I].ZUG+2*ZUWACHS[PROTOKOLL[I].RI]]);
     FELD[PROTOKOLL[I].ZUG]:=FREI;
     FELD[PROTOKOLL[I].ZUG+ZUWACHS[PROTOKOLL[I].RI]]:=FREI;
     FELD[PROTOKOLL[I].ZUG+2*ZUWACHS[PROTOKOLL[I].RI]]:=BESETZT;
     Ausgabe.Repaint;Delay(Pause);
    End
  end;

 procedure TSoli.VerZoeChange(Sender: TObject);
  begin Pause:=VerZoe.Value end;

 procedure TSoli.CheckZielClick(Sender: TObject);
  begin
   if Not CheckZiel.Checked then
    begin
     Ziel:=0;LabelZ.Caption:='Ziel = '+IntToStr(Ziel);
     Ausgabe.Repaint;
    end
  end;

 procedure TSoli.FormCreate(Sender: TObject);
  begin Demo.Enabled:=False;Init end;

end.
