unit Springerproblem;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Grids, ExtCtrls;

type
  TSpringerRek = class(TForm)
    BrettLaenge: TSpinEdit;
    SpringerStart: TButton;
    ZeilenIndex: TSpinEdit;
    SpaltenIndex: TSpinEdit;
    LabelN: TLabel;
    LabelX: TLabel;
    LabelY: TLabel;
    Ausgabe: TStringGrid;
    LabelZeit: TLabel;
    LabelV: TLabel;
    Wahl: TRadioGroup;
    TourArt: TRadioGroup;
    procedure SpringerStartClick(Sender: TObject);
    procedure BrettLaengeChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    function TimeSekunden:Extended;
    PROCEDURE INIT;
    PROCEDURE AUSGEBEN;
    PROCEDURE SPRINGE(ZUG,XALT,YALT:BYTE);
    procedure WahlClick(Sender: TObject);
    PROCEDURE TOUR(VAR ZUG:Int64;N,XALT,YALT:BYTE;VAR ERFOLG:BOOLEAN);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  SpringerRek: TSpringerRek;

implementation

{$R *.DFM}
{$R-,Q-}

 CONST WA:ARRAY[1..8]OF Integer=(2,1,-1,-2,-2,-1,1,2);
       SE:ARRAY[1..8]OF Integer=(1,2,2,1,-1,-2,-2,-1);
 VAR N,MAX:Word;
     VERSUCH:Int64;
     ABBRUCH,FERTIG:BOOLEAN;
     BRETT,BrettAlt,FELD,FeldAlt:ARRAY[-1..22,-1..22]OF INTEGER;
     T_Sek:Extended;

 function TSpringerRek.TimeSekunden:Extended;
  var H, M, S, MS : Word;
  begin
   DecodeTime(Now,H,M,S,MS);
   TimeSekunden:=3600.0*H+60.0*M+S+MS/1000
  end;

 PROCEDURE TSpringerRek.INIT;
  VAR AN,WO,K,L:Integer;
  BEGIN
   FOR K:=-1 TO N+2 DO
    FOR L:=-1 TO N+2 DO BEGIN BRETT[K,L]:=-1;FELD[K,L]:=-1 END;
   FOR K:=1 TO N DO
    FOR L:=1 TO N DO BEGIN FELD[K,L]:=0;BRETT[K,L]:=0 END;
   if Wahl.ItemIndex=1 then
    Begin
     AN:=0;
     FOR K:=1 TO N DO
      FOR L:=1 TO N DO
       BEGIN
        FOR WO:=1 TO 8 DO
         IF BRETT[K+WA[WO],L+SE[WO]]>-1 THEN INC(AN);
        BRETT[K,L]:=AN;AN:=0
       END;
    End;
   MAX:=N*N;
   IF (WAHL.ITEMINDEX=1) AND (TOURART.ITEMINDEX=1) THEN DEC(MAX);
   FERTIG:=FALSE;ABBRUCH:=FALSE;VERSUCH:=0;
  END;

 PROCEDURE TSpringerRek.AUSGEBEN;
  VAR K,L:BYTE;
      Zahl:String;
  BEGIN
   for K:=1 to N do
    for L:=1 to N do
     if Wahl.ItemIndex=0 then Ausgabe.Cells[K,L]:=IntToStr(BRETT[K,L])
     else Ausgabe.Cells[K,L]:=IntToStr(Feld[K,L]);
   FERTIG:=TRUE;
   Screen.Cursor:=crDefault;
   LabelV.Caption:='Anzahl der Versuche = '+IntToStr(VERSUCH);
   T_Sek:=TimeSekunden-T_Sek;
   Str(T_Sek:0:2,Zahl);
   LabelZeit.Caption:='Rechenzeit= '+Zahl+' sek.';
   if Wahl.ItemIndex=0 then
    Begin
     if MessageDlgPos('Weiter suchen?',mtConfirmation,[mbyes,mbNo],0,
                       SpringerRek.Left+36+Ausgabe.Width,SpringerRek.Top+
                                    Ausgabe.Top+30)=mrno then ABBRUCH:=TRUE
     else Screen.Cursor:=crHourGlass;
     T_Sek:=TimeSekunden;
    End
  END;

 PROCEDURE TSpringerRek.TOUR(VAR ZUG:Int64;N,XALT,YALT:BYTE;VAR ERFOLG:BOOLEAN);
  VAR K,XMIN,YMIN,MIN:BYTE;
      X,Y:Integer;
  BEGIN
   ZUG:=0;
   REPEAT
    XMIN:=XALT;YMIN:=YALT;
    INC(ZUG);FELD[XALT,YALT]:=ZUG;
    BRETT[XALT,YALT]:=-1;MIN:=9;
    FOR K:=1 TO 8 DO
     BEGIN
      X:=XALT+WA[K];Y:=YALT+SE[K];
      IF BRETT[X,Y]>0 THEN
       BEGIN
        DEC(BRETT[X,Y]);
        IF MIN>BRETT[X,Y] THEN BEGIN MIN:=BRETT[X,Y];XMIN:=X;YMIN:=Y END
       END
     END;
    XALT:=XMIN;YALT:=YMIN
   UNTIL (MIN=9) OR (ZUG=MAX);
   ERFOLG:=(MIN=9) AND (ZUG=MAX);
  END;

 PROCEDURE TSpringerRek.SPRINGE(ZUG,XALT,YALT:BYTE);
  VAR K,L:BYTE; XNEU,YNEU:Integer;
  BEGIN
   IF ABBRUCH THEN EXIT; // Aussprung aus der Rekursion
   INC(VERSUCH);
   FOR K:=1 TO 8 DO
    BEGIN
     XNEU:=XALT+WA[K];YNEU:=YALT+SE[K];
     IF BRETT[XNEU,YNEU]=0 THEN
      BEGIN
       BRETT[XNEU,YNEU]:=ZUG;
       IF ZUG=MAX THEN
        BEGIN
         IF TourArt.ItemIndex=0 THEN AUSGEBEN
         ELSE
          FOR L:=1 TO 8 DO
           IF BRETT[XNEU+WA[L],YNEU+SE[L]]=1 THEN AUSGEBEN
        END
       ELSE SPRINGE(ZUG+1,XNEU,YNEU);
       BRETT[XNEU,YNEU]:=0
      END
    END;
  END;

 procedure TSpringerRek.SpringerStartClick(Sender: TObject);
  var K,L,X,Y,XN,YN,S,Z:Integer;
      Zahl:String;
      OK:BOOLEAN;
  begin
   N:=BrettLaenge.Value;
   X:=SpaltenIndex.Value;
   Y:=ZeilenIndex.Value;
   Ausgabe.Width:=26*(N+1)+4;
   Ausgabe.Height:=25*(N+1);
   Ausgabe.ColCount:=N+1;
   Ausgabe.RowCount:=N+1;
   LabelV.Caption:='Anzahl der Versuche = ';
   LabelZeit.Caption:='Rechenzeit= ';
   for S:=1 to N do Ausgabe.Cells[S,0]:=Char(64+S);
   for Z:=1 to N do Ausgabe.Cells[0,Z]:=IntToStr(Z);
   for Z:=1 to N do
    for S:=1 to N do
     Ausgabe.Cells[Z,S]:=' ';
   INIT;T_Sek:=TimeSekunden;
   if Wahl.ItemIndex=0 then
    Begin
     BRETT[X,Y]:=1;
     Screen.Cursor:=crHourGlass;
     SPRINGE(2,X,Y);
     Screen.Cursor:=crDefault;
    End
   else
    Begin
     if TourArt.ItemIndex=1 then
       FOR K:=1 TO 8 DO
        BEGIN
         FeldAlt:=Feld;BrettAlt:=Brett;
         XN:=X+WA[K];YN:=Y+SE[K];
         IF BRETT[XN,YN]>0 THEN
          BEGIN
           Feld[XN,YN]:=N*N;Brett[XN,YN]:=-1;
           TOUR(Versuch,N,X,Y,OK);
           IF OK THEN
            BEGIN
             FOR L:=1 TO 8 DO
              IF FELD[XN+WA[L],YN+SE[L]]=N*N-1 THEN Ausgeben
            END;
           Feld:=FeldAlt;Brett:=BrettAlt
          END
        END
     ELSE BEGIN
           TOUR(Versuch,N,X,Y,OK);
           if OK then Ausgeben
          END
    End;
   IF NOT FERTIG THEN
    BEGIN
     T_Sek:=TimeSekunden-T_Sek;
     Str(T_Sek:0:2,Zahl);
     LabelZeit.Caption:='Rechenzeit= '+Zahl+' sek. Es gibt keine Lsung ';
     LabelV.Caption:='Anzahl der Versuche = '+IntToStr(VERSUCH);
    END;
  end;

 procedure TSpringerRek.BrettLaengeChange(Sender: TObject);
  begin
   ZeilenIndex.MaxValue:=BrettLaenge.Value;
   SpaltenIndex.MaxValue:=BrettLaenge.Value;
  end;

 procedure TSpringerRek.FormActivate(Sender: TObject);
  begin
   ZeilenIndex.MaxValue:=BrettLaenge.Value;;
   SpaltenIndex.MaxValue:=BrettLaenge.Value;
  end;

 procedure TSpringerRek.WahlClick(Sender: TObject);
  begin
   if Wahl.ItemIndex=1 then BrettLaenge.MaxValue:=20
   else BrettLaenge.MaxValue:=8
  end;

end.


