unit OBC;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TBordComputer = class(TForm)
    LabelOBC: TLabel;
    LabelEnergy: TLabel;
    Energy: TPanel;
    LabelAF: TLabel;
    EnergyNeu: TPanel;
    Functions: TGroupBox;
    LocStarbase: TButton;
    Hyperspace: TButton;
    LocAlien: TButton;
    LabelHinweis: TLabel;
    Auswahl: TPanel;
    OK: TButton;
    Cancel: TButton;
    Bild: TImage;
    Timer: TTimer;
    TimerTausch: TTimer;
    procedure LocStarbaseClick(Sender: TObject);
    procedure LocAlienClick(Sender: TObject);
    procedure HyperspaceClick(Sender: TObject);
    procedure CancelClick(Sender: TObject);
    procedure OKClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure FarbenTausch;
    procedure FormCreate(Sender: TObject);
    procedure TimerTauschTimer(Sender: TObject);
  private
    { Private-Deklarationen }
   RestEnergie:Integer;
   Farbe,FarbListe:Array[1..9]of TColor;
  public
    { Public-Deklarationen }
  end;

var
  BordComputer: TBordComputer;

implementation
uses StarTrek;
{$R *.dfm}
{$R+,Q+}

 procedure TBordComputer.FormCreate(Sender: TObject);
  begin
   randomize;
   Farbe[1]:=clWhite;Farbe[2]:=clRed;Farbe[3]:=clYellow;
   Farbe[4]:=clGreen;Farbe[5]:=clFuchsia;Farbe[6]:=clAqua;
   Farbe[7]:=clBlue;Farbe[8]:=clBlack;Farbe[9]:=clMaroon;
   FarbListe:=Farbe;
//   Bild.Picture.Bitmap.TransparentColor:=clWhite;
  end;

 procedure TBordComputer.FormActivate(Sender: TObject);
  const Hinweis='Select function'+#13+'and then OK to'+#13+'process or'+
                #13+'Cancel to abort';
  begin
   Energy.Caption:=IntToStr(Stellar.Energie);
   EnergyNeu.Caption:='???';
   if (Stellar.Energie>=1000) and not Stellar.SektorAnzeigen then
    LocStarbase.Enabled:=True;
   if (Stellar.Energie>=2000) and not Stellar.SektorAnzeigen then
    LocAlien.Enabled:=True;
   if Stellar.Energie>=2500 then Hyperspace.Enabled:=True;
   LabelHinweis.Caption:=Hinweis;
  end;

 procedure TBordComputer.LocStarbaseClick(Sender: TObject);
  begin
   RestEnergie:=Stellar.Energie-1000;
   EnergyNeu.Caption:=IntToStr(RestEnergie);
   Stellar.LocateStarbase:=True;  
   Stellar.LocateAlien:=False;
   Stellar.EnterHyperspace:=False;
  end;

 procedure TBordComputer.LocAlienClick(Sender: TObject);
  begin
   RestEnergie:=Stellar.Energie-2000;
   EnergyNeu.Caption:=IntToStr(RestEnergie);
   Stellar.LocateAlien:=True;
   Stellar.LocateStarbase:=False;
   Stellar.EnterHyperspace:=False;
  end;

 procedure TBordComputer.HyperspaceClick(Sender: TObject);
  begin
   RestEnergie:=Stellar.Energie-2500;
   EnergyNeu.Caption:=IntToStr(RestEnergie);
   Stellar.EnterHyperspace:=True;
   Stellar.LocateStarbase:=False;
   Stellar.LocateAlien:=False;
  end;

 procedure TBordComputer.CancelClick(Sender: TObject);
  begin
   Stellar.LocateStarbase:=False;
   Stellar.LocateAlien:=False;
   Stellar.EnterHyperspace:=False;
   close
  end;

 procedure TBordComputer.OKClick(Sender: TObject);
  begin
   Stellar.Energie:=RestEnergie;
   close
  end;

 procedure TBordComputer.FarbenTausch;
  var L,M:Byte;
      T:TColor;
  begin
   L:=Random(9)+1;M:=Random(9)+1;
   T:=FarbListe[L];FarbListe[L]:=FarbListe[M];FarbListe[M]:=T
  end;

 procedure TBordComputer.TimerTimer(Sender: TObject);
  var T:TColor;
      K:Byte;
  begin
   with Bild.Canvas do
    begin
     T:=FarbListe[1];
     for K:=1 to 5 do FarbListe[K]:=FarbListe[K+1];
     FarbListe[6]:=T;
     Brush.Color:=FarbListe[1];
     Ellipse(7,7,21,21);
     Brush.Color:=FarbListe[2];
     Ellipse(35,10,49,24);
     Brush.Color:=FarbListe[3];
     Ellipse(21,14,35,28);
     Brush.Color:=FarbListe[4];
     Ellipse(3,35,17,49);
     Brush.Color:=FarbListe[5];
     Ellipse(17,28,31,42);
     Brush.Color:=FarbListe[6];
     Ellipse(35,35,49,49);
    end;
  end;

 procedure TBordComputer.TimerTauschTimer(Sender: TObject);
  begin FarbenTausch end;

end.
