unit StarTrek;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, Grids, Menus;

const HiscoreName='StarTrek.hsc';

type
  TSektor=Record
           Feld:Array[0..9,0..9]of Byte;
           X,Y,Feind,SternBasis,Besucht:Byte;
          End;
  TGalaxy=Array[0..9,0..9]of TSektor;
  TSBListe=Array[1..8]of TPoint;
  TAListe=Array[0..9,0..9]of
   Record
    Anzahl:Byte;
    Position:Array[1..3]of TPoint;
    Energie:Array[1..3]of Integer;
   end;
  TStellar = class(TForm)
    PanelStatus: TPanel;
    Navigation: TGroupBox;
    GMap: TButton;
    SRScan: TButton;
    LRScan: TButton;
    Computer: TButton;
    Antrieb: TGroupBox;
    Warp: TButton;
    Waffen: TGroupBox;
    Phaser: TButton;
    Schilde: TRadioGroup;
    Richtung: TGroupBox;
    UPLeft: TSpeedButton;
    UP: TSpeedButton;
    UPRight: TSpeedButton;
    Photon: TButton;
    Left: TSpeedButton;
    Mitte: TSpeedButton;
    Right: TSpeedButton;
    DownLeft: TSpeedButton;
    Down: TSpeedButton;
    DownRight: TSpeedButton;
    PPower: TScrollBar;
    PAnzeige: TPanel;
    LabelPhaserPower: TLabel;
    WPower: TScrollBar;
    WAnzeige: TPanel;
    LabelWarp: TLabel;
    MapAnzeige: TPanel;
    Map: TDrawGrid;
    LabelNavigation: TLabel;
    LaufLichtAnzeige: TPanel;
    LaufLicht: TDrawGrid;
    TimerLL: TTimer;
    LabelKlingonen: TLabel;
    KAnzahl: TPanel;
    LabelTorpedos: TLabel;
    TAnzahl: TPanel;
    LabelQuadrant: TLabel;
    QuadrantAnzeige: TPanel;
    LabelSector: TLabel;
    SectorAnzeige: TPanel;
    LabelEnergie: TLabel;
    EnergieAnzeige: TPanel;
    LabelAntrieb: TLabel;
    AntriebAnzeige: TPanel;
    LabelPhaser: TLabel;
    PhaserAnzeige: TPanel;
    LabelPhoton: TLabel;
    PhotonAnzeige: TPanel;
    LabelSchilde: TLabel;
    SchildeAnzeige: TPanel;
    LabelWarnung: TLabel;
    MainMenu: TMainMenu;
    Mission: TMenuItem;
    Neu: TMenuItem;
    N1: TMenuItem;
    HighScores: TMenuItem;
    Sound: TMenuItem;
    N2: TMenuItem;
    Beenden: TMenuItem;
    Kontrolle: TMenuItem;
    GalaxyMap: TMenuItem;
    LongRangeScan: TMenuItem;
    ShortRangeScan: TMenuItem;
    N3: TMenuItem;
    ComputerDisplay: TMenuItem;
    N4: TMenuItem;
    SchildZustand: TMenuItem;
    N5: TMenuItem;
    WarpAntrieb: TMenuItem;
    N6: TMenuItem;
    FeuerPhaser: TMenuItem;
    FeuerPhoton: TMenuItem;
    N7: TMenuItem;
    Missionabbrechen: TMenuItem;
    Hilfe: TMenuItem;
    Regeln: TMenuItem;
    N8: TMenuItem;
    Info: TMenuItem;
    LabelSN: TLabel;
    EditSN: TEdit;
    Abbruch: TButton;
    Level: TMenuItem;
    Kadett: TMenuItem;
    Faenrich: TMenuItem;
    Leutnant: TMenuItem;
    Kommandant: TMenuItem;
    Kapitaen: TMenuItem;
    Admiral: TMenuItem;
    procedure PPowerScroll(Sender: TObject; ScrollCode: TScrollCode;
                           var ScrollPos: Integer);
    procedure WPowerScroll(Sender: TObject; ScrollCode: TScrollCode;
                           var ScrollPos: Integer);
    procedure UPLeftClick(Sender: TObject);
    procedure UPClick(Sender: TObject);
    procedure UPRightClick(Sender: TObject);
    procedure LeftClick(Sender: TObject);
    procedure RightClick(Sender: TObject);
    procedure DownLeftClick(Sender: TObject);
    procedure DownClick(Sender: TObject);
    procedure DownRightClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MapDrawCell(Sender: TObject; ACol, ARow: Integer;
                          Rect: TRect; State: TGridDrawState);
    procedure LaufLichtDrawCell(Sender: TObject; ACol, ARow: Integer;
                                Rect: TRect; State: TGridDrawState);
    procedure TimerLLTimer(Sender: TObject);
    procedure Delay(Zeit:DWord);// Pausenzeit in Millisekunden
    procedure LRScanClick(Sender: TObject);
    procedure GMapClick(Sender: TObject);
    procedure WarpClick(Sender: TObject);
    procedure Kampf;
    procedure SRScanClick(Sender: TObject);
    procedure ZufallsPosition;
    procedure Init;
    procedure NeuClick(Sender: TObject);
    procedure BeendenClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure HighScoresClick(Sender: TObject);
    procedure GameOver;
    procedure SoundClick(Sender: TObject);
    procedure MissionabbrechenClick(Sender: TObject);
    procedure SchildZustandClick(Sender: TObject);
    procedure ComputerClick(Sender: TObject);
    procedure PhaserClick(Sender: TObject);
    procedure PhotonClick(Sender: TObject);
    procedure SpielEnde;
    procedure Sortieren(var L:TStrings);
    procedure SchildeClick(Sender: TObject);
    procedure AbbruchClick(Sender: TObject);
    procedure KadettClick(Sender: TObject);
    procedure FaenrichClick(Sender: TObject);
    procedure LeutnantClick(Sender: TObject);
    procedure KommandantClick(Sender: TObject);
    procedure KapitaenClick(Sender: TObject);
    procedure AdmiralClick(Sender: TObject);
    procedure MapMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure InfoClick(Sender: TObject);
    procedure RegelnClick(Sender: TObject);
  private
    { Private-Deklarationen }
   Licht,Aliens,Basen,Photons,ZielRichtung,SchildEnergie,TorpedoEnergie,
   Von,Bis,AnzahlBase,Punkte:Integer;
   Quadrant:TPoint;
   Sektor:TSektor;
   Galaxy:TGalaxy;
   GalaxyAnzeigen,LRAnzeigen,PhaserDefekt,PhotonDefekt,WarpDefekt:Boolean;
   StarBase,SternKlein,SternGross,SternExplosion:TBitMap;
   Enterprise,EnterpriseHit,EnterpriseInSonne,EnterpriseInAlien:TBitMap;
   Alien,Alien2,AlienHit,Alien2Hit,Torpedo:TBitMap;
   SternBasisListe:TSBListe;
   AlienListe:TAListe;
  public
    { Public-Deklarationen }
    Liste:TStrings;
    Energie:Integer;
    SektorAnzeigen,LocateStarbase,LocateAlien,EnterHyperspace:Boolean;
  end;

var
  Stellar: TStellar;

implementation

uses Hiscore,OBC,Info;
{$R *.dfm}
{$R+,Q+}

 procedure TStellar.Delay(Zeit:DWord);// Pausenzeit in Millisekunden
  var AltZeit:DWord;
  begin
   AltZeit:=GetTickCount;
   repeat Application.ProcessMessages until GetTickCount-AltZeit>Zeit
  end;

 procedure TStellar.PPowerScroll(Sender: TObject; ScrollCode: TScrollCode;
                                 var ScrollPos: Integer);
  begin
   PAnzeige.Caption:=IntToStr(PPower.Position);
  end;

 procedure TStellar.WPowerScroll(Sender: TObject; ScrollCode: TScrollCode;
                                 var ScrollPos: Integer);
  begin
   WAnzeige.Caption:=IntToStr(WPower.Position);
  end;

 procedure TStellar.UPLeftClick(Sender: TObject);
  begin
   Mitte.Glyph:=UPLeft.Glyph;
   ZielRichtung:=1;
  end;

 procedure TStellar.UPClick(Sender: TObject);
  begin
   Mitte.Glyph:=UP.Glyph;
   ZielRichtung:=2;
  end;

 procedure TStellar.UPRightClick(Sender: TObject);
  begin
   Mitte.Glyph:=UPRight.Glyph;
   ZielRichtung:=3;
  end;

 procedure TStellar.LeftClick(Sender: TObject);
  begin
   Mitte.Glyph:=Left.Glyph;
   ZielRichtung:=4;
  end;

 procedure TStellar.RightClick(Sender: TObject);
  begin
   Mitte.Glyph:=Right.Glyph;
   ZielRichtung:=5;
  end;

 procedure TStellar.DownLeftClick(Sender: TObject);
  begin
   Mitte.Glyph:=DownLeft.Glyph;
   ZielRichtung:=6;
  end;

 procedure TStellar.DownClick(Sender: TObject);
  begin
   Mitte.Glyph:=Down.Glyph;
   ZielRichtung:=7;
  end;

 procedure TStellar.DownRightClick(Sender: TObject);
  begin
   Mitte.Glyph:=DownRight.Glyph;
   ZielRichtung:=8;
  end;

 procedure TStellar.ZufallsPosition;
  var XSector,YSector:Byte;
  begin
   Quadrant.X:=Random(10);Quadrant.Y:=Random(10);
   Galaxy[Quadrant.X,Quadrant.Y].Besucht:=1;
   Sektor:=Galaxy[Quadrant.X,Quadrant.Y];
   repeat
    XSector:=Random(10);YSector:=Random(10);
   until Sektor.Feld[XSector,YSector]=0;
   Sektor.Feld[XSector,YSector]:=5; // Enterprise
   Sektor.X:=XSector;Sektor.Y:=YSector; // Position der Enterprise
   SectorAnzeige.Caption:='('+IntToStr(Sektor.X)+','+IntToStr(Sektor.Y)+')';
   QuadrantAnzeige.Caption:='('+IntToStr(Quadrant.X)+','+IntToStr(Quadrant.Y)+')';
   MapAnzeige.Color:=clScrollBar;
   LabelWarnung.Caption:='';
   GalaxyAnzeigen:=True;SektorAnzeigen:=False;LRAnzeigen:=False;
   Map.Repaint;
   if Sektor.Feind>0 then Kampf;
  end;

 procedure TStellar.Init;
  var XSector,YSector,K,X,Y:Byte;
  begin
   Kontrolle.Enabled:=True;
   Computer.Enabled:=True;
   GMap.Enabled:=True;
   LRScan.Enabled:=True;
   SRScan.Enabled:=True;
   Phaser.Enabled:=True;
   Photon.Enabled:=True;
   Warp.Enabled:=True;
   Abbruch.Enabled:=True;
   PhaserDefekt:=False;PhotonDefekt:=False;WarpDefekt:=False;
   WPower.Max:=9;
   PPower.Max:=999;
   LabelWarnung.Font.Color:=clBlack;
   GalaxyAnzeigen:=True;SektorAnzeigen:=False;LRAnzeigen:=False;
   Energie:=9999;
   TorpedoEnergie:=500;
   EnergieAnzeige.Caption:=IntToStr(Energie);
   AntriebAnzeige.Caption:='OK';
   PhaserAnzeige.Caption:='OK';
   PhotonAnzeige.Caption:='OK';
   SchildeAnzeige.Caption:='100%';
   SchildEnergie:=10000;
   Photons:=7;
   TAnzahl.Caption:=IntToStr(Photons);
   Aliens:=Random(Bis-Von)+Von; // 5 - 65 Feinde je nachLevel
   Punkte:=Aliens;
   KAnzahl.Caption:=IntToStr(Aliens);
   Basen:=AnzahlBase;               // 6 - 3 Sternbasen je nach Level
   FillChar(Galaxy,SizeOf(Galaxy),0);
   FillChar(AlienListe,SizeOf(AlienListe),0);
   for K:=1 to Aliens do
    begin
     repeat
      X:=Random(10);Y:=Random(10);
     until Galaxy[X,Y].Feind<3;
     inc(Galaxy[X,Y].Feind);
     inc(AlienListe[X,Y].Anzahl);
    end;
   for K:=1 to Basen do
    begin
     X:=Random(10);Y:=Random(10);
     inc(Galaxy[X,Y].SternBasis);
     SternBasisListe[K].X:=X;
     SternBasisListe[K].Y:=Y;
    end;
   for X:=0 to 9 do
    for Y:=0 to 9 do
     begin
      for K:=1 to Galaxy[X,Y].Feind do
       begin
        repeat
         XSector:=Random(10);YSector:=Random(10);
        until Galaxy[X,Y].Feld[XSector,YSector]=0;
        Galaxy[X,Y].Feld[XSector,YSector]:=1+10*random(2); // Alienschiff
        AlienListe[X,Y].Position[K].X:=XSector;
        AlienListe[X,Y].Position[K].Y:=YSector;
        AlienListe[X,Y].Energie[K]:=500+random(600);
       end;
      for K:=1 to Galaxy[X,Y].SternBasis do
       begin
        repeat
         XSector:=Random(10);YSector:=Random(10);
        until Galaxy[X,Y].Feld[XSector,YSector]=0;
        Galaxy[X,Y].Feld[XSector,YSector]:=2; // Sternenbasis
       end;
      for K:=1 to random(20)+15 do // Sonnenanzahl
       begin
        repeat
         XSector:=Random(10);YSector:=Random(10);
        until Galaxy[X,Y].Feld[XSector,YSector]=0;
        Galaxy[X,Y].Feld[XSector,YSector]:=3+random(2); // Sonnen gro - klein
       end;
     end;
   ZufallsPosition;
  end;

 procedure TStellar.FormCreate(Sender: TObject);
  var K:Integer;
  begin
   Application.HelpFile:='Stellar.hlp';
   Alien:=TBitMap.Create;
   Alien.LoadFromFile('Alien.bmp');
   Alien.Transparent:=True;
   AlienHit:=TBitMap.Create;
   AlienHit.LoadFromFile('AlienGetroffen.bmp');
   AlienHit.Transparent:=True;
   Alien2:=TBitMap.Create;
   Alien2.LoadFromFile('Alien2.bmp');
   Alien2.Transparent:=True;
   Alien2Hit:=TBitMap.Create;
   Alien2Hit.LoadFromFile('Alien2Getroffen.bmp');
   Alien2Hit.Transparent:=True;
   StarBase:=TBitMap.Create;
   StarBase.LoadFromFile('StarBase.bmp');
   StarBase.Transparent:=True;
   SternKlein:=TBitMap.Create;
   SternKlein.LoadFromFile('SternKlein.bmp');
   SternKlein.Transparent:=True;
   SternGross:=TBitMap.Create;
   SternGross.LoadFromFile('SternGross.bmp');
   SternGross.Transparent:=True;
   SternExplosion:=TBitMap.Create;
   SternExplosion.LoadFromFile('SternExplosion.bmp');
   SternExplosion.Transparent:=True;
   Enterprise:=TBitMap.Create;
   Enterprise.LoadFromFile('Enterprise.bmp');
   Enterprise.Transparent:=True;
   EnterpriseHit:=TBitMap.Create;
   EnterpriseHit.LoadFromFile('Enterprise getroffen.bmp');
   EnterpriseHit.Transparent:=True;
   EnterpriseInSonne:=TBitMap.Create;
   EnterpriseInSonne.LoadFromFile('Enterprise in Sonne.bmp');
   EnterpriseInSonne.Transparent:=True;
   EnterpriseInAlien:=TBitMap.Create;
   EnterpriseInAlien.LoadFromFile('Enterprise in Alien.bmp');
   EnterpriseInAlien.Transparent:=True;
   Torpedo:=TBitMap.Create;
   Torpedo.LoadFromFile('Torpedo.bmp');
   Torpedo.Transparent:=True;
   randomize;Licht:=4;ZielRichtung:=0;
   PanelStatus.Caption:='Dein Zug, '+EditSN.Text;
   Liste:=TStringList.Create;
   try
    Liste.LoadFromFile(HiscoreName);
   except
    MessageDlg('Datei '+HiscoreName+' nicht gefunden!',mtError,[mbOk],0);
    for K:=1 to 10 do
     Liste.Add('20 -      Seven of Nine');
   end;
   Von:=5;Bis:=15;AnzahlBase:=6;
   Init;
  end;

 procedure TStellar.GameOver;
  begin
   Kontrolle.Enabled:=False;
   Computer.Enabled:=False;
   GMap.Enabled:=False;
   LRScan.Enabled:=False;
   SRScan.Enabled:=False;
   Phaser.Enabled:=False;
   Photon.Enabled:=False;
   Warp.Enabled:=False;
   Abbruch.Enabled:=False;
  end;

 procedure TStellar.MapDrawCell(Sender: TObject; ACol, ARow: Integer;
                                Rect: TRect; State: TGridDrawState);
  var Klingonen,HQ:Byte;
  begin
   with Map.Canvas do
    begin
     if (ACol=10) or (ARow=10) then
      begin
       Brush.Color:=clMaroon;
       Brush.Style:=bsSolid;
       FillRect(Rect);
       Font.Color:=clWhite;
       Font.Style:=[fsBold];
       if ARow=10 then
        if ACol<10 then TextOut(Rect.Left+8,Rect.Top+6,IntToStr(ACol));
       if ACol=10 then
        if ARow<10 then TextOut(Rect.Left+8,Rect.Top+6,IntToStr(ARow));
      end
     else
      begin
       Brush.Color:=clScrollBar;
       Brush.Style:=bsSolid;
       FillRect(Rect);
       if GalaxyAnzeigen then
        begin
         if Galaxy[ACol,ARow].Besucht=1 then
          begin
           if (ACol=Quadrant.X) and (ARow=Quadrant.Y) then
            begin
             Brush.Color:=clYellow;
             Brush.Style:=bsSolid;
             FillRect(Rect);
            end;
           Klingonen:=Galaxy[ACol,ARow].Feind;
           HQ:=Galaxy[ACol,ARow].SternBasis;
           if Klingonen>0 then Font.Color:=clRed
           else if HQ>0 then Font.Color:=clWhite
           else if (ACol=Quadrant.X) and (ARow=Quadrant.Y) then Font.Color:=clBlue
           else Font.Color:=clBlack;
           Font.Style:=[fsBold];
           TextOut(Rect.Left+4,Rect.Top+6,IntToStr(Klingonen)+IntToStr(HQ));
          end
        end;
       if LRAnzeigen then
        begin
         if Galaxy[ACol,ARow].Besucht=2 then
          begin
           if (ACol=Quadrant.X) and (ARow=Quadrant.Y) then
            begin
             Brush.Color:=clYellow;
             Brush.Style:=bsSolid;
             FillRect(Rect);
            end;
           Klingonen:=Galaxy[ACol,ARow].Feind;
           HQ:=Galaxy[ACol,ARow].SternBasis;
           if Klingonen>0 then Font.Color:=clRed
           else if HQ>0 then Font.Color:=clWhite
           else if (ACol=Quadrant.X) and (ARow=Quadrant.Y) then Font.Color:=clBlue
           else Font.Color:=clBlack;
           Font.Style:=[fsBold];
           TextOut(Rect.Left+4,Rect.Top+6,IntToStr(Klingonen)+IntToStr(HQ));
          end
        end;
       if SektorAnzeigen then
        begin
         Brush.Color:=clScrollBar;
         Brush.Style:=bsSolid;
         FillRect(Rect);
         if Sektor.Feld[ACol,ARow]=1 then Draw(Rect.Left,Rect.Top,Alien);
         if Sektor.Feld[ACol,ARow]=2 then Draw(Rect.Left,Rect.Top,StarBase);
         if Sektor.Feld[ACol,ARow]=3 then Draw(Rect.Left,Rect.Top,SternKlein);
         if Sektor.Feld[ACol,ARow]=4 then Draw(Rect.Left,Rect.Top,SternGross);
         if Sektor.Feld[ACol,ARow]=5 then Draw(Rect.Left,Rect.Top,Enterprise);
         if Sektor.Feld[ACol,ARow]=6 then Draw(Rect.Left,Rect.Top,EnterpriseInSonne);
         if Sektor.Feld[ACol,ARow]=7 then Draw(Rect.Left,Rect.Top,EnterpriseInAlien);
         if Sektor.Feld[ACol,ARow]=8 then Draw(Rect.Left,Rect.Top,AlienHit);
         if Sektor.Feld[ACol,ARow]=9 then Draw(Rect.Left,Rect.Top,Alien2Hit);
         if Sektor.Feld[ACol,ARow]=10 then Draw(Rect.Left,Rect.Top,EnterpriseHit);
         if Sektor.Feld[ACol,ARow]=11 then Draw(Rect.Left,Rect.Top,Alien2);
         if Sektor.Feld[ACol,ARow]=12 then Draw(Rect.Left,Rect.Top,Torpedo);
         if Sektor.Feld[ACol,ARow]=13 then Draw(Rect.Left,Rect.Top,SternExplosion);
        end
      end
    end;
  end;

 procedure TStellar.LaufLichtDrawCell(Sender: TObject; ACol, ARow: Integer;
                                      Rect: TRect; State: TGridDrawState);
  begin
   with LaufLicht.Canvas do
    begin
     Brush.Color:=clMaroon;
     if (ACol=Licht) or (ACol=9-Licht) then Brush.Color:=clRed;
     Brush.Style:=bsSolid;
     FillRect(Rect);
    end
  end;

 procedure TStellar.TimerLLTimer(Sender: TObject);
  begin
   dec(Licht);
   if Licht<-1 then Licht:=4;
   LaufLicht.Repaint;
  end;

 procedure TStellar.LRScanClick(Sender: TObject);
  var X,Y:Integer;
  begin
   PanelStatus.Caption:='Dein Zug, '+EditSN.Text;
   Warp.Caption:='Warp';
   Dec(Energie,50);
   EnergieAnzeige.Caption:=IntToStr(Energie);
   if Energie<0 then
    begin
     MapAnzeige.Color:=clBlack;
     LabelWarnung.Font.Color:=clRed;
     LabelWarnung.Caption:='Die Mission ist gescheitert!';
     GameOver;
     exit
    end;
   for X:=-1 to 1 do
    for Y:=-1 to 1 do
     if (X+Quadrant.X>=0) and (X+Quadrant.X<=9) and
        (Y+Quadrant.Y>=0) and (Y+Quadrant.Y<=9) then
         Galaxy[X+Quadrant.X,Y+Quadrant.Y].Besucht:=2;
   MapAnzeige.Color:=clScrollBar;
   LabelWarnung.Caption:='';
   LabelNavigation.Caption:='Long-Range Scan';
   LRAnzeigen:=True;GalaxyAnzeigen:=False;SektorAnzeigen:=False;
   Map.Repaint;
   for X:=-1 to 1 do
    for Y:=-1 to 1 do
     if (X+Quadrant.X>=0) and (X+Quadrant.X<=9) and
        (Y+Quadrant.Y>=0) and (Y+Quadrant.Y<=9) then
         Galaxy[X+Quadrant.X,Y+Quadrant.Y].Besucht:=1;
  end;

 procedure TStellar.GMapClick(Sender: TObject);
  begin
   PanelStatus.Caption:='Die bekannte Galaxie!';
   Warp.Caption:='Warp';
   MapAnzeige.Color:=clScrollBar;
   LabelWarnung.Caption:='';
   LabelNavigation.Caption:='Galaxy Map';
   GalaxyAnzeigen:=True;SektorAnzeigen:=False;LRAnzeigen:=False;
   Map.Repaint;
  end;

 procedure TStellar.Kampf; // Alien schiet auf Enterprise
  var AlienPosition:TPoint;
      K,AlienEnergie,X1,Y1,X2,Y2:Integer;
  begin
   GalaxyAnzeigen:=False;SektorAnzeigen:=True;
   LRAnzeigen:=False;LRScan.Enabled:=False;
   Warp.Caption:='Ionen';
   Map.Repaint;
   MapAnzeige.Color:=clRed;
   LabelWarnung.Caption:='roter Alarm';
   if SchildEnergie>0 then
    begin
     Schilde.ItemIndex:=0;
     PanelStatus.Caption:='Schilde sind aktiviert!!';
    end
   else
    begin
     Schilde.ItemIndex:=1;
     PanelStatus.Caption:='Schilde sind ausgefallen!!';
    end;
   Delay(1000);
   for K:=1 to AlienListe[Quadrant.X,Quadrant.Y].Anzahl do
    if AlienListe[Quadrant.X,Quadrant.Y].Energie[K]>0 then
     begin
      AlienPosition:=AlienListe[Quadrant.X,Quadrant.Y].Position[K];
      AlienEnergie:=random(400)+100;
      PanelStatus.Caption:='Alien auf ('+IntToStr(AlienPosition.X)+'|'+
      IntToStr(AlienPosition.Y)+') schiet mit '+
      IntToStr(AlienEnergie)+' Energie!';
      Delay(1000);
      Sektor.Feld[Sektor.X,Sektor.Y]:=10; // Enterprise wird getroffen
      Map.Repaint;
      X1:=13+Sektor.X*26;
      Y1:=13+Sektor.Y*26;
      X2:=13+AlienPosition.X*26;
      Y2:=13+AlienPosition.Y*26;
      Map.Canvas.Pen.Color:=clRed;
      Map.Canvas.MoveTo(X1,Y1);Map.Canvas.LineTo(X2,Y2);
      Delay(500);
      if random(5)>0 then
       begin
        PanelStatus.Caption:='Schilde getroffen mit '+IntToStr(3*AlienEnergie div 4);
        SchildEnergie:=SchildEnergie-3*AlienEnergie div 4;
        if random(100)>50 then // Engines
         begin
          AntriebAnzeige.Caption:='beschdigt';
          WarpDefekt:=True;
          WPower.Max:=WPower.Max-2;
          if WPower.Max<1 then WPower.Max:=1;
          if StrToInt(WAnzeige.Caption)>WPower.Max then
           WAnzeige.Caption:=IntToStr(WPower.Max)
         end;
        if (random(100)>50) and (AlienEnergie>200) then // Phasers
         begin
          PhaserAnzeige.Caption:='beschdigt';
          if PPower.Max>200 then PPower.Max:=PPower.Max-200
          else PPower.Max:=10;
          if StrToInt(PAnzeige.Caption)>PPower.Max then
           PAnzeige.Caption:=IntToStr(PPower.Max);
          if PPower.Max<11 then PhaserDefekt:=True;
         end;
        if (random(100)>50) and (AlienEnergie>200) then // Photon
         begin
          PhotonAnzeige.Caption:='beschdigt';
          inc(TorpedoEnergie,200);
          if TorpedoEnergie>1000 then PhotonDefekt:=True;
         end;
       end
      else PanelStatus.Caption:='Alien schiet vorbei!';
      if SchildEnergie<=0 then
       begin
        SchildeAnzeige.Caption:='zerstrt';
        Schilde.ItemIndex:=1;
       end
      else
       begin
        SchildeAnzeige.Caption:=IntToStr(SchildEnergie div 100)+'%';
        Sektor.Feld[Sektor.X,Sektor.Y]:=5;
        Map.Repaint;
       end
     end;
   LRScan.Enabled:=True;
  end;

 procedure TStellar.WarpClick(Sender: TObject);
  const Richtung:Array[1..8]of TPoint=
                            ((X:-1;Y:-1),(X: 0;Y:-1),(X:+1;Y:-1),(X:-1;Y: 0),
                             (X:+1;Y: 0),(X:-1;Y:+1),(X: 0;Y:+1),(X:+1;Y:+1));
  var Neu:TPoint;
      Speed,XSector,YSector:Integer;
  begin
   Speed:=StrToInt(WAnzeige.Caption);
   if Speed=0 then exit;
   if not SektorAnzeigen then
    begin
     Schilde.ItemIndex:=1;
     PanelStatus.Caption:='Der Schutzschild ist deaktiviert!!';
    end;
   Delay(1000);
   if SektorAnzeigen then Dec(Energie,StrToInt(WAnzeige.Caption)*10)
   else Dec(Energie,StrToInt(WAnzeige.Caption)*103);
   EnergieAnzeige.Caption:=IntToStr(Energie);
   if Energie<-10 then
    begin
     MapAnzeige.Color:=clBlack;
     LabelWarnung.Font.Color:=clRed;
     LabelWarnung.Caption:='Die Mission ist gescheitert!';
     GameOver;
     exit
    end;
   if GalaxyAnzeigen or LRAnzeigen then
    begin
     Neu.X:=Quadrant.X+Speed*Richtung[ZielRichtung].X;
     Neu.Y:=Quadrant.Y+Speed*Richtung[ZielRichtung].Y;
    end
   else
    begin // SektorAnzeigen
     Neu.X:=Sektor.X+Speed*Richtung[ZielRichtung].X;
     Neu.Y:=Sektor.Y+Speed*Richtung[ZielRichtung].Y;
    end;
   if (Neu.X>=0) and (Neu.X<=9) and (Neu.Y>=0) and (Neu.Y<=9) then
    begin
     if SektorAnzeigen then PanelStatus.Caption:='Ionenantrieb erfolgreich!'
     else PanelStatus.Caption:='Warp erfolgreich!';
     if GalaxyAnzeigen or LRAnzeigen then
      begin
       Quadrant:=Neu;
       QuadrantAnzeige.Caption:='('+IntToStr(Quadrant.X)+','+IntToStr(Quadrant.Y)+')';
       Galaxy[Quadrant.X,Quadrant.Y].Besucht:=1;
       Sektor:=Galaxy[Quadrant.X,Quadrant.Y];
       repeat
        XSector:=Random(10);YSector:=Random(10);
       until Sektor.Feld[XSector,YSector]=0;
       Sektor.Feld[XSector,YSector]:=5; // Enterprise
       Sektor.X:=XSector;Sektor.Y:=YSector; // Position der Enterprise
       SectorAnzeige.Caption:='('+IntToStr(Sektor.X)+','+IntToStr(Sektor.Y)+')';
       LabelNavigation.Caption:='Galaxy Map';
       GalaxyAnzeigen:=True;SektorAnzeigen:=False;LRAnzeigen:=False;
       Map.Repaint;
       if Sektor.Feind>0 then Kampf
      end
     else
      begin // im selben Sektor
       Sektor.Feld[Sektor.X,Sektor.Y]:=0; // Platz rumen
       Sektor.X:=Neu.X;Sektor.Y:=Neu.Y;
       if (Sektor.Feld[Sektor.X,Sektor.Y]=0) or (Sektor.Feld[Sektor.X,Sektor.Y]=2) then
        begin
         if Sektor.Feld[Sektor.X,Sektor.Y]=2 then // Andocken an Starbase
          begin
           Energie:=9999;
           EnergieAnzeige.Caption:=IntToStr(Energie);
           AntriebAnzeige.Caption:='OK';
           PhaserAnzeige.Caption:='OK';
           PhotonAnzeige.Caption:='OK';
           PhaserDefekt:=False;PhotonDefekt:=False;
           WarpDefekt:=False;
           WPower.Max:=9;
           PPower.Max:=999;
           TorpedoEnergie:=500;
           SchildeAnzeige.Caption:='100%';
           SchildEnergie:=10000;
           Photons:=7;
           TAnzahl.Caption:=IntToStr(Photons);
          end;
         Sektor.Feld[Sektor.X,Sektor.Y]:=5;    
         GalaxyAnzeigen:=False;SektorAnzeigen:=True;LRAnzeigen:=False;
         Map.Repaint;
         if Sektor.Feind>0 then Kampf
        end
       else
        begin // die Enterprise ist zerstrt
         if Sektor.Feld[Sektor.X,Sektor.Y]>2 then
          begin
           PanelStatus.Caption:='Die NCC 1701 materialisierte in einer Sonne!';
           MapAnzeige.Color:=clPurple;
           LabelWarnung.Caption:='Die Enterprise ist verglht!';
           Sektor.Feld[Sektor.X,Sektor.Y]:=6; // Enterprise in Sonne
           GalaxyAnzeigen:=False;SektorAnzeigen:=True;LRAnzeigen:=False;
           Map.Repaint;
          end;
         if Sektor.Feld[Sektor.X,Sektor.Y]=1 then
          begin
           PanelStatus.Caption:='Die NCC 1701 stie mit einem UFO zusammen!';
           MapAnzeige.Color:=clPurple;
           LabelWarnung.Caption:='Du hast ein Alien gerammt!';
           Sektor.Feld[Sektor.X,Sektor.Y]:=7; // Enterprise in Alien
           GalaxyAnzeigen:=False;SektorAnzeigen:=True;LRAnzeigen:=False;
           Map.Repaint;
          end;
         GameOver;
        end;
       SectorAnzeige.Caption:='('+IntToStr(Sektor.X)+','+IntToStr(Sektor.Y)+')';
      end
    end
  end;

 procedure TStellar.SRScanClick(Sender: TObject);
  begin
   PanelStatus.Caption:='Dein Sektor!';
   Warp.Caption:='Ionen';
   GalaxyAnzeigen:=False;SektorAnzeigen:=True;LRAnzeigen:=False;
   Map.Repaint;
   LabelNavigation.Caption:='Short-Range Scan';
   if Sektor.Feind=0 then
    begin
     MapAnzeige.Color:=clGreen;
     LabelWarnung.Caption:='Sektor normal';
    end
   else
    begin
     MapAnzeige.Color:=clRed;
     LabelWarnung.Caption:='roter Alarm';
     Kampf
    end
  end;

 procedure TStellar.NeuClick(Sender: TObject);
  begin
   if (Aliens>0) and Kontrolle.Enabled then
    begin
     if MessageDlg('Willst du wirklich aufgeben?',mtConfirmation,[mbYes, mbNo],0)=mrYes then
      begin
       MessageDlg('Die Mission wird beendet...',mtInformation,[mbOk],0);
       Init;PanelStatus.Caption:='Dein Zug, '+EditSN.Text;
      end
    end
   else
    begin
     Init;
     PanelStatus.Caption:='Dein Zug, '+EditSN.Text
    end
  end;

 procedure ListeZeigen;
  begin
   HSL.ShowModal;
  end;

 procedure TStellar.BeendenClick(Sender: TObject);
  begin close end;

 procedure TStellar.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  begin
   if MessageDlg('Beenden?',mtConfirmation,[mbYes,mbNo],0)=mrYes then
    begin
     ListeZeigen;
     try
      Liste.SaveToFile(HiscoreName);
     except
       MessageDlg('Datei '+HiscoreName+' kann nicht gespeichert werden!',mtError,[mbOk],0);
      end;
     CanClose:=True
    end
   else CanClose:=False
  end;

 procedure TStellar.HighScoresClick(Sender: TObject);
  begin ListeZeigen end;

 procedure TStellar.SoundClick(Sender: TObject);
  begin Sound.Checked:=not Sound.Checked end;

 procedure TStellar.MissionabbrechenClick(Sender: TObject);
  begin
   if MessageDlg('Willst du wirklich aufgeben?',mtConfirmation,[mbYes, mbNo],0)=mrYes then
    begin
     MessageDlg('Die Mission wird beendet...',mtInformation,[mbOk],0);
     GameOver;
    end;
  end;

 procedure TStellar.SchildZustandClick(Sender: TObject);
  begin Schilde.ItemIndex:=1-Schilde.ItemIndex end;

 procedure TStellar.ComputerClick(Sender: TObject);
  var K,Index,X1,Y1,X,Y:Byte;
      Entfernung,Minimum:Extended;
      Rect:TRect;
  begin
   PanelStatus.Caption:='Die Hal2002 wird aktiviert!';
   Dec(Energie,100);
   EnergieAnzeige.Caption:=IntToStr(Energie);
   if Energie<0 then
    begin
     MapAnzeige.Color:=clBlack;
     LabelWarnung.Font.Color:=clRed;
     LabelWarnung.Caption:='Die Mission ist gescheitert!';
     GameOver;
     exit
    end;
   LocateStarbase:=False;LocateAlien:=False;EnterHyperspace:=False;
   BordComputer.LocStarbase.Enabled:=False;
   BordComputer.LocAlien.Enabled:=False;
   BordComputer.Hyperspace.Enabled:=False;
   BordComputer.ShowModal;
   EnergieAnzeige.Caption:=IntToStr(Energie);
   PanelStatus.Caption:='Dein Zug, '+EditSN.Text;
   if LocateStarbase then
    begin
     Minimum:=1000;Index:=0;
     for K:=1 to Basen do
      begin
       Entfernung:=Sqrt(sqr(SternBasisListe[K].X-Quadrant.X)+
                        sqr(SternBasisListe[K].Y-Quadrant.Y));
       if Entfernung<=Minimum then
        begin Minimum:=Entfernung;Index:=K end;
      end;
     if Minimum<1000 then
      begin
       Rect:=Map.CellRect(SternBasisListe[Index].X,SternBasisListe[Index].Y);
       Map.Canvas.Brush.Color:=clBlue;
       Map.Canvas.Brush.Style:=bsSolid;
       Map.Canvas.FillRect(Rect);
       Map.Canvas.Pen.Color:=clWhite;
       Map.Canvas.Rectangle(Rect);
       PanelStatus.Caption:='Starbase geortet!';
      end
    end;
   if LocateAlien then
    begin
     Minimum:=1000;X1:=0;Y1:=0;
     for X:=0 to 9 do
      for Y:=0 to 9 do
       if AlienListe[X,Y].Anzahl>0 then
        begin
         Entfernung:=Sqrt(sqr(X-Quadrant.X)+sqr(Y-Quadrant.Y));
         if Entfernung<=Minimum then
          begin Minimum:=Entfernung;X1:=X;Y1:=Y end;
        end;
     if Minimum<1000 then
      begin
       Rect:=Map.CellRect(X1,Y1);
       Map.Canvas.Brush.Color:=clRed;
       Map.Canvas.Brush.Style:=bsSolid;
       Map.Canvas.FillRect(Rect);
       Map.Canvas.Pen.Color:=clBlack;
       Map.Canvas.Rectangle(Rect);
       PanelStatus.Caption:='Alien geortet!';
      end
    end;
   if EnterHyperspace then
    begin
     PanelStatus.Caption:='In neuen Quadranten vorgedrungen!';
     ZufallsPosition;
    end
  end;

 procedure TStellar.Sortieren(var L:TStrings);
  var sortiert:Boolean;
      K:Integer;
      Tausch:String;
  begin
   repeat
    sortiert:=True;
    for K:=0 to L.Count-2 do
     if L[K]<L[K+1] then
      begin
       Tausch:=L[K];
       L[K]:=L[K+1];
       L[K+1]:=Tausch;
       sortiert:=False;
      end
   until sortiert
  end;

 procedure TStellar.SpielEnde;
  var Minimum:Integer;
      Zeile:String;
  begin
   LabelWarnung.Font.Color:=clBlue;
   LabelWarnung.Color:=clYellow;
   LabelWarnung.Caption:='Die Mission ist erfllt!';
   GameOver;
   Zeile:=Liste[Liste.Count-1];
   Minimum:=StrToInt(copy(Zeile,1,Pos(' ',Zeile)-1));
   if Minimum<Punkte then // Punkte sind IMMER 2-stellig
    begin
     Liste.Add(IntToStr(Punkte)+' - '+Format('%20s',[EditSN.Text]));
     Sortieren(Liste);
     Liste.Delete(Liste.Count-1);
     ListeZeigen
    end;
  end;

 procedure TStellar.PhaserClick(Sender: TObject);
  var K,X1,Y1,X2,Y2,NCCEnergie,Inhalt:Integer;
      AlienPosition:TPoint;
  begin
   if GalaxyAnzeigen or LRAnzeigen then
    begin
     PanelStatus.Caption:='Den Phaser kannst du nur im Sektor benutzen!';
     exit
    end;
   if PhaserDefekt then
    begin
     PanelStatus.Caption:='Der Phaser ist beschdigt!';
     exit
    end;
   if Energie<StrToInt(PAnzeige.Caption) then
    begin
     PanelStatus.Caption:='Nicht gengend Energie fr den Phaser vorhanden!';
     exit;
    end;
   if Galaxy[Quadrant.X,Quadrant.Y].Feind=0 then
    begin
     PanelStatus.Caption:='Keine Feinde in diesem Quadranten!';
     Dec(Energie,10);
     EnergieAnzeige.Caption:=IntToStr(Energie);
     exit;
    end;
   Dec(Energie,StrToInt(PAnzeige.Caption));
   EnergieAnzeige.Caption:=IntToStr(Energie);
   NCCEnergie:=StrToInt(PAnzeige.Caption) div AlienListe[Quadrant.X,Quadrant.Y].Anzahl;
   PanelStatus.Caption:='Enterprise feuert mit '+IntToStr(NCCEnergie)+' Energie';
   // Enterprise feuert auf alle feindliche Schiffe
   for K:=1 to AlienListe[Quadrant.X,Quadrant.Y].Anzahl do
    if AlienListe[Quadrant.X,Quadrant.Y].Energie[K]>0 then
     begin
      AlienPosition:=AlienListe[Quadrant.X,Quadrant.Y].Position[K];
      Dec(AlienListe[Quadrant.X,Quadrant.Y].Energie[K],NCCEnergie);
      PanelStatus.Caption:='Enterprise feuert auf Alien ('+
                  IntToStr(AlienPosition.X)+'|'+IntToStr(AlienPosition.Y)+')';
      Delay(1000);
      Inhalt:=Sektor.Feld[AlienPosition.X,AlienPosition.Y];
      if Inhalt=11 then Sektor.Feld[AlienPosition.X,AlienPosition.Y]:=9
      else Sektor.Feld[AlienPosition.X,AlienPosition.Y]:=8;
      Map.Repaint;
      X1:=13+Sektor.X*26;
      Y1:=13+Sektor.Y*26;
      X2:=13+AlienPosition.X*26;
      Y2:=13+AlienPosition.Y*26;
      Map.Canvas.Pen.Color:=clAqua;
      Map.Canvas.MoveTo(X1,Y1);Map.Canvas.LineTo(X2,Y2);
      Delay(500);
      if AlienListe[Quadrant.X,Quadrant.Y].Energie[K]<0 then
       begin
        PanelStatus.Caption:='Alien auf ('+IntToStr(AlienPosition.X)+'|'+
        IntToStr(AlienPosition.Y)+') vernichtet';
        Delay(2000);
        Dec(Aliens);
        KAnzahl.Caption:=IntToStr(Aliens);
        AlienListe[Quadrant.X,Quadrant.Y].Position[K].X:=-1; // vernichtet
        Sektor.Feld[AlienPosition.X,AlienPosition.Y]:=0;
        Dec(Sektor.Feind);
        if Sektor.Feind=0 then
         begin
          Galaxy[Quadrant.X,Quadrant.Y].Feind:=0;
          MapAnzeige.Color:=clGreen;
          LabelWarnung.Caption:='Sektor normal';
          PanelStatus.Caption:='Dein Zug, '+EditSN.Text;
         end;
        Map.Repaint;
        if Aliens=0 then
         begin
          SpielEnde;
          exit;
         end
       end
      else
       begin
        Sektor.Feld[AlienPosition.X,AlienPosition.Y]:=Inhalt;
        Map.Repaint;
       end
     end;
   // Aliens schieen zurck
   if Sektor.Feind>0 then Kampf;
  end;

 procedure TStellar.PhotonClick(Sender: TObject);
   const Richtung:Array[1..8]of TPoint=
                            ((X:-1;Y:-1),(X: 0;Y:-1),(X:+1;Y:-1),(X:-1;Y: 0),
                             (X:+1;Y: 0),(X:-1;Y:+1),(X: 0;Y:+1),(X:+1;Y:+1));
  var Neu:TPoint;
      K,L,Inhalt,InhaltSumme:Integer;
  begin
   if GalaxyAnzeigen or LRAnzeigen then
    begin
     PanelStatus.Caption:='Den Torpedo kannst du nur im Sektor benutzen!';
     exit
    end;
   if PhotonDefekt then
    begin
     PanelStatus.Caption:='Der Photontorpedo ist beschdigt!';
     exit
    end;
   if Photons=0 then
    begin
     PanelStatus.Caption:='Keine Torpedos vorhanden!';
     exit
    end;
   if Energie<TorpedoEnergie then
    begin
     PanelStatus.Caption:='Nicht gengend Energie fr den Torpedo vorhanden!';
     exit;
    end;
   if ZielRichtung=0 then
    begin
     PanelStatus.Caption:='Zielrichtung eingeben!';
     exit;
    end;
   if GalaxyAnzeigen or LRAnzeigen then
    begin
     PanelStatus.Caption:='Den Torpedo kannst du nur im Sektor benutzen!';
     exit
    end;
   Dec(Energie,TorpedoEnergie);
   EnergieAnzeige.Caption:=IntToStr(Energie);
   Dec(Photons);
   TAnzahl.Caption:=IntToStr(Photons);
   InhaltSumme:=0;
   for K:=1 to 9 do
    begin
     Neu.X:=Sektor.X+K*Richtung[ZielRichtung].X;
     Neu.Y:=Sektor.Y+K*Richtung[ZielRichtung].Y;
     if (Neu.X>=0) and (Neu.X<=9) and (Neu.Y>=0) and (Neu.Y<=9) then
      begin
       Inhalt:=Sektor.Feld[Neu.X,Neu.Y];
       inc(InhaltSumme,Inhalt);
       Sektor.Feld[Neu.X,Neu.Y]:=12; // Torpedo
       Map.Repaint;Delay(500);
       if Inhalt=0 then
        begin
         Sektor.Feld[Neu.X,Neu.Y]:=Inhalt; // restaurieren
         Map.Repaint;Delay(500);
        end;
       if (Inhalt=1) or (Inhalt=11) then // Alien
        begin
         PanelStatus.Caption:='Alien auf ('+IntToStr(Neu.X)+'|'+IntToStr(Neu.Y)
                              +') vernichtet!';
         Delay(2000);
         dec(Aliens);
         KAnzahl.Caption:=IntToStr(Aliens);
         for L:=1 to AlienListe[Quadrant.X,Quadrant.Y].Anzahl do
          if (AlienListe[Quadrant.X,Quadrant.Y].Position[L].X=Neu.X) and
             (AlienListe[Quadrant.X,Quadrant.Y].Position[L].Y=Neu.Y)then
           begin
            AlienListe[Quadrant.X,Quadrant.Y].Position[L].X:=-1; // vernichtet
            AlienListe[Quadrant.X,Quadrant.Y].Energie[L]:=-1;
            dec(Aliens);
            KAnzahl.Caption:=IntToStr(Aliens);
           end;
         Sektor.Feld[Neu.X,Neu.Y]:=0;
         Dec(Sektor.Feind);
         if Sektor.Feind=0 then
          begin
           Galaxy[Quadrant.X,Quadrant.Y].Feind:=0;
           MapAnzeige.Color:=clGreen;
           LabelWarnung.Caption:='Sektor normal';
           PanelStatus.Caption:='Dein Zug, '+EditSN.Text;
          end;
         Map.Repaint;
         Break;
        end;
       if Inhalt=2 then
        begin
         PanelStatus.Caption:='Starbase vernichtet!';
         Sektor.Feld[Neu.X,Neu.Y]:=Inhalt; // restaurieren
         Map.Repaint;Delay(500);
         if Aliens=0 then
          begin
           SpielEnde;
           exit;
          end;
         Break;
        end;
       if (Inhalt=3) or (Inhalt=4) then // Sterne
        begin
         PanelStatus.Caption:='Torpedo landet in einer Sonne!';
         Sektor.Feld[Neu.X,Neu.Y]:=13; // Sternexplosion
         Map.Repaint;Delay(1000);
         Sektor.Feld[Neu.X,Neu.Y]:=Inhalt; // restaurieren
         Map.Repaint;Delay(500);
         Break
        end;
      end
    end;
   if InhaltSumme=0 then PanelStatus.Caption:='Der Torpedo landet im Nirwana!';
   // Aliens schieen zurck
   if Sektor.Feind>0 then Kampf;
  end;

 procedure TStellar.SchildeClick(Sender: TObject);
  begin
   if Schilde.ItemIndex=0 then
    PanelStatus.Caption:='Der Schutzschild ist aktiviert!!';
   if Schilde.ItemIndex=1 then
    PanelStatus.Caption:='Der Schutzschild ist deaktiviert!!';
  end;

 procedure TStellar.AbbruchClick(Sender: TObject);
  var x,y:Byte;
  begin
   if MessageDlg('Willst du wirklich abbrechen?',mtConfirmation,[mbYes, mbNo],0)=mrYes then
    begin
     MessageDlg('Die Mission wird abgebrochen...',mtInformation,[mbOk],0);
     PanelStatus.Caption:='die gesamte Galaxie';
     for X:=0 to 9 do
      for Y:=0 to 9 do Galaxy[X,Y].Besucht:=1;
     GalaxyAnzeigen:=True;SektorAnzeigen:=False;LRAnzeigen:=False;
     Map.Repaint;
     GameOver;
    end
  end;

 procedure TStellar.KadettClick(Sender: TObject);
  begin
   Kadett.Checked:=True;
   Von:=5;Bis:=15;AnzahlBase:=6;
  end;

 procedure TStellar.FaenrichClick(Sender: TObject);
  begin
   Faenrich.Checked:=True;
   Von:=15;Bis:=25;AnzahlBase:=5;
  end;

 procedure TStellar.LeutnantClick(Sender: TObject);
  begin
   Leutnant.Checked:=True;
   Von:=25;Bis:=35;AnzahlBase:=5;
  end;

 procedure TStellar.KommandantClick(Sender: TObject);
  begin
   Kommandant.Checked:=True;
   Von:=35;Bis:=45;AnzahlBase:=4;
  end;

 procedure TStellar.KapitaenClick(Sender: TObject);
  begin
   Kapitaen.Checked:=True;
   Von:=45;Bis:=55;AnzahlBase:=4;
  end;

 procedure TStellar.AdmiralClick(Sender: TObject);
  begin
   Admiral.Checked:=True;
   Von:=55;Bis:=65;AnzahlBase:=3;
  end;

procedure TStellar.MapMouseDown(Sender: TObject; Button: TMouseButton;
                                Shift: TShiftState; X, Y: Integer);
 var ACol,ARow:Integer;
 begin
  if (Button=mbRight) and GalaxyAnzeigen then
   begin
    Map.MouseToCell(X,Y,ACol,ARow);
    GalaxyAnzeigen:=False;SektorAnzeigen:=True;LRAnzeigen:=False;
    Sektor:=Galaxy[ACol,ARow];
    Map.Repaint;Delay(1000);
    GalaxyAnzeigen:=True;SektorAnzeigen:=False;LRAnzeigen:=False;
    Map.Repaint;
   end
 end;

 procedure TStellar.InfoClick(Sender: TObject);
  begin
   InfoBox.ShowModal;
  end;

 procedure TStellar.RegelnClick(Sender: TObject);
  begin
   Application.HelpJump('HelpIndex');
  end;

end.

