unit SuchselGenerator;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, Menus, Printers;

const MaxX=19;MaxY=19;
      Wechsel:Array[1..4]of TPoint=((X:-1;Y:1),(X:0;Y:1),(X:1;Y:1),(X:1;Y:0));
type
  TFeld=Array[0..MaxX,0..MaxY]of Char;
  TSuchsel = class(TForm)
    Ausgabe: TStringGrid;
    MainMenu: TMainMenu;
    Datei: TMenuItem;
    Oeffnen: TMenuItem;
    N1: TMenuItem;
    Beenden1: TMenuItem;
    Drucken: TMenuItem;
    Verstecken: TMenuItem;
    DateiLesen: TOpenDialog;
    DateiSpeichern: TSaveDialog;
    PrintDialog: TPrintDialog;
    Editor: TMenuItem;
    LabelS: TLabel;
    SuchListe: TListBox;
    Suchsel: TMenuItem;
    LadenS: TMenuItem;
    SpeichernS: TMenuItem;
    DruckenS: TMenuItem;
    Hilfe: TMenuItem;
    Info: TMenuItem;
    N2: TMenuItem;
    Anleitung: TMenuItem;
    procedure Einordnen(N:Integer);
    function TimeSekunden:Extended;
    procedure Anzeigen;
    procedure Fuellen;
    procedure FormCreate(Sender: TObject);
    procedure VersteckenClick(Sender: TObject);
    procedure OeffnenClick(Sender: TObject);
    procedure EditorClick(Sender: TObject);
    procedure SuchListeClick(Sender: TObject);
    procedure Suche(Wort:String);
    procedure AusgabeDrawCell(Sender: TObject; ACol, ARow: Integer;
                              Rect: TRect; State: TGridDrawState);
    procedure LadenSClick(Sender: TObject);
    procedure SpeichernSClick(Sender: TObject);
    procedure InfoClick(Sender: TObject);
    procedure AnleitungClick(Sender: TObject);
    procedure DruckenSClick(Sender: TObject);
  private
    { Private-Deklarationen }
   Feld:TFeld;
   Antwort:Word;
   Liste:TStrings;
  public
    { Public-Deklarationen }
  end;

var
  Suchsel: TSuchsel;

implementation

uses WortEditor, Info, Regeln;

{$R *.dfm}
{$R+,Q+}

 function TSuchsel.TimeSekunden:Extended;
  var H, M, S, MS : Word;
  begin
   DecodeTime(Now,H,M,S,MS);
   TimeSekunden:=3600.0*H+60.0*M+1.0*S+MS/1000
  end;

 procedure TSuchsel.Anzeigen;
  var x,y:Integer;
  begin
   for x:=0 to MaxX do
    for y:=0 to MaxY do Ausgabe.Cells[x,y]:=Feld[x,y];
  end;

 procedure TSuchsel.Fuellen;
  var x,y:Integer;
  begin
   for x:=0 to MaxX do
    for y:=0 to MaxY do
     if Feld[x,y]='.' then Feld[x,y]:=Char(random(26)+65);
  end;

 procedure TSuchsel.Einordnen(N:Integer);
  var Wort:String;
      Unmoeglich,Zufrieden,Rueckwaerts,Erlaubt:Boolean;
      Richtung,Laenge,K,XZufall,YZufall,XGrenze,YGrenze,X,Y:Integer;
      TimeSek:Extended;
      Puffer:TFeld;
  begin
   Unmoeglich:=False;
   repeat
    TimeSek:=TimeSekunden;
    repeat
     Rueckwaerts:=False;Richtung:=Random(8)+1;
     if Richtung>4 then begin Richtung:=Richtung-4;Rueckwaerts:=True end;
     Wort:=Liste[N];Laenge:=Length(Wort);
     if Rueckwaerts then
      for K:=1 to Laenge do Wort[K]:=Liste[N][Laenge+1-K]; // umdrehen
     case Richtung of
       1 : begin
            XZufall:=Random(MaxX-Laenge);
            YZufall:=MaxY-Random(MaxY-Laenge);
           end;
       2 : begin
            XZufall:=Random(MaxX-Laenge);
            YZufall:=Random(MaxY);
           end;
       3 : begin
            XZufall:=Random(MaxX-Laenge);
            YZufall:=Random(MaxY-Laenge);
           end;
       4 : begin
            XZufall:=Random(MaxX);
            YZufall:=Random(MaxY-Laenge);
           end;
      end;
      XGrenze:=XZufall+Wechsel[Richtung].X*(Laenge-1);
      YGrenze:=YZufall+Wechsel[Richtung].Y*(Laenge-1);
      Erlaubt:=(XGrenze>=0) and (XGrenze<=MaxX) and
               (YGrenze>=0) and (YGrenze<=MaxY);
      if Erlaubt then
       begin
        for K:=0 to Laenge-1 do
         begin
          X:=XZufall+K*Wechsel[Richtung].X;
          Y:=YZufall+K*Wechsel[Richtung].Y;
          if (Feld[X,Y]<>Wort[K+1]) and (Feld[X,Y]<>'.') then Erlaubt:=False;
         end
       end;
     if not Erlaubt and (TimeSekunden-TimeSek>2.0) then Unmoeglich:=True
    until Erlaubt or Unmoeglich;
    if Unmoeglich then exit;
    Puffer:=Feld;
    for K:=0 to Laenge-1 do
     begin
      X:=XZufall+K*Wechsel[Richtung].X;
      Y:=YZufall+K*Wechsel[Richtung].Y;
      Feld[x,y]:=Wort[K+1];
     end;
    Anzeigen;
    Zufrieden:=True;
    if Antwort<>mrYesToAll then
     Antwort:=MessageDlg('Zufrieden?',mtConfirmation,[mbYes,mbNo,mbYesToAll],0);
    if Antwort=mrNo then Zufrieden:=False;
    if Zufrieden then
     begin
      for K:=0 to Laenge-1 do
       begin
        X:=XZufall+K*Wechsel[Richtung].X;
        Y:=YZufall+K*Wechsel[Richtung].Y;
        Feld[X,Y]:=Wort[K+1]
       end;
      SuchListe.Items.Add(Liste[N]);
     end
    else begin Feld:=Puffer;Anzeigen end;
   until Zufrieden;
  end;

 procedure TSuchsel.VersteckenClick(Sender: TObject);
  var K:Integer;
  begin
   Antwort:=mrNo;
   SuchListe.Clear;
   FillChar(Feld,SizeOf(Feld),'.');
   Anzeigen;
   Screen.Cursor:=crHourGlass;
   for K:=0 to Liste.Count-1 do
    Einordnen(K);
   Screen.Cursor:=crDefault;
   Fuellen;Anzeigen;
  end;

 procedure TSuchsel.FormCreate(Sender: TObject);
  begin
   randomize;
   Liste:=TStringList.Create;
  end;

 procedure TSuchsel.OeffnenClick(Sender: TObject);
  begin
   with DateiLesen do
    begin
     Filter:='Suchseldateien (*.txt) |*.txt';
     DefaultExt:='txt';
     if Execute then
       Liste.LoadFromFile(Filename);
    end
  end;

 procedure TSuchsel.EditorClick(Sender: TObject);
  begin
   BegriffEditor.ShowModal;
  end;

 procedure TSuchsel.Suche(Wort:String);
  const Richtung:Array[1..8]of TPoint=((X:-1;Y: 1),(X: 0;Y: 1),
                                       (X: 1;Y: 1),(X: 1;Y: 0),
                                       (X: 1;Y:-1),(X: 0;Y:-1),
                                       (X:-1;Y:-1),(X:-1;Y: 0));
  var x,y,K,L,Anzahl,XNeu,YNeu:Integer;
      ok,Erlaubt:Boolean;
  begin
   for x:=0 to MaxX do
    for y:=0 to MaxY do
     if Feld[x,y]=Wort[1] then
      begin
       for K:=1 to 8 do
        begin
         Anzahl:=2;
         repeat
          XNeu:=x+(Anzahl-1)*Richtung[K].X;
          YNeu:=y+(Anzahl-1)*Richtung[K].Y;
          Erlaubt:=(XNeu>=0) and (XNeu<=MaxX) and (YNeu>=0) and (YNeu<=MaxX);
          ok:=Erlaubt and (Feld[XNeu,YNeu]=Wort[Anzahl]);
          inc(Anzahl);
         until not ok or (Anzahl>Length(Wort));
         if ok then
          begin
           for L:=0 to Length(Wort)-1 do
            begin
             XNeu:=x+L*Richtung[K].X;
             YNeu:=y+L*Richtung[K].Y;
             Feld[XNeu,YNeu]:=AnsiLowerCase(Wort[L+1])[1];
            end;
           Ausgabe.repaint
          end
        end
      end
  end;

 procedure TSuchsel.SuchListeClick(Sender: TObject);
  var Nr:Integer;
      Wort:String;
      Puffer:TFeld;
  begin
   Nr:=SuchListe.ItemIndex;
   Wort:=SuchListe.Items[Nr];
   Puffer:=Feld;
   Suche(Wort);
   Feld:=Puffer;
  end;

 procedure TSuchsel.AusgabeDrawCell(Sender: TObject; ACol, ARow: Integer;
                                    Rect: TRect; State: TGridDrawState);
  const Klein='qwertzuiopasdfghjklyxcvbnm';
  begin
   with Ausgabe.Canvas do
    begin
     Font.Color:=clBlack;Brush.Color:=clWhite;
     if pos(Feld[ACol,Arow],Klein)>0 then
      begin Font.Color:=clYellow;Brush.Color:=clBlue end;
     FillRect(Rect);
     TextOut(Rect.Left+8,Rect.Top+6,Ausgabe.Cells[ACol,ARow]);
    end
  end;

 procedure TSuchsel.LadenSClick(Sender: TObject);
  var SucListe:TStrings;
      Zeile:String;
      x,y:Integer;
  begin
   SucListe:=TStringList.Create;
   with DateiLesen do
    begin
     Filter:='Suchseldateien (*.suc) |*.suc';
     DefaultExt:='suc';
     if Execute then
      begin
       SucListe.LoadFromFile(Filename);
       y:=0;SuchListe.Clear;
       while SucListe[0]<>'%' do
        begin
         Zeile:=SucListe[0]; // immer MaxX Zeichen lang!
         for x:=0 to MaxX do Feld[x,y]:=Zeile[x+1];
         inc(y);SucListe.Delete(0);
        end;
       Anzeigen;
       SucListe.Delete(0); // '%' wird gelscht
       for x:=0 to SucListe.Count-1 do
        SuchListe.Items.Add(SucListe[x]);
      end;
    end;
   SucListe.Free;
  end;

 procedure TSuchsel.SpeichernSClick(Sender: TObject);
  var SucListe:TStrings;
      Zeile:String;
      x,y:Integer;
  begin
   SucListe:=TStringList.Create;
   with DateiSpeichern do
    begin
     Filter:='Suchseldateien (*.suc) |*.suc';
     DefaultExt:='suc';
     if Execute then
      begin
       for y:=0 to MaxY do
        begin
         Zeile:='';
         for x:=0 to MaxX do Zeile:=Zeile+Feld[x,y];
         SucListe.Add(Zeile);
        end;
       SucListe.Add('%'); // SuchselEndeMarkierung
       for x:=0 to SuchListe.Items.Count-1 do
        SucListe.Add(SuchListe.Items[x]); // Suchbegriffe
       SucListe.SaveToFile(Filename);
      end;
    end;
   SucListe.Free;
  end;

 procedure TSuchsel.InfoClick(Sender: TObject);
  begin
   InfoBox.ShowModal;
  end;

 procedure TSuchsel.AnleitungClick(Sender: TObject);
  begin
   RegelnBox.ShowModal;
  end;

 procedure TSuchsel.DruckenSClick(Sender: TObject);
  const maxzeilen  = 57;
        texthoehe  = 40;   //  4 mm
        linkerRand = 100;  // 10 mm
        obererRand = 120;  // 10 mm
        Leer='                              ';
  var Zeile,K,x,y: Integer;
      Autor,Name,TextZeile:String;
      w,v:TSize;
      OUTDC:HDC;
      Heute:TDateTime;
      Jahr,Monat,Tag:Word;
  begin
   if SuchListe.Items.Count=0 then
    begin
     MessageDlg('Es gibt NICHTS zu drucken!!',mtError,[mbOk],0);
     exit;
    end;
   Heute:=Now;
   DecodeDate(Heute,Jahr,Monat,Tag);
   Autor:='Fiete '+IntToStr(Jahr);
   Name:='Suchsel';
   if PrintDialog.Execute then
    begin
     Printer.BeginDoc;
     outDC:=Printer.Canvas.Handle;
     setmapmode(OutDC,mm_lometric);     // 1/10 mm aber Y geht nach oben
     GetWindowExtEx(OutDC,w);           // Auflsung ermitteln
     GetViewportExtEx(OutDC,v);
     setmapmode(OutDC,MM_ANISOTROPIC);         // neuer Abb.-Modus
     SetWindowExtEX(OutDC,w.cx,w.cy,nil);      // Skalierung ...
     SetViewPortExtEx(OutDC,v.cx,-v.cy,nil);
     Printer.Canvas.Font.Name:='Courier New';
     Printer.Canvas.Brush.Color:=clwhite;   // Hintergrundfarbe
     Printer.Canvas.Font.Height:=texthoehe;
     Printer.Canvas.Font.Style:=[fsbold];  // Kopfzeile
     Printer.Canvas.TextOut(linkerRand,obererRand,Name+'  by '+Autor);
     Printer.Canvas.Font.style:=[];
     zeile:=0;
     for y:=0 to MaxY do
      begin
       TextZeile:='';
       for x:=0 to MaxX do TextZeile:=TextZeile+Feld[x,y]+' ';
       inc(zeile);
       Printer.Canvas.TextOut(linkerRand,obererRand+Zeile*(texthoehe+3),TextZeile);
      end;
     TextZeile:=' '; // Abstand zu Begriffen
     for x:=1 to 3 do
      begin
       inc(Zeile);
       Printer.Canvas.TextOut(linkerRand,obererRand+Zeile*(texthoehe+3),TextZeile);
      end;
     inc(Zeile);TextZeile:='Deine Suchbegriffe:';
     Printer.Canvas.TextOut(linkerRand,obererRand+Zeile*(texthoehe+3),TextZeile);
     inc(Zeile);TextZeile:=' ';
     Printer.Canvas.TextOut(linkerRand,obererRand+Zeile*(texthoehe+3),TextZeile);
     TextZeile:='';
     For K:=0 to SuchListe.Items.Count-1 do
      Begin
       TextZeile:=TextZeile+SuchListe.Items[K]+
                  Copy(Leer,1,30-Length(SuchListe.Items[K]));
       if K mod 3=2 then
        begin
         inc(zeile);
         Printer.Canvas.TextOut(linkerRand,obererRand+Zeile*(texthoehe+3),TextZeile);
         TextZeile:='';
        end;
      End;
     if TextZeile<>'' then
      begin
       inc(zeile);
       Printer.Canvas.TextOut(linkerRand,obererRand+Zeile*(texthoehe+3),TextZeile);
      end;
     Printer.EndDoc;
    end
  end;

end.

