unit Weltraumspiel;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, Grids, Spin, StdCtrls, ExtCtrls, Mmsystem, ComCtrls;

 const LobMax=10;HiscoreName='Weltraum.hsc';
       AnzMaxRaeume=99;AnzLevel=99;AnzahlSterne=1000;FMax=15;
       Farben:Array[1..FMax]of TColor=(clBlue, clGreen,  clRed,    clYellow,
                                       clAqua, clFuchsia,clGray,   clTeal,
                                       clLime, clLtGray, clMaroon, clNavy,
                                       clOlive,clPurple, clSilver);

       Lob:ARRAY[1..LobMax]of String=
                ('prima','sehr gut','wow, good','exellent','very nice',
                 'weiter so','klasse','genial','sagenhaft','ultimativ');
type
 DatenRec=Record             // Daten fr Level im Byte-Format
           Zeile:ARRAY[0..7]of Byte;
           x,y:Byte;
          End;
 DatenArray=Record          //  alle Level im Bit-kodierten Format
             Kennung:String[13];
             Level:Array[1..AnzMaxRaeume]of DatenRec; // alle Level
            End;
 LevelRec = RECORD         // entschlsseltes Format
             Feld:Array[-2..9,-2..9]of Byte;
             x,y:Integer;
            End;
  TWeltraum = class(TForm)
    RaumAnzeige: TDrawGrid;
    MainMenu: TMainMenu;
    Spiel: TMenuItem;
    neustarten: TMenuItem;
    Bestenliste: TMenuItem;
    N1: TMenuItem;
    Beenden: TMenuItem;
    LabelSN: TLabel;
    LabelStartLevel: TLabel;
    EditSN: TEdit;
    SpinEditLevel: TSpinEdit;
    Start: TMenuItem;
    Editor: TMenuItem;
    TimerSterne: TTimer;
    TimerBonus: TTimer;
    Abbruch: TMenuItem;
    Optionen: TMenuItem;
    Sound: TMenuItem;
    Leveldatei: TMenuItem;
    DateiLesen: TOpenDialog;
    Hilfe: TMenuItem;
    About: TMenuItem;
    N2: TMenuItem;
    Info: TMenuItem;
    Status: TStatusBar;
    procedure CopyRight;
    procedure CopyRightName(var Name:String);
    procedure ListeZeigen;
    procedure LevelErzeugen(Raum:Byte);
    procedure DrawSterne;
    procedure SterneErneuern;
    procedure SterneFlimmern;
    procedure Sortieren(var L:TStrings);
    procedure Spielende;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure BeendenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BestenlisteClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure RaumAnzeigeDrawCell(Sender:TObject;ACol,ARow:Integer;
                                  Rect:TRect;State:TGridDrawState);
    procedure FormKeyDown(Sender:TObject;var Key:Word;Shift:TShiftState);
    procedure StartClick(Sender: TObject);
    procedure SpinEditLevelChange(Sender: TObject);
    procedure TimerSterneTimer(Sender: TObject);
    procedure TimerBonusTimer(Sender: TObject);
    procedure AbbruchClick(Sender: TObject);
    procedure SoundClick(Sender: TObject);
    procedure LeveldateiClick(Sender: TObject);
    procedure InfoClick(Sender: TObject);
    procedure AboutClick(Sender: TObject);
    procedure EditorClick(Sender: TObject);
  private
    { Private-Deklarationen }
   Punkte,LevelNr,Bonus,Leben,AnzahlFelder,GeraeumteFelder,Ebene:Integer;
   SterneBewegen:Boolean;
   Sterne:Array[1..AnzahlSterne]of TPoint;
   BildDaten:DatenArray;
   Level:LevelRec;
   Figur:TBitMap;
   Geheim:String;
  public
    { Public-Deklarationen }
   Liste:TStrings;
  end;

var Weltraum: TWeltraum;

 implementation

uses Hiscore, Info, Regeln, Editor, Passwort;

{$R *.dfm}
{$R+,Q+}

{****************************************************************************}
{*                         Geheimzahl berechnen                             *}
{****************************************************************************}
 procedure TWeltraum.CopyRight;
  var Name:String;
      K,LA:Byte;
  Begin
   RandSeed:=3062;Name:='D_';Geheim:='';LA:=223;
   for K:=1 to 6 do
    Geheim:=Geheim+char(32+(ord(Name[K])-Random(LA)+LA-32) mod LA);
  End;

 procedure TWeltraum.CopyRightName(var Name:String);
  var I:Byte; Code:String;
  begin
   RandSeed:=13;Code:='zы';Name:='';
   for I:=1 to Length(Code) do
    Name:=Name+char((ord(Code[I])-random(128)) and 255);
  end;

 procedure TWeltraum.ListeZeigen;
  var HiscoreDLG:THSL;
  begin
   HiscoreDLG:=THSL.Create(Weltraum);
   HiscoreDLG.ShowModal;
   HiscoreDLG.Free;
  end;

 procedure TWeltraum.LevelErzeugen(Raum:Byte);        // Level entschlsseln
  const Wert:Array[0..7]of Byte=(128, 64, 32, 16, 8, 4, 2, 1);
  var x,y:Integer;
  Begin
   Level.x:=BildDaten.Level[Raum].x;                  // Startposition
   Level.y:=BildDaten.Level[Raum].y;
   For x := -2 to 9 do
    For y := -2 to 9 do Level.Feld[x,y]:=0;           // Rahmen
   For x := 0 to 7 do
    For y := 0 to 7 do
     if (BildDaten.Level[Raum].Zeile[x] and Wert[y])>0 then
      Level.Feld[x,y]:=random(FMax)+1;
  End;

 procedure TWeltraum.FormCreate(Sender: TObject);
  var K:Integer;
      Heute:TDateTime;
      Jahr,Monat,Tag:Word;
      Wer:String;
  begin
   Heute:=Now;
   DecodeDate(Heute,Jahr,Monat,Tag);
   CopyRightName(Wer);
   if Wer<>'Fiete' then
    begin
     MessageDlg(' Du hast das  verletzt!!!!',mtError,[mbOk],0);
     Application.Terminate
    end;
   CopyRight;
   randomize;Liste:=TStringList.Create;
   try
    Liste.LoadFromFile(HiscoreName);
   except
    MessageDlg('Datei '+HiscoreName+' nicht gefunden!',mtError,[mbOk],0);
    for K:=1 to 10 do
     Liste.Add('1000 -        Mllmeister');
   end;
   Figur:=TBitMap.Create;
   Figur.LoadFromFile('Smily.bmp');
   Figur.Transparent:=True;
   SterneBewegen:=False;
   BildDaten.Kennung:='keine';
  end;

 procedure TWeltraum.FormDestroy(Sender: TObject);
  begin Liste.Free end;

 procedure TWeltraum.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  begin
   if MessageDlg('Beenden?',mtConfirmation,[mbYes,mbNo],0)=mrYes then
    begin
     ListeZeigen;
     try
      Liste.SaveToFile(HiscoreName);
     except
       MessageDlg('Datei '+HiscoreName+' kann nicht gespeichert werden!',mtError,[mbOk],0);
      end;
     CanClose:=True
    end
   else CanClose:=False
  end;

 procedure TWeltraum.BeendenClick(Sender: TObject);
  begin close end;

 procedure TWeltraum.BestenlisteClick(Sender: TObject);
  begin ListeZeigen end;

 procedure TWeltraum.RaumAnzeigeDrawCell(Sender:TObject;ACol,ARow:Integer;
                                         Rect:TRect;State:TGridDrawState);
  var Vorn,Oben,Rechts:Array[1..4]of TPoint;
      dX,dY,MX,MY,Radius:Integer;
  begin
   with RaumAnzeige.Canvas do
    begin
     dX:=(Rect.Right-Rect.Left)div 8;
     dY:=(Rect.Bottom-Rect.Top)div 8;
     MX:=Rect.Left+4*dX+4;MY:=Rect.Top+4*dY-4;Radius:=8;
     Vorn[1].X:=Rect.Left+dX;Vorn[1].Y:=Rect.Top+5*dY;
     Vorn[2].X:=Rect.Left+5*dX;Vorn[2].Y:=Rect.Top+5*dY;
     Vorn[3].X:=Rect.Left+5*dX;Vorn[3].Y:=Rect.Top+6*dY;
     Vorn[4].X:=Rect.Left+dX;Vorn[4].Y:=Rect.Top+6*dY;
     Oben[1].X:=Rect.Left+4*dX;Oben[1].Y:=Rect.Top+2*dY;
     Oben[2].X:=Rect.Left+8*dX;Oben[2].Y:=Rect.Top+2*dY;
     Oben[3].X:=Rect.Left+5*dX;Oben[3].Y:=Rect.Top+5*dY;
     Oben[4].X:=Rect.Left+dX;Oben[4].Y:=Rect.Top+5*dY;
     Rechts[1].X:=Rect.Left+8*dX;Rechts[1].Y:=Rect.Top+2*dY;
     Rechts[2].X:=Rect.Left+8*dX;Rechts[2].Y:=Rect.Top+3*dY;
     Rechts[3].X:=Rect.Left+5*dX;Rechts[3].Y:=Rect.Top+6*dY;
     Rechts[4].X:=Rect.Left+5*dX;Rechts[4].Y:=Rect.Top+5*dY;
     Brush.Style:=bsSolid;
     Brush.Color:=clBlack;
     Pen.Color:=clWhite;
     FillRect(Rect);
     if Level.Feld[ACol,ARow]>0 then
      begin
       Brush.Color:=Farben[Level.Feld[ACol,ARow]];
       Polygon(Vorn);Polygon(Oben);Polygon(Rechts);
      end;
     if (Level.x=ACol) and (Level.y=ARow) then
      begin
       if BildDaten.Kennung<>'keine' then Draw(MX-Radius,MY-Radius,Figur);
//       Brush.Color:=clWhite;
//       Ellipse(MX-Radius,MY-Radius,MX+Radius,MY+Radius);
      end;
     if not RaumAnzeige.Enabled then SterneErneuern;
    end;
  end;

 procedure TWeltraum.Sortieren(var L:TStrings);
  var sortiert:Boolean;
      K:Integer;
      Tausch:String;
  begin
   repeat
    sortiert:=True;
    for K:=0 to L.Count-2 do
     if L[K]<L[K+1] then
      begin
       Tausch:=L[K];
       L[K]:=L[K+1];
       L[K+1]:=Tausch;
       sortiert:=False;
      end
   until sortiert
  end;

 procedure TWeltraum.Spielende;
  var Minimum:Integer;
      Zeile:String;
  begin
   EditSN.Enabled:=True;EditSN.TabStop:=True;
   SpinEditLevel.Enabled:=True;SpinEditLevel.TabStop:=True;
   RaumAnzeige.Enabled:=True;RaumAnzeige.TabStop:=True;
   SterneBewegen:=False;
   TimerBonus.Enabled:=False;Screen.Cursor:=crDefault;
   if Sound.Checked then sndplaysound('Ende.wav',snd_async);
   Zeile:=Liste[Liste.Count-1];
   Minimum:=StrToInt(copy(Zeile,1,Pos(' ',Zeile)-1));
   if Minimum<Punkte then // Punkte sind IMMER 4-stellig
    begin
     Liste.Add(IntToStr(Punkte)+' - '+Format('%20s',[EditSN.Text]));
     Sortieren(Liste);
     Liste.Delete(Liste.Count-1);
     ListeZeigen
    end;
   LevelNr:=SpinEditLevel.Value; 
   LevelErzeugen(LevelNr);
   RaumAnzeige.Repaint;
  end;

 procedure TWeltraum.FormKeyDown(Sender:TObject;var Key:Word;Shift:TShiftState);
  var x,y:Integer;
  begin
   if RaumAnzeige.Enabled then exit;
   if not(Key in[VK_Escape,VK_Left,VK_Up,VK_Right,VK_Down]) then exit; // falsche Taste
   if Key=VK_Escape then
    begin
     if MessageDlg('Willst du wirklich aufgeben?',mtConfirmation,
                   [mbYes,mbNo],0)=mrYes then Spielende;
     exit
    end;
   Level.Feld[Level.x,Level.y]:=0; // aktuelles Feld leeren
   if Shift=[ssShift] then  // Doppelsprung
    begin
     if Key=VK_Left  then Dec(Level.x,2);
     if Key=VK_Up    then Dec(Level.y,2);
     if Key=VK_Right then Inc(Level.x,2);
     if Key=VK_Down  then Inc(Level.y,2);
    end
   else
    begin
     if Key=VK_Left  then Dec(Level.x);
     if Key=VK_Up    then Dec(Level.y);
     if Key=VK_Right then Inc(Level.x);
     if Key=VK_Down  then Inc(Level.y);
    end;
   RaumAnzeige.Repaint;
   if (Level.Feld[Level.x,Level.y]=0) and (GeraeumteFelder+1<>AnzahlFelder) then
    begin
     Dec(Leben);Status.Panels[2].Text:='Leben '+IntToStr(Leben);
     MessageDlg('Du bist vorbeigesprungen!',mtError,[mbOk],0);
     if Sound.Checked then sndplaysound('Fehler.wav',snd_async);
     if Leben=0 then
      begin
       MessageDlg('Du hast dein Leben ausgehaucht!',mtWarning,[mbOk],0);
       Spielende;
       exit
      end;
     Bonus:=101;GeraeumteFelder:=0;
     Status.Panels[0].Text:='Bonus '+IntToStr(Bonus);
     LevelErzeugen(LevelNr); // Neubeginn des Levels
     RaumAnzeige.Repaint;
    end
   else
    begin
     Inc(Punkte,10);Inc(GeraeumteFelder);
     if Sound.Checked then sndplaysound('Stein.wav',snd_async);
     if GeraeumteFelder=AnzahlFelder then
      begin
       TimerBonus.Enabled:=False;
       MessageDlg('Du bist im nchsten Level!',mtInformation,[mbOk],0);
       Inc(Punkte,Bonus);
       Inc(Ebene);if Ebene mod 5=0 then Inc(Leben);
       Inc(LevelNr);if LevelNr=100 then LevelNr:=1;
       LevelErzeugen(LevelNr);
       if Level.x>7 then
        begin
         MessageDlg('Es gibt keinen nchsten Level!',mtError,[mbOk],0);
         LevelNr:=1;LevelErzeugen(LevelNr);
        end;
       RaumAnzeige.Enabled:=True;
       RaumAnzeige.Repaint;DrawSterne;
       RaumAnzeige.Enabled:=False;
       Bonus:=101;
       Status.Panels[0].Text:='Bonus '+IntToStr(Bonus);
       Status.Panels[2].Text:='Leben '+IntToStr(Leben);
       Status.Panels[3].Text:='Level '+IntToStr(LevelNr);
       AnzahlFelder:=0;GeraeumteFelder:=0;
       For x := 0 to 7 do
        For y := 0 to 7 do
         if Level.Feld[x,y]>0 then Inc(AnzahlFelder);
       TimerBonus.Enabled:=True;
      end;
     Status.Panels[1].Text:='Punkte '+IntToStr(Punkte);
    end
  end;

 procedure TWeltraum.DrawSterne;
  var K,X,Y:Integer;
  begin
   for K:=1 to AnzahlSterne do
    begin
     repeat
      X:=random(RaumAnzeige.Width);
      Y:=random(RaumAnzeige.Height);
     until RaumAnzeige.Canvas.Pixels[X,Y]=clBlack;
     Sterne[K].X:=X;Sterne[K].Y:=Y;
     RaumAnzeige.Canvas.Pixels[X,Y]:=Farben[random(FMax)+1]
    end
  end;

 procedure TWeltraum.SterneFlimmern;
  var N:Integer;
  begin
   N:=random(AnzahlSterne)+1;
   RaumAnzeige.Canvas.Pixels[Sterne[N].X,Sterne[N].Y]:=Farben[random(FMax)+1];
  end;

 procedure TWeltraum.SterneErneuern;
  var K:Integer;
  begin
   for K:=1 to AnzahlSterne do
    RaumAnzeige.Canvas.Pixels[Sterne[K].X,Sterne[K].Y]:=Farben[random(FMax)+1]
  end;

 procedure TWeltraum.StartClick(Sender: TObject);
  var x,y:Integer;
  begin
   if BildDaten.Kennung='keine' then
    begin
     MessageDlg('Es sind keine Level vorhanden!',mtError,[mbOk],0);
     exit
    end;
   if Sound.Checked then sndplaysound('Start.wav',snd_async);
   EditSN.Enabled:=False;EditSN.TabStop:=False;
   SpinEditLevel.Enabled:=False;SpinEditLevel.TabStop:=False;
   RaumAnzeige.Enabled:=False;RaumAnzeige.TabStop:=False;
   TimerBonus.Enabled:=True;Screen.Cursor:=crNone;
   LevelNr:=SpinEditLevel.Value;
   LevelErzeugen(LevelNr);
   if Level.x>7 then
    begin
     MessageDlg('Diesen Level gibt es nicht!',mtError,[mbOk],0);
     LevelNr:=1;LevelErzeugen(LevelNr);
    end;
   DrawSterne;RaumAnzeige.Repaint;
   SterneBewegen:=True;
   Punkte:=0;Bonus:=101;Leben:=3;
   Status.Panels[0].Text:='Bonus '+IntToStr(Bonus);
   Status.Panels[1].Text:='Punkte '+IntToStr(Punkte);
   Status.Panels[2].Text:='Leben '+IntToStr(Leben);
   Status.Panels[3].Text:='Level '+IntToStr(LevelNr);
   Ebene:=0;AnzahlFelder:=0;GeraeumteFelder:=0;
   For x := 0 to 7 do
    For y := 0 to 7 do
     if Level.Feld[x,y]>0 then Inc(AnzahlFelder);
  end;

 procedure TWeltraum.SpinEditLevelChange(Sender: TObject);
  var LevelNrAlt:Integer;
  begin
   if SpinEditLevel.Text='' then SpinEditLevel.Value:=1;
   LevelNrAlt:=LevelNr;LevelNr:=SpinEditLevel.Value;
   LevelErzeugen(LevelNr);RaumAnzeige.Repaint;
   if Level.x>7 then
    begin
     MessageDlg('Es gibt keinen weiteren Level!',mtError,[mbOk],0);
     LevelNr:=LevelNrAlt;
     SpinEditLevel.Value:=LevelNr;
     LevelErzeugen(LevelNr);RaumAnzeige.Repaint;
    end;
  end;

 procedure TWeltraum.TimerSterneTimer(Sender: TObject);
  begin
   if SterneBewegen then SterneFlimmern
  end;

 procedure TWeltraum.TimerBonusTimer(Sender: TObject);
  begin
   if TimerBonus.Enabled and (Bonus>0) then
    begin dec(Bonus);Status.Panels[0].Text:='Bonus '+IntToStr(Bonus);end;
  end;

 procedure TWeltraum.AbbruchClick(Sender: TObject);
  begin
   if RaumAnzeige.Enabled then exit;
   if MessageDlg('Willst du wirklich aufgeben?',mtConfirmation,
                 [mbYes,mbNo],0)=mrYes then Spielende;
  end;

 procedure TWeltraum.SoundClick(Sender: TObject);
  begin
   Sound.Checked:=not Sound.Checked;
  end;

 procedure TWeltraum.LeveldateiClick(Sender: TObject);
  const LevelKennung:String[13]='Weltraumspiel';
  var BildDatei:File of DatenArray;
  begin
   with DateiLesen do
    begin
     Filter:='Weltraumdateien (*.lev) |*.lev';
     DefaultExt:='lev';
     if Execute then
      begin
       AssignFile(BildDatei,FileName);{$I-}Reset(BildDatei);{$I+}
       IF IOResult<>0 THEN
        BEGIN
         MessageDlg('Fehler bei Dateizugriff', mtWarning, [mbOk], 0);
         MessageDlg(FileName+' kann ich nicht ffnen!',mtError,[mbOk],0);
         Exit;
        END;
       {$I-} IF FileSize(BildDatei)=1 THEN Read(BildDatei,BildDaten);{$I+}
       IF (BildDaten.Kennung<>LevelKennung) OR (IOResult<>0) THEN
        BEGIN
         MessageDlg(FileName+' ist keine Leveldatei fr Weltraumspiel!',mtError,[mbOk],0);
         MessageDlg('Das Programm wird beendet...',mtConfirmation,[mbOk],0);
         Halt;
        END;
       CloseFile(BildDatei);
       LevelNr:=1;LevelErzeugen(LevelNr);RaumAnzeige.Repaint;
       SpinEditLevel.Value:=LevelNr;
       if Level.x>7 then
        begin
         MessageDlg('Es gibt keine Level!',mtError,[mbOk],0);
         exit;
        end;
       SterneBewegen:=False;
      end
    end
  end;

 procedure TWeltraum.InfoClick(Sender: TObject);
  var Info:TInfoBox;
  begin
   Info:=TInfoBox.Create(Weltraum);
   Info.ShowModal;
   Info.Free;
  end;

 procedure TWeltraum.AboutClick(Sender: TObject);
  var Regeln:TRegelnBox;
  begin
   Regeln:=TRegelnBox.Create(Weltraum);
   RegelnBox.ShowModal;
   Regeln.Free;
  end;

 procedure TWeltraum.EditorClick(Sender: TObject);
  var Zahl:String;
  begin
   PasswordDlg.Caption:='Paworteingabe';
   PasswordDlg.LabelPasswort.Caption:='Gib deine Codezahl ein!';
   PasswordDlg.Passwort.PasswordChar:='?';
   PasswordDlg.Passwort.Text:='';
   PasswordDlg.ShowModal;
   Zahl:=PasswordDlg.Passwort.Text;
   if Zahl=Geheim then LevelEditor.ShowModal
   else MessageDlg('Betrger!',mtError,[mbOk],0);
  end;

end.

